2016-03-11  TJ Saunders <tj@castaglia.org>

	* RELEASE_NOTES: Updated release notes to mention DH selection
	issue.

2016-03-10  TJ Saunders <tj@castaglia.org>

	* README.md: Update link to shields.io badge for latest release.

2016-03-10  TJ Saunders <tj@castaglia.org>

	* README.md, contrib/dist/rpm/proftpd.spec, include/version.h: 
	Updating files for 1.3.6rc3 development.

2016-03-10  TJ Saunders <tj@castaglia.org>

	* NEWS: Update NEWS with release date.

2016-03-10  TJ Saunders <tj@castaglia.org>

	* include/version.h: Preparing for RC2 release.

2016-03-10  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/rfc4716.c,
	tests/t/etc/modules/mod_sftp/authorized_rsa_keys_no_nl,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Reproduce, and fix,
	the case where mod_sftp does not handle public key files which do
	not end in a newline.

2016-03-10  TJ Saunders <tj@castaglia.org>

	* NEWS: Update NEWS with fix for Bug#4230.

2016-03-10  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #226 from proftpd/tls-dhparam-ignored-bug4230 Bug#4230: TLSDHParamFile directive appears ignored because
	unexpected…

2016-03-10  TJ Saunders <tj@castaglia.org>

	* modules/mod_core.c,
	tests/t/lib/ProFTPD/Tests/Config/DisplayQuit.pm: If DisplayQuit is
	configured with a non-path, make sure we handle it properly.

2016-03-10  TJ Saunders <tj@castaglia.org>

	* modules/mod_xfer.c,
	tests/t/lib/ProFTPD/Tests/Config/DisplayFileTransfer.pm: If the
	configured DisplayFileTransfer file is not able to be handled
	successfully, don't penalize/close the data transfer connection for
	it.

2016-03-10  TJ Saunders <tj@castaglia.org>

	* contrib/mod_wrap.c: Sigh.  Declared right variable in wrong
	location.  Trying again.

2016-03-10  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #228 from proftpd/json-no-stdbool-dependency Remove the JSON implementation's dependence on stdbool.h, on the
	assu…

2016-03-10  TJ Saunders <tj@castaglia.org>

	* doc/modules/mod_core.html: Fix the documented default
	TimeoutLinger value.

2016-03-10  TJ Saunders <tj@castaglia.org>

	* contrib/mod_wrap.c: Address compiler warnings.

2016-03-10  TJ Saunders <tj@castaglia.org>

	* modules/mod_facl.c: Make sure the module-unload event listener is
	conditionally compiled with the same conditions as its usage.

2016-03-09  TJ Saunders <tj@castaglia.org>

	* : commit f9e85236e76703303ecad3c16951ac623ec34e5a Author: TJ
	Saunders <tj@castaglia.org> Date:   Wed Mar 9 16:10:11 2016 -0800

2016-03-09  TJ Saunders <tj@castaglia.org>

	* src/netacl.c, tests/api/netacl.c: Adding tests showing that we
	properly handle "0.0.0.0/0" as a netacl expression.

2016-03-08  TJ Saunders <tj@castaglia.org>

	* : commit 35455b027ba9a315109035e117bd4890781ee489 Merge: 57ef0cd
	d49387e Author: TJ Saunders <tj@castaglia.org> Date:   Tue Mar 8
	23:04:55 2016 -0800

2016-03-08  TJ Saunders <tj@castaglia.org>

	* include/netacl.h, src/netacl.c, tests/api/netacl.c: Provide a
	pr_netacl_get_str2() function for getting string versions of ACLs
	without the added description that pr_netacl_get_str() adds.

2016-03-08  TJ Saunders <tj@castaglia.org>

	* RELEASE_NOTES: Fleshing out the release notes, as we're getting
	very close to release.

2016-03-08  TJ Saunders <tj@castaglia.org>

	* doc/modules/mod_log.html: Add docs for the added %{file-size} and
	%{transfer-type} LogFormat variables.

2016-03-08  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls.c: Bug#4230: TLSDHParamFile directive appears
	ignored because unexpected DH is chosen.

2016-03-04  TJ Saunders <tj@castaglia.org>

	* doc/contrib/mod_auth_otp.html: Minor updates/fixes to the
	mod_auth_otp docs.

2016-03-04  TJ Saunders <tj@castaglia.org>

	* doc/contrib/mod_auth_otp.html: Add required OpenSSL attributions.

2016-03-04  TJ Saunders <tj@castaglia.org>

	* include/ccan-json.h, lib/ccan-json.c: Attempt to fix/address
	compiler errors on different platforms (e.g. HP-UX) by not reusing
	the same name for a struct and its typedef.  Also avoid
	re-typedef'ing uchar_t.

2016-03-04  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c, contrib/mod_sftp/scp.c: Clear the internal
	statcache in a few more places when handling SFTP, SCP.

2016-03-04  TJ Saunders <tj@castaglia.org>

	* modules/mod_core.c, modules/mod_site.c, modules/mod_xfer.c: More
	places where the internal cache should be cleared first.

2016-03-04  TJ Saunders <tj@castaglia.org>

	* modules/mod_core.c: Another place where we need to clear the
	internal statcache.

2016-02-29  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #223 from proftpd/core-str-hex2bin Add symmetric String API function for converting from hex string to
	b…

2016-02-25  TJ Saunders <tj@castaglia.org>

	* modules/mod_ctrls.c: If there are issues creating the
	ControlsSocket, log them at the NOTICE level, rather than in a
	ControlsLog (which not be opened anyway).

2016-02-25  TJ Saunders <tj@castaglia.org>

	* contrib/mod_statcache.c, src/fsio.c: When the pr_fs_clear_cache2()
	function is used to clear the statcache, generate an event for any
	OTHER modules which might also be doing caching (e.g.
	mod_statcache), so that they too can clear their cached stat data.

2016-02-25  TJ Saunders <tj@castaglia.org>

	* contrib/mod_statcache.c: Make mod_statcache less intrusive when it
	encounters an error when handling an FSIO callback; just return the
	underlying OS call return value.

2016-02-25  TJ Saunders <tj@castaglia.org>

	* contrib/mod_statcache.c: The FSIO open(2) callback in
	mod_statcache was only clearing the cached value IFF open(2)
	returned zero.  But open(2) returns zero OR GREATER on success.
	Oops.

2016-02-25  TJ Saunders <tj@castaglia.org>

	* src/fsio.c: Cache the close(2) errno value, to avoid it being
	changed by later code in pr_fsio_close().

2016-02-25  TJ Saunders <tj@castaglia.org>

	* doc/contrib/mod_unique_id.html: Fix HTML markup.

2016-02-25  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c: Add a fake 451 response code for aborted
	SFTP file transfers.

2016-02-23  TJ Saunders <tj@castaglia.org>

	* contrib/mod_statcache.c: Automatically disable negative caching
	for SSH2 sessions.

2016-02-23  TJ Saunders <tj@castaglia.org>

	* NEWS: Add mention of fix for Bug#4227.

2016-02-23  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #220 from proftpd/sftp-multi-init-bug4227 Bug#4227: Support SFTP clients that send multiple INIT requests.

2016-02-22  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c: Only increment the bytes transferred
	values, when handling an SFTP WRITE request, once the bytes have
	been successfully written, per write(2) result.

2016-02-22  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #219 from proftpd/sftp-no-stat-on-read Attempt to mitigate the issue with mod_statcache's stat() causing
	SFT…

2016-02-22  TJ Saunders <tj@castaglia.org>

	* contrib/mod_statcache.c: Improve mod_statcache trace logging, to
	better differentiate among locking-related log messages.

2016-02-21  TJ Saunders <tj@castaglia.org>

	* RELEASE_NOTES, contrib/mod_tls.c, doc/contrib/mod_tls.html: Use a
	directive name of TLSServerInfoFile, for consistency with other
	mod_tls directives.

2016-02-20  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #217 from proftpd/tls-serverinfo Add TLSServerInfo directive, for TLS ServerHello extensions

2016-02-20  TJ Saunders <tj@castaglia.org>

	* RELEASE_NOTES, contrib/mod_tls.c, doc/contrib/mod_tls.html: 
	Implement a TLSServerInfo directive, for configuring custom TLS
	extension data (e.g. for SCT data).

2016-02-17  TJ Saunders <tj@castaglia.org>

	* contrib/mod_exec.c, contrib/mod_sftp/keys.c, contrib/mod_tls.c,
	modules/mod_rlimit.c, src/rlimit.c: Don't log spurious log messages
	if getrlimit(2) fails with ENOSYS/EPERM.

2016-02-16  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/blacklist.c: Quell Coverity warning by setting an
	upper bound on the number of records we are willing to scan/process
	from the blacklist.dat file.

2016-02-16  TJ Saunders <tj@castaglia.org>

	* lib/libltdl/ltdl.c: Quell Coverity warning about possible resource
	leak in libltdl.

2016-02-12  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/keys.c, contrib/mod_tls.c: Ensure proper
	NUL-termination of buffers in all cases.  Should make Coverity
	happier.

2016-02-12  TJ Saunders <tj@castaglia.org>

	* contrib/mod_auth_otp/base32.c: Use signed data types, to prevent
	underflow and bad shift operations.  Found by Coverity.

2016-02-12  TJ Saunders <tj@castaglia.org>

	* contrib/mod_statcache.c: Add check for return value, per Coverity.

2016-02-12  TJ Saunders <tj@castaglia.org>

	* contrib/mod_auth_otp/mod_auth_otp.c: Fix issue discovered by
	Coverity.

2016-02-12  TJ Saunders <tj@castaglia.org>

	* contrib/mod_digest.c: Fix issue detected by Coverity.

2016-02-12  TJ Saunders <tj@castaglia.org>

	* doc/contrib/mod_auth_otp.html, doc/contrib/mod_digest.html,
	doc/contrib/mod_statcache.html: Update docs of new modules to
	mention where their source code is.

2016-02-12  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #214 from proftpd/contrib-statcache Adding mod_statcache to the contrib/ directory.

2016-02-12  TJ Saunders <tj@castaglia.org>

	* .gitignore, .travis.yml, contrib/mod_auth_otp/mod_auth_otp.c: 
	Address build warnings, tweak the travis-ci setup.

2016-02-12  TJ Saunders <tj@castaglia.org>

	* contrib/mod_auth_otp/Makefile.in: Trying some reordering, when
	building mod_auth_otp as a DSO module.

2016-02-12  TJ Saunders <tj@castaglia.org>

	* contrib/mod_digest.c: Fix building of mod_digest as a shared
	module.

2016-02-11  TJ Saunders <tj@castaglia.org>

	* contrib/mod_auth_otp/Makefile.in: Back to the original.  Probably
	won't work.

2016-02-11  TJ Saunders <tj@castaglia.org>

	* contrib/mod_auth_otp/Makefile.in: Still correcting paths.  Sigh.

2016-02-11  TJ Saunders <tj@castaglia.org>

	* contrib/mod_auth_otp/Makefile.in,
	contrib/mod_auth_otp/mod_auth_otp.c: Still trying to get the
	travis-ci builds passing.

2016-02-11  TJ Saunders <tj@castaglia.org>

	* contrib/mod_auth_otp/Makefile.in: Tweak, tweak.

2016-02-11  TJ Saunders <tj@castaglia.org>

	* contrib/mod_auth_otp/Makefile.in: Still working on fixing the
	travis-ci build.

2016-02-11  TJ Saunders <tj@castaglia.org>

	* contrib/mod_auth_otp/t/Makefile.in,
	contrib/mod_auth_otp/t/api/base32.c,
	contrib/mod_auth_otp/t/api/otp.c,
	contrib/mod_auth_otp/t/api/stubs.c,
	contrib/mod_auth_otp/t/api/tests.c,
	contrib/mod_auth_otp/t/api/tests.h: Add missing API tests for
	mod_auth_otp, breaking the travis-ci build.

2016-02-11  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Add mod_auth_otp, mod_digest to the travis-ci builds.

2016-02-11  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #213 from proftpd/contrib-auth-otp Adding mod_auth_otp to the contrib/ modules directory.

2016-02-11  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #212 from proftpd/contrib-digest Adding mod_digest module to contrib modules.

2016-02-01  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sql.c: Log a warning about using the Plaintext
	SQLAuthType; it's a bad security policy, as it allows storing
	passwords IN THE CLEAR in the database.

2016-02-01  TJ Saunders <tj@castaglia.org>

	* RELEASE_NOTES, contrib/mod_sql.c, include/mod_log.h,
	modules/mod_log.c, tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm: 
	Add a %{transfer-type} LogFormat variable; this is just one more
	variable needed to make an ExtendedLog that contains the same
	information as the fixed-format TransferLog.

2016-02-01  TJ Saunders <tj@castaglia.org>

	* contrib/mod_wrap.c, modules/mod_core.c: Update mod_wrap to
	properly handle a HOST command.

2016-02-01  TJ Saunders <tj@castaglia.org>

	* contrib/mod_quotatab.c, modules/mod_core.c: Update mod_quotatab to
	Do The Right Thing(tm) in the face of HOST commands.

2016-02-01  TJ Saunders <tj@castaglia.org>

	* contrib/mod_wrap2/mod_wrap2.c, modules/mod_core.c: Update
	mod_wrap2 to properly handle HOST commands.

2016-02-01  TJ Saunders <tj@castaglia.org>

	* contrib/mod_radius.c, contrib/mod_rewrite.c, modules/mod_core.c: 
	Update the mod_radius and mod_rewrite modules to properly
	respond/handle HOST commands.

2016-01-31  TJ Saunders <tj@castaglia.org>

	* contrib/mod_ldap.c, modules/mod_core.c: Make mod_ldap be
	HOST-aware, and reset its settings as necessary.

2016-01-31  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sql_passwd.c, modules/mod_core.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sql_passwd.pm: Make sure that
	mod_sql_passwd works properly with respect to HOST commands.

2016-01-31  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sql.c: Update mod_sql so that it Does The Right
	Thing(tm) for HOST commands.

2016-01-31  TJ Saunders <tj@castaglia.org>

	* src/auth.c: Correct grammar in a trace log message; no functional
	change.

2016-01-31  TJ Saunders <tj@castaglia.org>

	* modules/mod_core.c: Update the list of modules needing HOST
	handling work.

2016-01-31  TJ Saunders <tj@castaglia.org>

	* modules/mod_auth.c: Remove now-obsolete POST_CMD HOST handler; it
	was replaced by the 'core.session-reinit' event listener.

2016-01-31  TJ Saunders <tj@castaglia.org>

	* modules/mod_auth.c,
	tests/t/lib/ProFTPD/Tests/Config/AnonAllowRobots.pm: Fix edge case
	with implementation of Bug#4224, where we do NOT want any automatic
	handling of "robots.txt" for non-anonymous logins.

2016-01-31  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #210 from
	proftpd/auth-anon-allow-robots-bug4224 Bug#4224: Prohibit FTP indexing by web crawlers via auto-generated
	ro…

2016-01-30  TJ Saunders <tj@castaglia.org>

	* locale/files.txt: Updated files.txt.

2016-01-30  TJ Saunders <tj@castaglia.org>

	* doc/contrib/mod_quotatab.html: Fix markup.

2016-01-29  TJ Saunders <tj@castaglia.org>

	* NEWS, RELEASE_NOTES, doc/modules/mod_auth.html,
	modules/mod_auth.c, tests/t/config/anonallowrobots.t,
	tests/t/lib/ProFTPD/Tests/Config/AnonAllowRobots.pm: Bug#4224:
	Prohibit FTP indexing by web crawlers via auto-generated robots.txt.

2016-01-29  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls.c: Properly shut down the TLS session on data
	connections as well.

2016-01-28  TJ Saunders <tj@castaglia.org>

	* doc/rfc/rfc7151.txt: Adding RFC 7151 to our RFCs area, since we
	now implement the HOST command.

2016-01-28  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #209 from proftpd/exists2 Restore backward compatibility

2016-01-28  TJ Saunders <tj@castaglia.org>

	* contrib/mod_copy.c, contrib/mod_sftp/fxp.c,
	contrib/mod_sftp/mod_sftp.c, contrib/mod_sftp/scp.c,
	contrib/mod_sql.c, contrib/mod_tls.c, include/support.h,
	modules/mod_core.c, modules/mod_ls.c, modules/mod_xfer.c,
	src/support.c, tests/api/misc.c: Restore backward compatibility by
	restoring the Support API's exists/mode functions back to their
	original signatures, and provide variants, which accept a pool, for
	the chroot+symlink-aware functionality.

2016-01-28  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #208 from proftpd/extlog-file-size-var-redux Use POST_CMD handlers for stashing the 'mod_xfer.file-size' note, so
	…

2016-01-27  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #207 from proftpd/extlog-file-size-var Add support for a %{file-size} LogFormat variable, which resolves to
	the

2016-01-27  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Config/AllowForeignAddress.pm: Add
	regression test for a site-to-site transfer of a >2GB file.

2016-01-27  TJ Saunders <tj@castaglia.org>

	* NEWS: Update NEWS for fix for Bug#4219.

2016-01-27  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #206 from
	proftpd/fsio-chrooted-readlink-bug4219 Bug#4219: Better handling of symlinks when chrooted

2016-01-27  TJ Saunders <tj@castaglia.org>

	* modules/mod_site.c, tests/t/lib/ProFTPD/Tests/Modules/mod_site.pm: 
	Added regression tests for SITE CHMOD commands and symlinks,
	chrooted and not.  All tests pass properly now.

2016-01-27  TJ Saunders <tj@castaglia.org>

	* modules/mod_site.c, tests/t/lib/ProFTPD/Tests/Modules/mod_site.pm: 
	Added regression tests for the SITE CHGRP command and symlinks,
	chrooted and not.  All tests pass now.

2016-01-27  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/scp.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Added regression
	tests for SCP downloads to symlinks, chrooted and not.  Made sure
	the tests pass as expected.

2016-01-27  TJ Saunders <tj@castaglia.org>

	* : commit 5dc63cc755fbc7fde7757812678b4d02eb54a654 Author: TJ
	Saunders <tj@castaglia.org> Date:   Wed Jan 27 11:15:37 2016 -0800

2016-01-27  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls.c: Add comment about where to find the definition
	of unknown TLS extension IDs.

2016-01-27  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sql_mysql.c: If mod_sql_mysql fails to configure the
	character set, just log the failure and do not treat it as a fatal
	error, in order to better handle situations of client/server version
	skew.

2016-01-27  TJ Saunders <tj@castaglia.org>

	* doc/howto/Logging.html: Mention that FreeBSD ftpd does NOT use the
	xferlog(5) format.

2016-01-26  TJ Saunders <tj@castaglia.org>

	* src/inet.c, src/support.c: Add Mac OSX-specific version macros for
	the newer OSX versions as needed.

2016-01-26  TJ Saunders <tj@castaglia.org>

	* : commit 662a109c354eb72b9f138e1b332ba3fd3e088b88 Author: TJ
	Saunders <tj@castaglia.org> Date:   Tue Jan 26 16:54:44 2016 -0800

2016-01-26  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Commands/STOU.pm: Add another regression
	test for Bug#4223, for the chroot case.

2016-01-26  TJ Saunders <tj@castaglia.org>

	* modules/mod_xfer.c: Style nit; no functional change.

2016-01-26  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c: Add the dir_readlink() magic to the
	check-file SFTP extension handling.

2016-01-26  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Added regression
	tests for SFTP RMDIR requests and symlinks, chrooted and not.
	Ensured that all tests pass as expected.

2016-01-26  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Added regression
	tests for SFTP OPENDIR requests and symlinks, chrooted and not.
	Made sure the tests pass as expected.

2016-01-26  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Added regression
	tests for SFTP SETSTAT requests and symlinks, chrooted and not.
	Made sure that the tests pass properly.

2016-01-26  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Added regression
	tests for the SFTP STAT requests and symlinks, chrooted and not, and
	made sure the tests pass.

2016-01-26  TJ Saunders <tj@castaglia.org>

	* : commit 9a17b90289f876339b4cf71f74329a2d5fa3c4f9 Author: TJ
	Saunders <tj@castaglia.org> Date:   Tue Jan 26 10:47:03 2016 -0800

2016-01-26  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #205 from proftpd/xfer-stou-umask-bug4223 Bug#4223: Permissions on files uploaded via STOU do not honor
	configured Umask

2016-01-26  TJ Saunders <tj@castaglia.org>

	* modules/mod_xfer.c: Bug#4223: Permissions on files uploaded via
	STOU do not honor configured Umask.

2016-01-25  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Added regression
	tests for the SFTP OPEN requests and symlinks, chrooted and not.

2016-01-25  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Added regression
	tests for SFTP MKDIR requests and symlinks, chrooted and not.

2016-01-25  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Commands/RNTO.pm: Added regression tests
	for the RNTO command, and symlinks.

2016-01-25  TJ Saunders <tj@castaglia.org>

	* modules/mod_core.c, tests/t/lib/ProFTPD/Tests/Commands/RNFR.pm: 
	Adding regression tests for the RNFR command and symlinks, chrooted
	and not.

2016-01-24  TJ Saunders <tj@castaglia.org>

	* : commit f8eded5488c03a40a02dbdb4056d6222e0a045a3 Author: TJ
	Saunders <tj@castaglia.org> Date:   Sun Jan 24 20:24:44 2016 -0800

2016-01-24  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #204 from proftpd/default-transfer-mode Move the processing of the DefaultTransferMode directive from
	mod_aut…

2016-01-24  TJ Saunders <tj@kiban.io>

	* modules/mod_auth.c, modules/mod_core.c: Move the processing of the
	DefaultTransferMode directive from mod_auth to mod_core.  The
	directive handler is in mod_core, and the processing is more
	properly done as a post-PASS step.

2016-01-24  TJ Saunders <tj@castaglia.org>

	* modules/mod_core.c, modules/mod_xfer.c,
	tests/t/lib/ProFTPD/Tests/Commands/RMD.pm: Added regression tests
	for RMD and symlinks, and made sure that symlinks could be handled
	properly when chrooted.

2016-01-24  TJ Saunders <tj@castaglia.org>

	* modules/mod_xfer.c, tests/t/lib/ProFTPD/Tests/Commands/RETR.pm: 
	Added regression tests for RETR and symlinks, and updated the RETR
	handling to use dir_readlink(), so that symlinks can be retrieved
	when chrooted.

2016-01-24  TJ Saunders <tj@castaglia.org>

	* modules/mod_core.c, tests/t/lib/ProFTPD/Tests/Commands/CWD.pm: 
	Added regression tests for the CWD and symlinks, and made sure that
	CWD does The Right Thing(tm) with symlinks, chrooted and not.

2016-01-22  TJ Saunders <tj@castaglia.org>

	* : commit e09990a3840ddca4413160c86ab0eff403c3a698 Author: TJ
	Saunders <tj@castaglia.org> Date:   Fri Jan 22 16:09:02 2016 -0800

2016-01-22  TJ Saunders <tj@castaglia.org>

	* src/fsio.c: Fix log messages to be grammatically correct.

2016-01-22  TJ Saunders <tj@kiban.io>

	* src/str.c, tests/api/str.c: For better logging/debugging, have the
	{uid,gid}2str() functions return "-1" for cases where the
	uid_t/gid_t have that value, as they are used as sentinel values in
	the core code.

2016-01-22  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Commands/MKD.pm: Updated MKD regression
	tests to use test_setup()/test_cleanup(), in preparation to adding
	more symlink-related regression tests.

2016-01-22  TJ Saunders <tj@castaglia.org>

	* modules/mod_core.c, tests/t/lib/ProFTPD/Tests/Commands/MDTM.pm: 
	Update the handling of the MDTM command for chrooted symlinks, with
	accompanying regression tests.

2016-01-22  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Commands/MDTM.pm: First, update the MDTM
	regression tests to use test_setup() and test_cleanup().  Next, I'll
	add regression tests for MDTM on symlinks (to files and
	directories).

2016-01-22  TJ Saunders <tj@castaglia.org>

	* contrib/mod_copy.c: Found another place needing updating for the
	change of exists() signature.

2016-01-22  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sql.c, contrib/mod_tls.c: Updated some contrib
	modules, due to changes in the Support API signatures.

2016-01-22  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Commands/APPE.pm: Make sure that the
	destination path correctly lines up with the (adjusted) chroot on
	MacOSX.

2016-01-22  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c, contrib/mod_sftp/mod_sftp.c,
	contrib/mod_sftp/scp.c, include/support.h, modules/mod_core.c,
	modules/mod_ls.c, modules/mod_xfer.c, src/support.c,
	tests/api/misc.c, tests/t/lib/ProFTPD/Tests/Commands/APPE.pm: Added
	more regression tests for the APPE command, for absolute destination
	path symlinks and chroots, which required some refactoring of the
	core library.

2016-01-22  TJ Saunders <tj@castaglia.org>

	* doc/howto/ListOptions.html, doc/modules/mod_facts.html,
	doc/modules/mod_ls.html: Update docs to mention new
	'NoAdjustedSymlinks' options for mod_facts, mod_ls.

2016-01-22  TJ Saunders <tj@kiban.io>

	* doc/howto/CreateHome.html: Updated links to the main docs for the
	CreateHome directive.

2016-01-21  TJ Saunders <tj@kiban.io>

	* contrib/mod_sftp_pam.c: Now the mod_sftp_pam module will check for
	the AuthPAM directive, in addition to SFTPPAMEngine, to better work,
	as expected, with existing proftpd configurations that use AuthPAM.  See:
	http://serverfault.com/questions/386294/proftpd-with-sftp-first-login-fails-seconds-succeeds

2016-01-21  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Commands/DELE.pm: Modernized some of the
	DELE regression tests in preparation, but then realized that DELE's
	handling of symlinks just does The Right Thing(tm), regardless of
	chroots.

2016-01-21  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Commands/APPE.pm: Adding APPE regression
	tests for symlinks, chrooted and not.

2016-01-21  TJ Saunders <tj@castaglia.org>

	* modules/mod_xfer.c: Rename a variable to be more consistent with
	usage elsewhere, i.e. using 'xerrno' as the errno holder, not
	'ferrno'.

2016-01-21  TJ Saunders <tj@kiban.io>

	* include/ftp.h: Remove redundant redefinition of the C_HOST macro.

2016-01-21  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Commands/LIST.pm: Adding regression
	tests for the LIST command, with regard to symlinks, ShowSymlinks,
	and chroots.

2016-01-21  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Commands/NLST.pm: Added NLST regression
	tests for symlinks, and symlinks when chrooted.

2016-01-20  TJ Saunders <tj@castaglia.org>

	* src/support.c, tests/api/misc.c: Clean up the returned destination
	paths, even when not chrooted.

2016-01-20  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Commands/STAT.pm: Updated the STAT
	regression tests, and added missing tests for symlinks, both when
	chrooted and not.

2016-01-20  TJ Saunders <tj@castaglia.org>

	* tests/api/misc.c: Fix the broken unit tests.

2016-01-20  TJ Saunders <tj@castaglia.org>

	* modules/mod_facts.c, src/support.c, tests/api/misc.c,
	tests/t/lib/ProFTPD/Tests/Commands/MLSD.pm,
	tests/t/lib/ProFTPD/Tests/Commands/MLST.pm: Update mod_facts to use
	dir_readlink() for MLST/MLSD commands.  Turns out that this fixes an
	already-existing bug, where symlinks were not being handled well
	when the session is chrooted anyway.

2016-01-20  TJ Saunders <tj@castaglia.org>

	* src/fsio.c: Remove some distracting FSIO statcache trace logging
	by explicitly setting errno to zero for success cases.

2016-01-20  TJ Saunders <tj@castaglia.org>

	* src/dirtree.c: Move some noisy AllowOverride logging to trace
	logging, from debug logging.

2016-01-19  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Update mod_sftp's
	handling of the READLINK request to use the new chroot-aware
	dir_readlink() function.

2016-01-19  TJ Saunders <tj@castaglia.org>

	* : commit 632cc9dd493e263f66fb42dd54809cb3f671b17b Merge: d55f831
	5fd7508 Author: TJ Saunders <tj@castaglia.org> Date:   Tue Jan 19
	09:56:04 2016 -0800

2016-01-19  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sql.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm: Make sure that
	mod_sql can also handle the new %R, %{transfer-millisecs} variables
	from Bug#4218.

2016-01-19  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #202 from proftpd/privs-coverage Increase test coverage of the Privs API.

2016-01-19  TJ Saunders <tj@castaglia.org>

	* include/privs.h, src/privs.c, tests/api/privs.c: Attempt to
	increase test coverage of the Privs API by providing a function for
	setting the "am I running as nonroot?" flag, to be used by unit
	tests.

2016-01-19  TJ Saunders <tj@castaglia.org>

	* include/support.h, src/support.c, tests/api/misc.c: Provide flags,
	for handling relative destination symlink paths (or not).  Update
	the unit tests to cover the new branches.

2016-01-18  TJ Saunders <tj@castaglia.org>

	* src/support.c, tests/api/misc.c: If dir_readlink() reads in a
	relative path, and that path falls within the chroot, try to
	emit/provide a relative path as output, in order to preserve the
	principle of least surprise.

2016-01-18  TJ Saunders <tj@castaglia.org>

	* include/support.h, src/support.c, tests/api/misc.c: First part of
	Bug#4219: provide a support function which wraps pr_fsio_readlink(),
	and does the chroot checking/adaptation.

2016-01-18  TJ Saunders <tj@castaglia.org>

	* src/fsio.c: Handle the edge case where a custom FSIO object does
	not provide a readlink implementation, and that callback is thus
	NULL.

2016-01-18  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_snmp.pm: Update the mod_snmp
	tests to pass properly, when more contrib modules (e.g.  mod_tls,
	mod_sftp, mod_ban) are present.

2016-01-18  TJ Saunders <tj@castaglia.org>

	* contrib/mod_snmp/mod_snmp.c: Remove some logically unneeded code,
	per Coverity.

2016-01-18  TJ Saunders <tj@castaglia.org>

	* contrib/mod_snmp/PROFTPD-MIB.txt: Remove CVS tag, now that we're
	in Git.

2016-01-18  TJ Saunders <tj@castaglia.org>

	* .gitignore: Ignore the Coverity cov-int directory, too.

2016-01-18  TJ Saunders <tj@castaglia.org>

	* modules/mod_ctrls.c: Avoid unnecessary (and redundant) null check,
	per Coverity.

2016-01-18  TJ Saunders <tj@castaglia.org>

	* src/dirtree.c: Catch/handle a possible null pointer dereference,
	per Coverity.

2016-01-18  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sql_passwd.c: Pedantically check for possible null
	values, per Coverity.

2016-01-18  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls_fscache.c: Implement permission checks on the
	directory for caching OCSP responses, and avoid world-writable
	directories.

2016-01-18  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls_fscache.c: Be a little more strict when checking
	permissions for cached OCSP responses, by calling open(2) on the
	path, then using fstat(2), rather than just using lstat(2).  This
	should make Coverity happier.  Hopefully.

2016-01-17  TJ Saunders <tj@castaglia.org>

	* NEWS, RELEASE_NOTES: Updates NEWS, release notes with mention of
	Bug#4218.

2016-01-17  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #201 from
	proftpd/extlog-response-transfer-millisecs-bug4218 Bug#4218: Support a LogFormat variable for logging command duration
	in milliseconds

2016-01-17  TJ Saunders <tj@castaglia.org>

	* doc/modules/mod_log.html, include/mod_log.h, modules/mod_log.c,
	tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm: Implement the
	%{transfer-millisecs} LogFormat variable, with regression test.  In
	doing so, the implementation of the %T LogFormat variable was made
	much simpler.

2016-01-17  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm: First step: add
	missing regression test for the %T LogFormat variable, to be used as
	a template for the next part.

2016-01-17  TJ Saunders <tj@castaglia.org>

	* tests/api/misc.c: Now we're playing with platform-specific
	behaviors.  Whee!

2016-01-17  TJ Saunders <tj@castaglia.org>

	* tests/api/str.c: Quell compiler warning about mismatched types.

2016-01-17  TJ Saunders <tj@kiban.io>

	* include/support.h, modules/mod_ls.c, src/support.c,
	tests/api/misc.c: Still working out the kinks with the rewritten
	get_name_max().

2016-01-17  TJ Saunders <tj@castaglia.org>

	* tests/api/misc.c: The rewriting of get_name_max() changed the test
	expectations.

2016-01-17  TJ Saunders <tj@castaglia.org>

	* src/support.c: Rewrite the get_name_max() function to be more
	legible, and avoid (hopefully) the rats' nest of ifdefs.

2016-01-17  TJ Saunders <tj@castaglia.org>

	* src/netio.c: At least check if our stashing of the NetIO in the
	notes fails, per Coverity.

2016-01-17  TJ Saunders <tj@castaglia.org>

	* modules/mod_ls.c: Avoid memory leak under error conditions; found
	by Coverity.

2016-01-17  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls.c: Avoid memory leak in edge case scenario; found
	by Coverity.

2016-01-17  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls.c: Avoid an unneeded loop, which avoids logically
	dead code.  Found by Coverity.

2016-01-17  TJ Saunders <tj@castaglia.org>

	* modules/mod_dso.c: Avoid checking a pointer that we already know
	to be null (due to earlier checks), per Coverity.

2016-01-17  TJ Saunders <tj@castaglia.org>

	* src/log.c: Be more paranoid about checking for null pointers, per
	Coverity.

2016-01-17  TJ Saunders <tj@castaglia.org>

	* contrib/mod_exec.c: It's possible for exec_subst_var() to be
	called with a null cmd_rec, thus we need to guard against such
	conditions.  Found by Coverity.

2016-01-17  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c: Remove unused code, detected by Coverity.

2016-01-17  TJ Saunders <tj@castaglia.org>

	* contrib/coverity/modeling.c: Update the Coverity modeling file, to
	squelch known false positives.

2016-01-17  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls_fscache.c: Avoid passing a known null pointer, per
	Coverity.

2016-01-17  TJ Saunders <tj@castaglia.org>

	* src/support.c: If pr_localtime() returns NULL, just bail, rather
	than trying to skirt around the issue.  Found by Coverity.

2016-01-17  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/interop.c: Avoid a possible null dereference,
	found by Coverity.

2016-01-17  TJ Saunders <tj@castaglia.org>

	* utils/ftpcount.c, utils/ftpscrub.c, utils/ftpwho.c: Add missing
	break statements, per Coverity.

2016-01-17  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/keys.c: Remove extraneous null check, per
	Coverity.

2016-01-17  TJ Saunders <tj@castaglia.org>

	* src/support.c: Avoid some dead/unreachable code, per Coverity.

2016-01-17  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls_memcache.c: Removing now-unused variables.

2016-01-16  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #200 from proftpd/facts-media-type Update mod_facts to use mod_mime, when present/enabled, to provide
	the

2016-01-16  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #199 from
	proftpd/quotatab-better-handling-of-default Tweak the lookup pattern mod_quotatab uses, with regard to the
	QuotaD…

2016-01-16  TJ Saunders <tj@castaglia.org>

	* doc/howto/TLS.html: Adding FAQ about the TLS "unknown protocol"
	error, from the forums.

2016-01-15  TJ Saunders <tj@castaglia.org>

	* modules/mod_auth.c: Make sure to validate the USER command first,
	before any other special processing.

2016-01-15  TJ Saunders <tj@castaglia.org>

	* NEWS: Update NEWS for fix for Bug#4217.

2016-01-15  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #198 from proftpd/auth-reauthenticate-bug4217 Bug#4217: Handle FTP re-authentication attempts better.

2016-01-15  TJ Saunders <tj@castaglia.org>

	* modules/mod_auth.c: Address Bug#4217, as requested, to be slightly
	more indicative, via response codes and messages, of the issue with
	reauthentication.

2016-01-15  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Logins.pm: First part of working on
	Bug#4217: make sure there is a regression test for the previous
	behavior, for Bug#3736.

2016-01-15  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #197 from proftpd/extlog-bug4067-redux Attempt to fix the exclusion LogFormat functionality introduced for
	a…

2016-01-14  TJ Saunders <tj@castaglia.org>

	* modules/mod_core.c: Fix bug where not providing all parameters for
	FSCachePolicy might not have the expected behavior.

2016-01-14  TJ Saunders <tj@castaglia.org>

	* src/str.c: Quell a compiler warning about an unused function.

2016-01-14  TJ Saunders <tj@castaglia.org>

	* configure, configure.in, contrib/mod_sftp/crypto.c,
	contrib/mod_sql_postgres.c: Make sure that the build system
	automatically enables OpenSSL support when mod_auth_otp or
	mod_digest are requested.  Also update the lists of OpenSSL-using
	modules elsewhere.

2016-01-14  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls.c: Remove now-unused variable.

2016-01-13  TJ Saunders <tj@castaglia.org>

	* src/timers.c: Clean up stylistic nits, and leave more comments for
	my future self.  This helped me track down a timer-related issue,
	where the suggested "next timeout" calculation was too coarse, and
	prone to cause unexpected behavior.  Hopefully better now.

2016-01-13  TJ Saunders <tj@castaglia.org>

	* modules/mod_core.c: Set the module pointer for the TimeoutIdle
	callback, for better trace logging.

2016-01-12  TJ Saunders <tj@castaglia.org>

	* src/data.c, src/netio.c: Fix the generation of network IO
	read/write events, and refactor these events such that ALL of them
	are generated by the NetIO API, not spread out amongst the NetIO and
	data transfer routines.

2016-01-12  TJ Saunders <tj@castaglia.org>

	* src/auth.c: Include the number of items in the authcache, when we
	flush it.

2016-01-12  TJ Saunders <tj@castaglia.org>

	* src/table.c: Minor simplification to the code for removing an
	entry from a table.

2016-01-12  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #196 from proftpd/sorted-feat Sorted FEAT response, for more professional look

2016-01-12  TJ Saunders <tj@castaglia.org>

	* src/table.c: Style nits; no functional change.

2016-01-12  TJ Saunders <tj@castaglia.org>

	* modules/mod_core.c: Sort the FEAT response, for prettier, more
	professional displays.

2016-01-12  TJ Saunders <tj@castaglia.org>

	* src/table.c: Style nits; no functional change.

2016-01-11  TJ Saunders <tj@castaglia.org>

	* src/response.c, tests/api/response.c: Minor improvement for
	pr_response_send_async() by properly tracking the starting pointer
	for sstrcat(), to avoid scanning bytes already concatenated.

2016-01-11  TJ Saunders <tj@castaglia.org>

	* modules/mod_core.c: Make sure to include CLNT in the HELP output.

2016-01-11  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #195 from proftpd/ssh2-on-ftp Detect SSH2 connections to an FTP port

2016-01-10  TJ Saunders <tj@castaglia.org>

	* : commit f70caf2b4c41f9a7fe4790d6d7a0c0650f35d6f9 Author: TJ
	Saunders <tj@castaglia.org> Date:   Sun Jan 10 23:48:47 2016 -0800

2016-01-10  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #194 from proftpd/support-clnt Support the CLNT command

2016-01-10  TJ Saunders <tj@castaglia.org>

	* doc/howto/FTP.html, include/cmd.h, include/ftp.h,
	modules/mod_core.c, src/cmd.c, tests/api/cmd.c,
	tests/t/commands/clnt.t, tests/t/lib/ProFTPD/TestSuite/FTP.pm,
	tests/t/lib/ProFTPD/Tests/Commands/CLNT.pm, tests/tests.pl: Support
	the CLNT command.

2016-01-10  TJ Saunders <tj@castaglia.org>

	* .gitignore: Ignoring a few more symlinks.

2016-01-10  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sql_passwd.c, contrib/mod_tls.c,
	contrib/mod_tls_memcache.c, contrib/mod_tls_shmcache.c,
	include/str.h, src/str.c, tests/api/str.c: I decided that
	pr_str_bin2hex() was a better function name.

2016-01-10  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sql_passwd.c: Typo in comment; no functional change.

2016-01-09  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #193 from proftpd/core-str-hex Add new `pr_str_hex()` function.

2016-01-09  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sql.c: Quell compiler warning.

2016-01-08  TJ Saunders <tj@castaglia.org>

	* .gitignore: Adding a few more symlinks, generated by the build
	system, to be ignored by git.

2016-01-06  TJ Saunders <tj@castaglia.org>

	* src/fsio.c: Prevent infinite recursion, in lookup_file_fs(), by
	using the fs object's readlink callback directly, rather than going
	through the public API, which calls lookup_file_fs() -- hence the
	recursion.

2016-01-05  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #192 from proftpd/sql-odbc-issues SQL ODBC issues

2016-01-05  TJ Saunders <tj@castaglia.org>

	* RELEASE_NOTES, contrib/mod_sql_odbc.c,
	doc/contrib/mod_sql_odbc.html,
	tests/t/etc/modules/mod_sql_odbc/odbc.ini,
	tests/t/etc/modules/mod_sql_odbc/odbcinst.ini,
	tests/t/lib/ProFTPD/Tests/Modules/mod_quotatab_sql.pm: While
	investigating some mod_sql_odbc issues mentioned in the forums, I
	discovered some cases where the ODBC API version needed to be
	configurable.  Adding in the new config (and docs), and the
	reproduction recipes.

2016-01-05  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sql.c: Minor nits; no functional change.

2016-01-05  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Better name for
	added testcase.

2016-01-05  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Add regression test
	ensuring that mod_sftp properly fails to login a client that fails
	password authentication.

2016-01-03  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_tls.pm: Add regression test
	for CCC before login.

2016-01-03  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls.c: Per RFC 4217, Section 15.3, require
	authentication before accepting the CCC command, to mitigate
	anonymous clients from issuing AUTH/CCC in loops, tying up server
	resources.

2016-01-03  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #191 from proftpd/tls-verify-client-optional Implement "TLSVerifyClient optional", to replace functionality lost
	when

2016-01-01  TJ Saunders <tj@castaglia.org>

	* NEWS, RELEASE_NOTES: Mention fix for Bug#4214 in NEWS, release
	notes.

2016-01-01  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #190 from
	proftpd/lang-useencoding-per-user-bug4214 Bug#4214 - Allow UseEncoding to be set on a per-user basis.

2016-01-01  TJ Saunders <tj@castaglia.org>

	* configure, configure.in, modules/mod_lang.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_lang.pm: Bug#4214 - Allow
	UseEncoding to be set on a per-user basis.

2016-01-01  TJ Saunders <tj@castaglia.org>

	* config.h.in, configure, configure.in, src/regexp.c: Add necessary
	autoconf detection of pcre_free_study() function.

2016-01-01  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Apparently the travis-ci environment doesn't have
	apt.  Weird.

2016-01-01  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Remove sending email notifications to -committers; it
	doesn't appear to be working as expected.

2016-01-01  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Show the details of the libpcre3-dev package, to help
	debug a build failure on travis-ci (but working locally).

2016-01-01  TJ Saunders <tj@castaglia.org>

	* src/regexp.c: Syntax tweak, more of a stylistic nit.

2016-01-01  TJ Saunders <tj@castaglia.org>

	* src/regexp.c: We were missing an include of the PCRE headers.
	Odd.

2016-01-01  TJ Saunders <tj@castaglia.org>

	* src/auth.c: Quell compiler warning on travis-ci.

2016-01-01  TJ Saunders <tj@castaglia.org>

	* src/regexp.c: Refactor some common code into a single routine, and
	reduce needless duplication.

2016-01-01  TJ Saunders <tj@castaglia.org>

	* src/regexp.c: Make sure we explicitly call pcre_free_study(), to
	free up any JIT-allocated memory used by pcre_study().

2015-12-31  TJ Saunders <tj@castaglia.org>

	* modules/mod_core.c: Style nits; no functional change.

2015-12-31  TJ Saunders <tj@castaglia.org>

	* NEWS, RELEASE_NOTES: Update NEWS, release notes with mention of
	Bug#4213.

2015-12-31  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #189 from
	proftpd/tls-nocertrequest-tlsoption-bug4213 Bug#4213 - Deprecate the NoCertRequest TLSOption.

2015-12-27  TJ Saunders <tj@castaglia.org>

	* NEWS, RELEASE_NOTES: Updates NEWS, release notes with mention of
	TLS session ticket support (Bug#4176).

2015-12-27  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #188 from proftpd/tls-session-tickets-bug4176 TLS session ticket support (Bug#4176)

2015-12-25  TJ Saunders <tj@castaglia.org>

	* : commit 251611d8f6f579cb8eacc87ad525822b0fbed1c3 Author: TJ
	Saunders <tj@castaglia.org> Date:   Fri Dec 25 13:44:11 2015 -0800

2015-12-25  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Add email notifications to the travis-ci builds.

2015-12-25  TJ Saunders <tj@castaglia.org>

	* doc/contrib/mod_tls.html: Documenting the TLS session ticket
	support for Bug#4176.

2015-12-25  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls.c: Bug#4176: Support for TLS session tickets.  Initial implementation, with some testing.  Needs documentation now.

2015-12-23  TJ Saunders <tj@castaglia.org>

	* doc/contrib/mod_sftp.html, doc/contrib/mod_tls.html: Remove some
	confusing text about having multiple Options directives on the same
	line.

2015-12-23  TJ Saunders <tj@castaglia.org>

	* NEWS, RELEASE_NOTES: Update news, release notes to mention
	Bug#4200.

2015-12-23  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #183 from proftpd/sql-tls-info-bug4200 Bug#4200 - Support TLS client configuration for SQL servers.

2015-12-22  TJ Saunders <tj@castaglia.org>

	* include/compat.h: Provide a backward compatibility macro for
	`_sql_make_cmd`, and remove some old backward compatibility macros
	while there.

2015-12-22  TJ Saunders <tj@castaglia.org>

	* : commit 39ee20cc2708bd8b7abd0c391e433f74858d2621 Author: TJ
	Saunders <tj@castaglia.org> Date:   Tue Dec 22 17:38:16 2015 -0800

2015-12-22  TJ Saunders <tj@castaglia.org>

	* NEWS, RELEASE_NOTES: Update NEWS, release notes with mention of
	fix for Bug#4175.

2015-12-22  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #186 from proftpd/tls-ocsp-stapling-bug4175 Bug#4175: Support for OCSP stapling

2015-12-22  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls_memcache.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_tls_memcache.pm: Implement an
	OCSP response cache provider using mod_tls_memcache, with
	accompanying regression tests.

2015-12-22  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls_shmcache.c: Update the mod_tls_shmcache comments
	to be more up-to-date.

2015-12-22  TJ Saunders <tj@castaglia.org>

	* doc/contrib/mod_tls.html, doc/contrib/mod_tls_shmcache.html: 
	Update the mod_tls_shmcache docs to mention its support for the
	TLSStaplingCache directive.

2015-12-22  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls_shmcache.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_tls_shmcache.pm: Implement an
	OCSP response cache provider via SysV shared memory segments (using
	mod_tls_shmcache), with accompanying tests.

2015-12-22  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_tls.pm,
	tests/t/lib/ProFTPD/Tests/Modules/mod_tls_fscache.pm: Move one of
	the OCSP stapling support routines to the mod_tls_fscache-specific
	tests.

2015-12-22  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls_fscache.c: Remove unused event listeners, and
	update the logging of OpenSSL errors to include the finer-grained
	data, if available.

2015-12-22  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls.c: If the EnableDiags TLSOption is in effect,
	print out the OCSP response we obtained from the TLSStaplingCache,
	if any.  Also make sure that we do NOT add back to the
	TLSStaplingCache a response that we just read from that cache.

2015-12-22  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls_shmcache.c: Step #1 in adding OCSP cache support
	to mod_tls_shmcache: rename all of the existing SSL session cache
	variables/functions more clearly.

2015-12-22  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_tls.pm,
	tests/t/lib/ProFTPD/Tests/Modules/mod_tls_fscache.pm,
	tests/t/modules/mod_tls_fscache.t, tests/tests.pl: Split out the
	mod_tls_fscache-related regression tests into their own test file,
	just as was done for mod_tls_memcache and mod_tls_shmcache.

2015-12-22  TJ Saunders <tj@castaglia.org>

	* .gitignore: Ignore the new mod_tls_fscache symlinked into the
	modules/ directory.

2015-12-22  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls_fscache.c: Finish implementing some of the
	'ftpdctl ocspcache' actions for mod_tls_fscache.

2015-12-21  TJ Saunders <tj@castaglia.org>

	* doc/contrib/mod_tls_fscache.html: Provide better example
	configuration.

2015-12-21  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_tls.pm: Remove development
	cruft.

2015-12-21  TJ Saunders <tj@castaglia.org>

	* doc/contrib/mod_tls.html, doc/contrib/mod_tls_fscache.html,
	doc/contrib/mod_tls_memcache.html: Update the mod_tls docs for the
	OCSP stapling support, and include the docs for the new
	mod_tls_fscache module.

2015-12-21  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls.c: Implement a TLSStaplingResponder directive, for
	sites which will need to proxy their OCSP queries.  Also remove
	unnecessary defensive coding, after reading the OpenSSL sources.

2015-12-21  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls_fscache.c: Be a little more careful with the OCSP
	response files found on disk.

2015-12-21  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls.c: Refactor some of the previous OCSP code (for
	checking client certificates' revocation status) to use the newer
	code, and reduce the amount of code duplication.

2015-12-21  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls.c: Fix build errors, warnings caught by travis-ci.

2015-12-21  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_quotatab_sql.pm: Add
	regression test demonstrating a mod_quotatab config that uses the
	QuotaDefault directive.

2015-12-21  TJ Saunders <tj@castaglia.org>

	* : commit 8a9a719b595b31f061be46835a18f9b73c172625 Author: TJ
	Saunders <tj@castaglia.org> Date:   Mon Dec 21 15:24:27 2015 -0800

2015-12-21  TJ Saunders <tj@kiban.io>

	* contrib/mod_tls.c: Address Issue #185 by explicitly clearing the
	passphrase list, even when there are no explicit passphrases for a
	cert.

2015-12-17  TJ Saunders <tj@castaglia.org>

	* : commit 8787af68da750efcbe11ccee93df07a583e3ba89 Merge: f98a4fc
	82a2fe1 Author: TJ Saunders <tj@castaglia.org> Date:   Thu Dec 17
	14:06:01 2015 -0800

2015-12-17  TJ Saunders <tj@castaglia.org>

	* locale/files.txt: Updating the list of candidate files which might
	contain localizable strings.

2015-12-17  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #180 from proftpd/build-fix-dist-target Fix the 'make dist' target

2015-12-17  TJ Saunders <tj@castaglia.org>

	* : commit fd4afb392a2855a93ea2615f73215125e07db72c Author: TJ
	Saunders <tj@castaglia.org> Date:   Thu Dec 17 13:34:26 2015 -0800

2015-12-17  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #184 from proftpd/rpm-systemd-bug3661 Updated proftpd.spec file to include the systemd files, per
	Bug#3661.

2015-12-17  TJ Saunders <tj@castaglia.org>

	* .gitignore: Ignore symlinks generated by the build system, and
	other auto-generated files.

2015-12-16  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls_memcache.c: Make the namespace for memcached
	sessions more precise, as we might want to cache other objects (e.g.
	OCSP responses) in the near future.

2015-12-16  TJ Saunders <tj@castaglia.org>

	* config.h.in, configure, configure.in, contrib/mod_tls.c: Initial
	start of OCSP stapling implementation in mod_tls.  For this, we
	either return a "tryLater" OCSP response, or none.  This is how it
	starts.

2015-12-15  TJ Saunders <tj@castaglia.org>

	* doc/contrib/mod_sql_odbc.html: HTML fixups.

2015-12-15  TJ Saunders <tj@castaglia.org>

	* : commit d259494c8ebc9c2074ec95125d1e57a5b8db3074 Author: TJ
	Saunders <tj@castaglia.org> Date:   Tue Dec 15 16:51:56 2015 -0800

2015-12-15  TJ Saunders <tj@castaglia.org>

	* config.h.in, configure, configure.in, contrib/mod_sql.c,
	contrib/mod_sql.h, contrib/mod_sql_mysql.c, contrib/mod_sql_odbc.c,
	contrib/mod_sql_postgres.c, contrib/mod_sql_sqlite.c,
	doc/contrib/mod_sql.html: Bug#4200 - Support TLS client
	configuration for SQL servers.

2015-12-15  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #182 from tkyf/fix_log_for_MaxHostsPerUser Fix log message on connection refused by MaxHostsPerUser limits

2015-12-14  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/crypto.c, contrib/mod_sftp/keys.c,
	contrib/mod_sftp/mod_sftp.h.in: Make mod_sftp compile when
	either/both DSA and DES are disabled in OpenSSL.

2015-12-14  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/crypto.c: Ensure that mod_sftp builds if RIPEMD
	is disabled in OpenSSL.

2015-12-14  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/crypto.c: Make sure that mod_sftp can compile
	against an OpenSSL which has had CAST support disabled.

2015-12-14  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/crypto.c, contrib/mod_sftp/mod_sftp.h.in: Make it
	possible to build mod_sftp against an OpenSSL which has had Blowfish
	support disabled.

2015-12-14  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/crypto.c: Make sure that mod_sftp compiles using
	an OpenSSL that has had RC4 support disabled.

2015-12-14  TJ Saunders <tj@castaglia.org>

	* NEWS: Update NEWS for fix for Bug#4212.

2015-12-14  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #181 from proftpd/rootrevoke-on-enforcement Bug#4212: Ensure that FTP data transfer commands fail appropriately
	when "RootRevoke on" is in effect.

2015-12-11  TJ Saunders <tj@castaglia.org>

	* modules/mod_core.c, modules/mod_ls.c, src/data.c: Make sure that
	the port number logged in the "RootRevoke in effect" messages is
	accurate.  Enforce the case where RootRevoke is on, but the client has ignored
	our error responses to PORT/EPRT, and had requested a data transfer
	anyway.  We do this by returning an error response for the data
	transfer command (e.g. LIST, STOR, etc) before we even attempt to
	make the connection.

2015-12-11  TJ Saunders <tj@castaglia.org>

	* Make.rules.in, lib/Makefile.in, modules/Makefile.in,
	src/Makefile.in, utils/Makefile.in: Define a MAKEDEPEND variable in
	the top-level Make.rules, so that I can easily override what to use
	as "makedepend" on platforms which don't easily have one (e.g. Mac
	OSX).

2015-12-11  TJ Saunders <tj@castaglia.org>

	* src/ftpscrub.c: Remove duplicated 'ftpscrub.c' from the src/
	directory; it is already in the utils/ directory (where it should
	be).  I suspect that this file was gumming up the makedepend works.

2015-12-11  TJ Saunders <tj@castaglia.org>

	* contrib/mod_ldap.c: Fix mod_ldap build issue when building against
	e.g. OpenLDAP-2.3.x.

2015-12-10  TJ Saunders <tj@castaglia.org>

	* contrib/ftpasswd: Address Debian ProFTPD Bug 796233; see:   https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=796233

2015-12-10  TJ Saunders <tj@castaglia.org>

	* utils/ftpshut.8.in: Man page style nits.

2015-12-10  TJ Saunders <tj@castaglia.org>

	* src/dirtree.c: Reduce logging verbosity when parsing Include
	directories.

2015-12-10  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #178 from proftpd/contrib-systemd-bug3661 Bug#3661 - Support for systemd's "socket activation" mode.

2015-12-10  TJ Saunders <tj@castaglia.org>

	* modules/mod_auth.c: Provide slightly more informative message
	about active data transfers being affected by "RootRevoke on".

2015-12-09  TJ Saunders <tj@castaglia.org>

	* : commit b82c2a02d2822d033f38026c53ee65579efce5b8 Author: TJ
	Saunders <tj@castaglia.org> Date:   Wed Dec 9 14:21:26 2015 -0800

2015-12-09  TJ Saunders <tj@castaglia.org>

	* contrib/dist/systemd/README.systemd,
	contrib/dist/systemd/proftpd.socket,
	contrib/dist/systemd/proftpd@.service: Bug#3661 - Support for
	systemd's "socket activation" mode.

2015-12-09  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #177 from proftpd/null-times-bug4136 Attempt to address/mitigate Bug#4136 by checking for null return
	valu…

2015-12-09  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sql.c: Removing unused variable/context.

2015-12-08  TJ Saunders <tj@castaglia.org>

	* RELEASE_NOTES: Something more to mention in the release notes
	(Bug#4057, that is).

2015-12-08  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #176 from
	proftpd/tls-memcache-using-json-bug4057 Bug#4057 - Support using JSON when storing TLS session information
	in memcached

2015-12-08  TJ Saunders <tj@castaglia.org>

	* contrib/mod_ban.c: While working on Bug#4057, I encountered some
	memory-handling issues with the work for Bug#4056; these are the
	fixes.

2015-12-08  TJ Saunders <tj@castaglia.org>

	* .gitignore: Another form of temporary file to ignore, please.

2015-12-08  TJ Saunders <tj@castaglia.org>

	* NEWS, contrib/mod_tls_memcache.c,
	doc/contrib/mod_tls_memcache.html, include/memcache.h,
	src/memcache.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_tls_memcache.pm: Bug#4057:
	Support using JSON when storing TLS session information in
	memcached.

2015-12-08  TJ Saunders <tj@castaglia.org>

	* : commit 6e34ab4c8132c3b8b87e60ab116e40a2b0aae3be Author: TJ
	Saunders <tj@castaglia.org> Date:   Tue Dec 8 08:20:51 2015 -0800

2015-12-08  TJ Saunders <tj@castaglia.org>

	* src/signals.c: Minor tweaks (build warnings, error checking) for
	obtaining stacktraces on Mac OSX.

2015-12-08  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #175 from
	proftpd/ban-memcache-using-json-bug4056 Bug#4056: Use JSON when storing ban information in memcached

2015-12-07  TJ Saunders <tj@castaglia.org>

	* contrib/mod_ban.c, include/memcache.h, src/memcache.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_ban/memcache.pm,
	utils/ftpwho.c: Finish the regression tests for Bug#4056.  This also
	involved adding some necessary cleanup (lessons learned!) in ftpwho.

2015-12-07  TJ Saunders <tj@castaglia.org>

	* contrib/mod_ban.c: Some cached ban rules might never expire; these
	can be added using ftpdctl.  Make sure that mod_ban does not purge
	the rules when checking for expired cache entries.

2015-12-07  TJ Saunders <tj@castaglia.org>

	* contrib/mod_ban.c, doc/contrib/mod_ban.html, src/memcache.c: 
	Implement the code for supporting Bug#4056, and update the mod_ban
	docs accordingly.

2015-12-04  TJ Saunders <tj@castaglia.org>

	* RELEASE_NOTES: Flesh out the release notes, preparing for a
	release.

2015-12-04  TJ Saunders <tj@castaglia.org>

	* tests/api/misc.c: Remove troublesome assertion, for now.

2015-12-04  TJ Saunders <tj@castaglia.org>

	* tests/api/misc.c: Trying to get this persnickety test to pass.
	Sheesh.

2015-12-04  TJ Saunders <tj@castaglia.org>

	* tests/api/misc.c: Fix test failures by ensuring that localtime(3)
	returns GMT data.

2015-12-04  TJ Saunders <tj@castaglia.org>

	* tests/api/misc.c: Adding test coverage of the check_shutmsg()
	support routine.

2015-12-04  TJ Saunders <tj@castaglia.org>

	* utils/ftpshut.c: Stylistic nits in the ftpshut utility; no
	functional change.

2015-12-04  TJ Saunders <tj@castaglia.org>

	* tests/api/display.c: Properly test the SEND_NOW and NO_EOM display
	flags.

2015-12-04  TJ Saunders <tj@castaglia.org>

	* src/support.c, tests/api/misc.c: More tests of the Support API;
	I'm sure more coverage is needed.

2015-12-04  TJ Saunders <tj@castaglia.org>

	* tests/api/display.c: Cover more of the Display API via unit tests.

2015-12-04  TJ Saunders <tj@castaglia.org>

	* include/support.h, src/main.c, src/support.c, tests/api/misc.c: 
	Adding to the code coverage of the unit tests.

2015-12-04  TJ Saunders <tj@castaglia.org>

	* tests/api/display.c: Tickle more of the code paths in the Display
	API in the unit tests.

2015-12-03  TJ Saunders <tj@castaglia.org>

	* tests/api/misc.c: Fix broken test, seen by travis-ci.

2015-12-03  TJ Saunders <tj@castaglia.org>

	* src/support.c, tests/api/misc.c: More unit tests, for more code
	coverage.

2015-12-03  TJ Saunders <tj@castaglia.org>

	* src/support.c, tests/api/misc.c: Filling out more unit tests, in
	the name of code coverage.

2015-12-03  TJ Saunders <tj@castaglia.org>

	* tests/Makefile.in, tests/api/misc.c, tests/api/tests.c,
	tests/api/tests.h: Start adding unit tests for the support API
	routines now pull in, to increase test coverage.

2015-12-03  TJ Saunders <tj@castaglia.org>

	* src/support.c: Stylistic nits; no functional change.

2015-12-03  TJ Saunders <tj@castaglia.org>

	* include/str.h, include/support.h, src/str.c, src/support.c,
	tests/api/str.c: With the addition of the src/support.c file to the
	unit tests, the test coverage has changed.  Thus work to get the
	coverage back up to par, which involves some good refactoring.

2015-12-03  TJ Saunders <tj@castaglia.org>

	* src/display.c: Stylistic tweaks; no functional change.

2015-12-03  TJ Saunders <tj@castaglia.org>

	* include/display.h, src/display.c, tests/Makefile.in,
	tests/api/display.c, tests/api/stubs.c, tests/api/tests.c,
	tests/api/tests.h: Start working on unit tests for the Display API.

2015-12-03  TJ Saunders <tj@castaglia.org>

	* RELEASE_NOTES: Start updating release notes; more to be fleshed
	out.

2015-12-01  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #168 from
	proftpd/login-timeout-exceeded-log-level Change the log level for various timeouts (TimeoutLogin,
	TimeoutSessi…

2015-11-30  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #172 from
	proftpd/core-masqueradeaddress-resolved-later-bug4104 Bug#4104 - Handle MasqueradeAddress resolution errors due to startup
	…

2015-11-30  TJ Saunders <tj@castaglia.org>

	* tests/api/netaddr.c: Make sure to add a unit test for the specific
	errno value, when a DNS name cannot be resolved (Bug#4104).

2015-11-30  TJ Saunders <tj@castaglia.org>

	* NEWS, RELEASE_NOTES: Update NEWS, release notes for this feature.

2015-11-30  TJ Saunders <tj@castaglia.org>

	* contrib/mod_dynmasq.c, tests/t/modules/mod_dynmasq.t,
	tests/tests.pl: Add regression tests for the mod_dynmasq module,
	ensuring that it handles the delayed-resolution DNS names for
	MasqueradeAddress properly (Bug#4104).

2015-11-30  TJ Saunders <tj@castaglia.org>

	* src/session.c,
	tests/t/lib/ProFTPD/Tests/Config/MasqueradeAddress.pm: Adding
	regression test for Bug#4104.

2015-11-28  TJ Saunders <tj@castaglia.org>

	* contrib/mod_dynmasq.c, modules/mod_core.c, src/dirtree.c,
	src/display.c, src/main.c, src/netaddr.c, src/session.c: Bug#4104 -
	Handle MasqueradeAddress resolution errors due to startup sequences.

2015-11-28  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/kbdint.c: Remove now-unneeded cast.

2015-11-28  TJ Saunders <tj@castaglia.org>

	* NEWS: Update NEWS with fix for Bug#4210.

2015-11-28  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #171 from
	proftpd/sftp-unbounded-extpair-bug4210 Bug#4210 - Avoid unbounded SFTP extended attribute key/values.

2015-11-28  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c: Bug#4210 - Avoid unbounded SFTP extension
	key/values.

2015-11-28  TJ Saunders <tj@castaglia.org>

	* NEWS: Updating NEWS for fix for Bug#4209.

2015-11-28  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #170 from
	proftpd/core-zero-size-pool-malloc-bug4209 Bug#4209 - Zero-length memory allocation possible, with undefined
	res…

2015-11-28  TJ Saunders <tj@castaglia.org>

	* src/pool.c: Bug#4209 - Zero-length memory allocation possible,
	with undefined results.

2015-11-15  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #169 from proftpd/tls-host-command Make the handling of the HOST command by mod_tls be more in line
	with…

2015-11-15  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls.c: Minor trace logging for debugging.

2015-11-15  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sql_mysql.c: Stylistic tweaks; no functional change.

2015-11-15  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sql.c: Minor nit; no functional change.

2015-11-15  TJ Saunders <tj@castaglia.org>

	* src/netio.c: Minor nits; no functional change.

2015-11-14  TJ Saunders <tj@castaglia.org>

	* modules/mod_auth.c: Change the log level for various timeouts
	(TimeoutLogin, TimeoutSession) from NOTICE to INFO, given that these
	timeouts can be very frequent/common occurrences.

2015-11-14  TJ Saunders <tj@castaglia.org>

	* doc/howto/index.html: Fix link to LogLevels howto.

2015-11-13  TJ Saunders <tj@castaglia.org>

	* src/netio.c: If a stream has been marked as interruptible, then do
	not retry e.g. poll() when the system call is interrupted; return
	that error to the caller.

2015-11-12  TJ Saunders <tj@castaglia.org>

	* include/bindings.h, modules/mod_core.c, src/bindings.c: During the
	implementing of HOST handling in mod_proxy, the integration tests
	there stumbled across a minor bug in the handling of HOST commands
	which pertain to several different vhosts on the same _address_, but
	on different ports.  We were not properly differentiating among
	these vhosts when looking for the one which had the requested HOST
	(or not).

2015-11-10  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #166 from
	proftpd/sftp-publickey-failed-login-logging Add more logging, via the normal auth logging channels, for when
	SFTP

2015-11-10  TJ Saunders <tj@castaglia.org>

	* : commit 100e7f7ca1780ce2cab8b489768b76816794999c Author: TJ
	Saunders <tj@castaglia.org> Date:   Mon Nov 9 17:51:36 2015 -0800

2015-11-09  TJ Saunders <tj@castaglia.org>

	* src/inet.c: Ignore "Bad file descriptor" errors when toggling
	Nagle on sockets.

2015-11-09  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #165 from
	proftpd/lang-segfault-postparse-bug4206 Attempt to Bug#4206 by speculatively fixing possible causes.  First,
	…

2015-10-28  TJ Saunders <tj@castaglia.org>

	* modules/mod_lang.c: Attempt to Bug#4206 by speculatively fixing
	possible causes.  First, reset a static string (allocated out of a
	pool which is cleared on restart) to its default.  Next, remove some
	(useless) #ifdefs which, if mod_lang is built as a DSO/shared
	module, could cause problems on module loading IFF the system does
	not have the expected header.

2015-10-27  TJ Saunders <tj@castaglia.org>

	* src/parser.c: Fix bug in parser, caused by refactoring.

2015-10-22  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls.c: Fix compiler warning.

2015-10-14  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #159 from proftpd/sftp-fsetstat-bug4204 Attempt to mitigate/fix Bug#4204 by ensuring that the response lists
	are

2015-10-14  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c: When writing out a STATUS message, make
	sure to use the pool from the SFTP request, rather than the
	session's pool, as the latter could possibly be overused; this thus
	counts as a memory leak.

2015-10-13  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #163 from bverschueren/obsolete_timer_t_macro Remove HAVE_TIMER_T macro and timer_t detection mechanism

2015-10-07  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Turns out that running the api-tests executable again
	doesn't really increase the coverage of the Privs API as I'd
	expected.  Oh well.

2015-10-07  TJ Saunders <tj@castaglia.org>

	* .travis.yml: I think that the `api-tests` executable needs to be
	run in the tests/ directory, so that the lcov stuff picks up the
	files.

2015-10-07  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Run just the privs-related unit tests as root, for
	better test code coverage.

2015-10-07  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c: Make sure that the errno value from a
	failed pr_fsio_write() call is properly propagated/used.

2015-10-07  TJ Saunders <tj@castaglia.org>

	* tests/api/privs.c: Remove unneeded setting of trace logging to
	STDERR.

2015-10-06  TJ Saunders <tj@castaglia.org>

	* tests/api/scoreboard.c: Attempt to fix spurious test failures.

2015-10-06  TJ Saunders <tj@castaglia.org>

	* tests/api/scoreboard.c: Refactor the Scoreboard testing code to be
	more in line with the rest of the styling.  Added coverage of more
	fields when updating scoreboard entries.

2015-10-05  TJ Saunders <tj@castaglia.org>

	* tests/api/scoreboard.c: Cover more of pr_scoreboard_entry_get(),
	and note what needs to be done for pr_scoreboard_entry_update().

2015-10-04  TJ Saunders <tj@castaglia.org>

	* include/scoreboard.h, src/scoreboard.c, tests/api/scoreboard.c: 
	Refactor the other portion of locking code in the Scoreboard API,
	that for locking entries, into a common testable function.

2015-10-04  TJ Saunders <tj@castaglia.org>

	* include/scoreboard.h, src/scoreboard.c, tests/api/scoreboard.c: 
	Refactor some of the scoreboard locking code to avoid code
	duplication, and make it possible to test via unit tests.  There's
	more such refactoring to do here.

2015-10-04  TJ Saunders <tj@castaglia.org>

	* tests/api/auth.c: Tickle the "authenticated/authorized/checked via
	RFC2228" code paths.

2015-10-04  TJ Saunders <tj@castaglia.org>

	* tests/api/auth.c, tests/api/data.c, tests/api/modules.c: Fixed
	some typos, tried to cover a few more edge cases.

2015-10-04  TJ Saunders <tj@castaglia.org>

	* src/modules.c, tests/api/data.c, tests/api/modules.c: Testing more
	code paths.

2015-10-04  TJ Saunders <tj@castaglia.org>

	* tests/api/data.c, tests/api/stubs.c, tests/api/tests.h: Simulate
	receiving control commands during a data transfer, for more test
	coverage.

2015-10-04  TJ Saunders <tj@castaglia.org>

	* tests/api/data.c: Add test coverage for reading data via
	pr_data_xfer().

2015-10-04  TJ Saunders <tj@castaglia.org>

	* src/data.c, tests/api/configdb.c, tests/api/data.c,
	tests/api/netacl.c: Refactor some of the too-large pr_data_xfer()
	function, to make it easier to read (and test).  Start working on
	unit tests for this function, too.

2015-10-04  TJ Saunders <tj@castaglia.org>

	* tests/api/configdb.c: Much better exercising of the mergedown
	functionality.

2015-10-04  TJ Saunders <tj@castaglia.org>

	* tests/api/configdb.c, tests/api/stash.c: Working on exercising
	more of the config lookup code.

2015-10-04  TJ Saunders <tj@castaglia.org>

	* src/stash.c, tests/api/encode.c, tests/api/stash.c: Eking out ever
	more test coverage, bit by bit.

2015-10-03  TJ Saunders <tj@castaglia.org>

	* src/auth.c, src/encode.c, tests/api/auth.c, tests/api/encode.c: 
	Increased code coverage for the Auth and Encode APIs.

2015-10-03  TJ Saunders <tj@castaglia.org>

	* src/response.c, tests/api/response.c: The response unit tests
	would fail if the TEST_VERBOSE environment variable was set; now
	fixed.  Also added some sanity checking for null format strings for
	pr_response_add() and pr_response_add_err(), for paranoia.

2015-10-03  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #162 from
	proftpd/tls-no-mlock-for-empty-passphrase If there is no passphrase needed for a certificate, then do not
	bother

2015-09-30  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #161 from
	orthographic-pedant/spell_check/administrator Fixed typographical error, changed adminstrator to administrator in
	README.

2015-09-30  TJ Saunders <tj@castaglia.org>

	* README.md: Add a few more badges.

2015-09-29  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c: Attempt to mitigate/fix Bug#4204 by
	ensuring that the response lists are cleared after each dispatching.

2015-09-29  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #158 from proftpd/exec-max-fd-count Limit the maximum number of fds closed by mod_exec when executing an
	…

2015-09-28  TJ Saunders <tj@castaglia.org>

	* src/configdb.c, tests/api/configdb.c: Tickling a few more branches
	in the Config API.

2015-09-28  TJ Saunders <tj@castaglia.org>

	* src/fsio.c, src/inet.c, tests/api/inet.c: Removing unneeded code
	paths.  Covering more of the Inet API with more testing.

2015-09-28  TJ Saunders <tj@castaglia.org>

	* tests/api/fsio.c: Cover more of the pr_fsio_access() code paths.

2015-09-28  TJ Saunders <tj@castaglia.org>

	* src/netaddr.c, tests/api/netaddr.c: Flesh out the remaining
	Netaddr API unit tests.

2015-09-28  TJ Saunders <tj@castaglia.org>

	* tests/api/netaddr.c: Cover the pr_netaddr_v6tov4() function in the
	tests, too.

2015-09-28  TJ Saunders <tj@castaglia.org>

	* tests/api/inet.c: Try covering more error paths in the Inet API.

2015-09-28  TJ Saunders <tj@castaglia.org>

	* src/fsio.c, tests/api/fsio.c: Trying to get coverage of the FSIO
	API higher.

2015-09-27  TJ Saunders <tj@castaglia.org>

	* contrib/mod_exec.c: Limit the maximum number of fds closed by
	mod_exec when executing an external program, regardless of the
	platform.

2015-09-27  TJ Saunders <tj@castaglia.org>

	* tests/api/fsio.c: Easy addition for covering of the --enable-devel
	FSIO API.

2015-09-27  TJ Saunders <tj@castaglia.org>

	* src/configdb.c, tests/api/configdb.c: Covering more of the Config
	API.

2015-09-27  TJ Saunders <tj@castaglia.org>

	* src/fsio.c, tests/api/fsio.c: Covering more of the FSIO API.

2015-09-26  TJ Saunders <tj@castaglia.org>

	* src/regexp.c, tests/api/regexp.c: Increase coverage of POSIX regex
	handling in the Regexp API.

2015-09-26  TJ Saunders <tj@castaglia.org>

	* tests/api/configdb.c: Cover a little more of the Config API.

2015-09-26  TJ Saunders <tj@castaglia.org>

	* src/auth.c, tests/api/auth.c: Testing the handling of -1 UID/GIDs
	turned up a small bug, where the Auth API was not setting errno
	appropriately.

2015-09-26  TJ Saunders <tj@castaglia.org>

	* tests/api/fsio.c: Test the cases where multiple FSes are
	inserted/removed.

2015-09-26  TJ Saunders <tj@castaglia.org>

	* tests/api/fsio.c: Cover more of the FSIO API, too.

2015-09-26  TJ Saunders <tj@castaglia.org>

	* tests/api/trace.c: Make sure we test the handling of the "DEFAULT"
	trace channel, too.

2015-09-26  TJ Saunders <tj@castaglia.org>

	* src/trace.c: If the channel name is null, then it cannot be
	removed from the trace table of channels, can it?

2015-09-26  TJ Saunders <tj@castaglia.org>

	* src/trace.c, tests/api/stubs.c, tests/api/trace.c: Tickle a few
	more code paths in the Trace API.

2015-09-26  TJ Saunders <tj@castaglia.org>

	* src/log.c: Be more paranoid about handling of possible directories
	as log files, including the "/" case.

2015-09-26  TJ Saunders <tj@castaglia.org>

	* tests/api/trace.c: More Trace test coverage.

2015-09-26  TJ Saunders <tj@castaglia.org>

	* tests/api/data.c: Fix unit test broken in travis-ci environment.

2015-09-26  TJ Saunders <tj@castaglia.org>

	* include/data.h, src/data.c, tests/api/data.c: Attempt to write
	tests for pr_data_sendfile(), covering more of its code paths.

2015-09-26  TJ Saunders <tj@castaglia.org>

	* src/netio.c, tests/api/event.c, tests/api/netio.c: Finish
	implementing the NetIO unit tests.

2015-09-25  TJ Saunders <tj@castaglia.org>

	* tests/api/event.c: One more tweak for the Event API unit test
	coverage.

2015-09-25  TJ Saunders <tj@castaglia.org>

	* tests/api/event.c: More coverage of the Event API code paths.

2015-09-25  TJ Saunders <tj@castaglia.org>

	* tests/api/auth.c: Fix unit test failing in travis-ci environment.

2015-09-25  TJ Saunders <tj@castaglia.org>

	* config.h.in, configure, configure.in, include/fsio.h, src/fsio.c,
	tests/api/fsio.c: Finish fleshing out the FSIO API unit tests.  This
	required adding a new pr_fsio_fsync() function (and its own test),
	for flushing data to disk for subsequent reading.

2015-09-25  TJ Saunders <tj@castaglia.org>

	* src/fsio.c, tests/api/fsio.c: More coverage for the FSIO API,
	please.

2015-09-25  TJ Saunders <tj@kiban.io>

	* tests/api/fsio.c, tests/api/trace.c: Quell compiler warnings, fix
	unit test failing in travis-ci environment.

2015-09-25  TJ Saunders <tj@kiban.io>

	* tests/api/fsio.c: Fix failing unit test.

2015-09-25  TJ Saunders <tj@kiban.io>

	* src/fsio.c, tests/api/fsio.c: Adding coverage for more functions
	in the FSIO API; still more to be done here.

2015-09-24  TJ Saunders <tj@kiban.io>

	* tests/api/parser.c: When testing the function for parsing files,
	load enough of a module's directive handling to test those paths,
	too.

2015-09-24  Castaglian <tj@kiban.io>

	* src/configdb.c, tests/api/configdb.c, tests/api/regexp.c: More
	test coverage, served up hot.

2015-09-24  Castaglian <tj@kiban.io>

	* src/parser.c, src/trace.c, tests/api/parser.c, tests/api/trace.c: 
	Fix some of the Parser API tests, and try to cover more of the Trace
	API.

2015-09-24  Castaglian <tj@kiban.io>

	* tests/api/netaddr.c: Use 'www.google.com' as a well-known DNS name
	that has multiple IP addresses.

2015-09-24  Castaglian <tj@kiban.io>

	* src/parser.c, tests/api/netaddr.c, tests/api/parser.c: Filling in
	more unit tests here and there, tickling more code paths, extending
	coverage.

2015-09-24  Castaglian <tj@kiban.io>

	* tests/api/auth.c: Fix tests on travis-ci.

2015-09-24  Castaglian <tj@kiban.io>

	* include/modules.h, src/main.c, src/modules.c, tests/api/modules.c: 
	Testing more of the Modules API.

2015-09-24  Castaglian <tj@kiban.io>

	* src/auth.c, tests/api/auth.c: More unit testing of the Auth API.
	Fixed one bug with the handling of the FL_AUTH_MODULE caching flag
	(yay unit tests!).

2015-09-24  Castaglian <tj@kiban.io>

	* src/pool.c, tests/api/parser.c, tests/api/pool.c: Extend test
	coverage of the Pool API.

2015-09-24  Castaglian <tj@kiban.io>

	* include/parser.h, modules/mod_auth_unix.c, modules/mod_core.c,
	src/main.c, src/parser.c, tests/api/parser.c: Fixing up compiler
	warnings.  Fixed the API for parsing a single line of text so that
	it is actually _useful_ for callers outside of
	pr_parser_parse_file().  Added more unit tests for parsing.

2015-09-24  Castaglian <tj@kiban.io>

	* src/auth.c, tests/api/auth.c: Extend test coverage of the Auth
	API.

2015-09-24  TJ Saunders <tj@castaglia.org>

	* tests/api/fsio.c: Properly test the eviction of expired
	fs.statcache entries.

2015-09-24  TJ Saunders <tj@castaglia.org>

	* src/fsio.c, tests/api/fsio.c, tests/api/tests.c: And yet more unit
	tests for the FSIO API.

2015-09-23  TJ Saunders <tj@castaglia.org>

	* tests/Makefile.in, tests/api/privs.c, tests/api/tests.c,
	tests/api/tests.h: Start working on unit tests for the Privs API
	directly.

2015-09-23  TJ Saunders <tj@castaglia.org>

	* tests/api/regexp.c: Flesh out more of the Regexp API unit tests.

2015-09-23  Castaglian <tj@kiban.io>

	* tests/api/data.c: The travis-ci environment yields slightly
	different (but still OK) errno values.

2015-09-23  Castaglian <tj@kiban.io>

	* include/configdb.h, src/data.c, tests/api/data.c,
	tests/api/stubs.c: Add some NULL checks, for e.g. unit tests.  Flesh
	out more Data API unit tests.

2015-09-22  TJ Saunders <tj@kiban.io>

	* src/data.c, tests/api/data.c: Start working on unit tests for the
	Data API.

2015-09-22  TJ Saunders <tj@kiban.io>

	* README.md, tests/api/fsio.c: Tweak README.  Fix unit test failing
	only in travis-ci.

2015-09-22  TJ Saunders <tj@kiban.io>

	* src/fsio.c, tests/api/fsio.c: Fleshing out more FSIO tests; more
	to come.

2015-09-22  TJ Saunders <tj@kiban.io>

	* tests/api/str.c: Fix failing test on this Yosemite MacOSX machine,
	due to not NUL-terminating the source buffer in a sstrcat test.

2015-09-22  TJ Saunders <tj@kiban.io>

	* src/pool.c: Quell compiler warnings about pointer
	arithmetic/casts; first seen on this version of Mac OSX (Yosemite).

2015-09-21  TJ Saunders <tj@castaglia.org>

	* README.md: Minor tweaks to README; no functional changes.

2015-09-21  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Fix typo in travis-ci config file.

2015-09-21  TJ Saunders <tj@castaglia.org>

	* .travis.yml, src/inet.c, tests/api/configdb.c, tests/api/inet.c: 
	Let's see/hope that these additions get us over the 50% mark for
	test coverage.

2015-09-20  TJ Saunders <tj@castaglia.org>

	* src/parser.c, src/scoreboard.c, tests/api/cmd.c,
	tests/api/event.c, tests/api/parser.c, tests/api/scoreboard.c,
	tests/api/trace.c: Working toward getting at least 50% unit test
	coverage.

2015-09-20  TJ Saunders <tj@castaglia.org>

	* src/netio.c, tests/api/netio.c, tests/api/timers.c: More unit
	tests, Cooky!

2015-09-20  TJ Saunders <tj@castaglia.org>

	* modules/mod_lang.c, tests/Makefile.in, tests/api/configdb.c,
	tests/api/encode.c, tests/api/parser.c, tests/api/tests.c,
	tests/api/tests.h: Adding more unit tests to increase the test
	coverage.

2015-09-20  TJ Saunders <tj@castaglia.org>

	* src/netio.c, tests/api/netio.c, tests/api/response.c: More work on
	the unit tests, trying to expand on the test coverage.  Doing so
	found a few small bugs in the NetIO code.  Yay Coveralls!

2015-09-20  TJ Saunders <tj@castaglia.org>

	* README.md: Add a badge for the Coveralls coverage status.

2015-09-20  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Let's see how Coveralls does for us, shall we?

2015-09-20  TJ Saunders <tj@castaglia.org>

	* configure, configure.in: Support a 'coverage' option for the
	--enable-devel compile-time option, for enabling test coverage
	generation/reporting.

2015-09-11  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #154 from proftpd/ldap-libldap-tracing Enable more tracing of mod_ldap's operations by hooking into the
	LDAP…

2015-08-30  tjsaunders <tj@lyveminds.com>

	* doc/license.txt: Update license header years.

2015-08-30  tjsaunders <tj@lyveminds.com>

	* doc/contrib/mod_ldap.html: Update the mod_ldap docs to actually
	match the code now, folding in the changes mentioned in README.LDAP.

2015-08-30  tjsaunders <tj@lyveminds.com>

	* contrib/mod_ldap.c: Make this directive handler name match the
	directive name, for consistency.

2015-08-26  tjsaunders <tj@lyveminds.com>

	* NEWS: Update NEWS for fix for Bug#4202.

2015-08-26  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #152 from proftpd/facts-mlsd-crlf-bug4202 Bug#4202 - MLSD lines not properly terminated with CRLF.

2015-08-26  tjsaunders <tj@lyveminds.com>

	* : commit 62a4e24dcc37204168896ea35f379a1c0b952ff0 Author:
	tjsaunders <tj@lyveminds.com> Date:   Thu Aug 20 13:59:55 2015 -0700

2015-08-20  tjsaunders <tj@lyveminds.com>

	* modules/mod_xfer.c: There are a few conditions under which we
	don't really need to log about failing to set the corking socket
	option.

2015-08-18  tjsaunders <tj@lyveminds.com>

	* NEWS: Update NEWS with mention of fix for Bug#4201.

2015-08-18  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #150 from
	proftpd/sftp-scp-hiddenstores-cleanup-bug4201 Bug#4201 - HiddenStores temporary files not removed when exceeding
	qu…

2015-08-17  tjsaunders <tj@lyveminds.com>

	* contrib/mod_dnsbl/configure, contrib/mod_dnsbl/configure.in,
	contrib/mod_load/configure, contrib/mod_load/configure.in,
	contrib/mod_sftp/configure, contrib/mod_sftp/configure.in,
	contrib/mod_snmp/configure, contrib/mod_snmp/configure.in,
	contrib/mod_wrap2/configure, contrib/mod_wrap2/configure.in: Reorder
	the header/function checks in the module configure scripts, so that
	they happen after processing --with-includes and --with-libraries
	command-line options.  While this doesn't fix any current issue, it
	does set a better example for future modules; this was a problem for
	the e.g. mod_proxy configure script.

2015-08-16  tjsaunders <tj@lyveminds.com>

	* .gitattributes: Add manual overrides, to stop mis-representing the
	language used for ProFTPD and its modules.

2015-08-16  tjsaunders <tj@lyveminds.com>

	* src/main.c: Add note to future self, about handling DisplayConnect
	properly for denied connections.

2015-08-16  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #151 from proftpd/extlog-speedup ExtendedLog speedup by avoiding redundant strlen(3) calls

2015-08-16  tjsaunders <tj@lyveminds.com>

	* lib/sstrncpy.c, modules/mod_log.c,
	tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm: Speed up
	ExtendedLog writing by removing redundant strlen(3) calls on the
	logged string, and instead simply tracking the return values from
	snprintf et al.  Note that to do this, the sstrncpy() semantics needed to be
	consistent, which means NOT using strcpy(3); we want sstrncpy() to
	return the number of bytes actually copied, not what WOULD have been
	copied.

2015-08-16  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c, modules/mod_log.c,
	tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm: Fixed some
	regressions with handling of the DELE command's argument, and with
	mod_tls tagging the PASS command as a SEC logging class (when it
	should not).

2015-08-16  tjsaunders <tj@lyveminds.com>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_ifsession.pm: Checking in
	regression test for Bug#4199.

2015-08-15  tjsaunders <tj@lyveminds.com>

	* configure, configure.in: Update the -pthread/OpenSSL check, to
	catch regressions of Bug#3975 on e.g FreeBSD platforms, where the
	`openssl version` command doesn't emit the expected flags.

2015-08-15  tjsaunders <tj@lyveminds.com>

	* : commit 006b1f73db9421ca653c5b545765ee6b6893ff6d Author:
	tjsaunders <tj@lyveminds.com> Date:   Sat Aug 15 12:40:35 2015 -0700

2015-08-15  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sftp/scp.c: Make sure that we delete the HiddenStores
	file on SCP upload when either write(2) or close(2) fails; we were
	handling close(2) failures, but not write(2) failures properly.

2015-08-15  tjsaunders <tj@lyveminds.com>

	* : commit d99edbb036cba1269352e66f6c89b26c502b58dd Author:
	tjsaunders <tj@lyveminds.com> Date:   Fri Aug 14 10:47:04 2015 -0700

2015-08-13  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sftp/interop.c, contrib/mod_sftp/interop.h,
	contrib/mod_sftp/mod_sftp.c: Fix regression for SSH2 logins,
	introduced by the changes for handling the optional 'comments' field
	in the initial version exchange.  The initial version (exactly as
	sent) need to be used in the session ID/hash; the previous changes
	were trimming off the optional comment field, thus causing server
	and client to calculate different session IDs.

2015-08-13  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sftp/scp.c: Bug#4201 - HiddenStores temporary files
	not removed when exceeding quota using SCP.  Make sure to clean up the HiddenStores temporary file when there was
	an error, either when writing OR when closing the HiddenStores file
	(as when quota is exceeded).

2015-08-13  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sftp/kex.c: Remove some unnecessary casts; fix a minor
	memory leak on error conditions.

2015-08-12  tjsaunders <tj@lyveminds.com>

	* src/main.c, src/signals.c: Clear out the EINTR errno value in a
	few more places.

2015-08-12  tjsaunders <tj@lyveminds.com>

	* src/main.c: Make sure to clear out any cached errno, too.

2015-08-12  tjsaunders <tj@lyveminds.com>

	* modules/mod_facts.c, tests/t/lib/ProFTPD/Tests/Commands/MLSD.pm: 
	Checkpointing work on investigating a possible regression with
	regard to MLSD line formatting, i.e.  missing proper CRLF
	terminations.

2015-08-12  tjsaunders <tj@lyveminds.com>

	* src/main.c: Make sure to clear any possibly-cached errno value in
	the main select() loop.

2015-08-10  tjsaunders <tj@lyveminds.com>

	* src/timers.c: Style nit; no functional change.

2015-08-10  tjsaunders <tj@lyveminds.com>

	* src/trace.c, tests/api/trace.c: Some tweaks to the Trace API,
	trying to reduce redundancy.

2015-08-10  tjsaunders <tj@lyveminds.com>

	* src/parser.c, tests/api/etc/str/utf8-space.txt, tests/api/str.c: 
	If we fail to parse some configuration directives, check for any
	non-ASCII characters in the directive name.  This recently tripped
	me up with diagnosing a broken system; now check for, and log, such
	things.

2015-08-10  tjsaunders <tj@lyveminds.com>

	* tests/t/lib/ProFTPD/Tests/Config/HideFiles.pm: Update integration
	test, broken by change for Bug#3990.

2015-08-10  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #149 from proftpd/core-ptr-cast Address some pointer cast alignment issues by defining the
	cmd_rec.ar…

2015-08-10  tjsaunders <tj@lyveminds.com>

	* modules/mod_cap.c: See what happens when you change your mind
	about variable names partway through? Sigh.

2015-08-10  tjsaunders <tj@lyveminds.com>

	* modules/mod_core.c: Quell a few more compiler warnings about
	pointer casts.

2015-08-10  tjsaunders <tj@lyveminds.com>

	* lib/tpl.c: Remove unused variables.

2015-08-10  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sql_passwd.c, modules/mod_cap.c: Fixing some build
	issues/warnings.

2015-08-10  tjsaunders <tj@lyveminds.com>

	* src/main.c: Quell another compiler warning about pointer casts.

2015-08-10  tjsaunders <tj@lyveminds.com>

	* contrib/mod_copy.c, contrib/mod_deflate.c, contrib/mod_exec.c,
	contrib/mod_ifsession.c, contrib/mod_ifversion.c,
	contrib/mod_ldap.c, contrib/mod_log_forensic.c,
	contrib/mod_quotatab.c, contrib/mod_quotatab_sql.c,
	contrib/mod_radius.c, contrib/mod_readme.c, contrib/mod_rewrite.c,
	contrib/mod_sftp/auth-hostbased.c, contrib/mod_sftp/auth-kbdint.c,
	contrib/mod_sftp/auth-password.c,
	contrib/mod_sftp/auth-publickey.c, contrib/mod_sftp/auth.c,
	contrib/mod_sftp/fxp.c, contrib/mod_sftp/mod_sftp.c,
	contrib/mod_sftp/scp.c, contrib/mod_sftp_sql.c,
	contrib/mod_shaper.c, contrib/mod_site_misc.c,
	contrib/mod_snmp/mod_snmp.c, contrib/mod_sql.c, contrib/mod_tls.c,
	contrib/mod_wrap2/mod_wrap2.c, contrib/mod_wrap2_sql.c,
	include/dirtree.h, include/proftpd.h, lib/json.c,
	modules/mod_auth.c, modules/mod_auth_file.c,
	modules/mod_auth_pam.c, modules/mod_core.c, modules/mod_ctrls.c,
	modules/mod_dso.c, modules/mod_facts.c, modules/mod_log.c,
	modules/mod_ls.c, modules/mod_site.c, modules/mod_xfer.c,
	src/cmd.c, src/data.c, src/dirtree.c, src/main.c, src/parser.c,
	tests/t/lib/ProFTPD/Tests/Config/Order.pm: Address some pointer cast
	alignment issues by defining the cmd_rec.argv member to be "void
	**", rather than "char **".  Void pointers are guaranteed to be
	large enough to hold pointers to anything, where as char pointers
	are not.  And we sometimes stash non-char data in the cmd_rec.argv
	area.  This looks like a fair amount of code churn; mostly it's addressing
	compiler warnings by providing explicit casts to char * in most
	places (e.g. logging) where the variadic function cannot easily tell
	the type.

2015-08-09  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sftp/kex.c: For some reason, the ordering in which the
	logging of the NEWKEYS command makes a difference.  I suspect it's
	the order/amount of memory read out of the pool.  By logging NEWKEYS
	after setting the session keys, some rather strange behaviors are
	alleviated.

2015-08-09  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sftp/auth.c: Fix possible segfault (due to null
	pointer) when the SSH2 authentication method succeeds, but
	subsequent login fails.

2015-08-08  TJ Saunders <tj@castaglia.org>

	* tests/api/str.c: Slightly better demonstration of
	pr_str_get_word()'s handling of quoted strings.

2015-08-08  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #148 from proftpd/tls-shutdown-buffering When shutting down the TLS session, we need to send a 'close_notify'
	…

2015-08-07  tjsaunders <tj@lyveminds.com>

	* NEWS: Update NEWS for fix for Bug#4198.

2015-08-07  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #147 from proftpd/facts-cdir-bug4198 Bug#4198 - MLSD/MLST fact type "cdir" is incorrectly used for the
	current working directory.

2015-08-06  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c, doc/contrib/mod_tls.html: Provide an
	environment variable for the requested SNI, if present.

2015-08-06  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c, doc/contrib/mod_tls.html: Provide an
	environment variable for the requested SNI, if present.

2015-08-06  tjsaunders <tj@lyveminds.com>

	* tests/t/lib/ProFTPD/Tests/Commands/MLSD.pm,
	tests/t/lib/ProFTPD/Tests/Commands/MLST.pm: Checking in the
	accompanying regression tests for Bug#4198.

2015-08-06  tjsaunders <tj@lyveminds.com>

	* modules/mod_facts.c: Bug#4198 - MLSD/MLST fact type "cdir" is
	incorrectly used for the current working directory.

2015-08-05  tjsaunders <tj@lyveminds.com>

	* modules/mod_xfer.c: Better handling of errno values when adjusting
	process priorities.

2015-08-05  tjsaunders <tj@lyveminds.com>

	* tests/api/rlimit.c: Missed a couple of RLimit test cases needing
	the conditional check.

2015-08-05  tjsaunders <tj@lyveminds.com>

	* contrib/mod_rewrite.c, contrib/mod_wrap2_file.c,
	contrib/mod_wrap2_sql.c: Quell more compiler warnings about shadowed
	global variables.

2015-08-05  tjsaunders <tj@lyveminds.com>

	* tests/api/filter.c: Add some additional assertions to quell
	compiler warnings about unused variables (and make the tests
	better).

2015-08-05  tjsaunders <tj@lyveminds.com>

	* tests/api/rlimit.c: Fixing up platform-sensitive tests for e.g.
	travis-ci builds.

2015-08-05  tjsaunders <tj@lyveminds.com>

	* tests/api/netio.c: Removing unused variable.

2015-08-05  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sql_postgres.c: Quell compiler warning about shadowed
	global variable; stylistic nits.  No functional change.

2015-08-05  tjsaunders <tj@lyveminds.com>

	* contrib/mod_deflate.c: Forgot to update mod_deflate for the
	changed NetIO API signature change.

2015-08-05  tjsaunders <tj@lyveminds.com>

	* src/scoreboard.c: Quell compiler warning about unreached function
	call.

2015-08-05  tjsaunders <tj@lyveminds.com>

	* tests/Makefile.in, tests/api/env.c, tests/api/help.c,
	tests/api/rlimit.c, tests/api/tests.c, tests/api/tests.h: Adding API
	tests for the RLimit API.  Adding forgotten Help API tests.

2015-08-05  tjsaunders <tj@lyveminds.com>

	* src/help.c: Fix the terminating condition for adding help items;
	the previous end-of-loop condition was too fragile, and not
	accurate.

2015-08-05  tjsaunders <tj@lyveminds.com>

	* src/help.c, src/response.c, tests/Makefile.in,
	tests/api/response.c, tests/api/tests.c, tests/api/tests.h: Added
	some tests for the Help API, which sussed out a few very minor
	issues.

2015-08-04  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c: Fix a few nits in the PSK handling; no
	functional change.

2015-08-04  tjsaunders <tj@lyveminds.com>

	* src/dirtree.c: When checking limits, make sure that we actually
	have an authenticated user/ group before checking for
	per-user/per-group limits.  With modules such as mod_proxy, this may
	not always be true.

2015-08-03  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sftp/mod_sftp.c: Make the ban messages emitted to SSH2
	clients a little more descriptive.

2015-08-03  tjsaunders <tj@lyveminds.com>

	* src/log.c: If the DebugLevel directive is used to set the debug
	level to anything higher than 0, then automatically assume that the
	SyslogLevel is DEBUG, not NOTICE.  This helps in debugging
	configurations.

2015-08-03  tjsaunders <tj@lyveminds.com>

	* src/trace.c: Turns out that the trace logging code needs the same
	over-long log line handling fixes as the main logging code.

2015-08-03  tjsaunders <tj@lyveminds.com>

	* src/log.c: Better handling of over-long log lines.

2015-08-03  tjsaunders <tj@lyveminds.com>

	* src/log.c: Increase (and fix the handling of) the max log line
	length.

2015-08-03  tjsaunders <tj@lyveminds.com>

	* doc/contrib/mod_tls.html: Some minor updates to the mod_tls docs.

2015-08-02  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c: When cleaning up OpenSSL-related code, mod_tls
	needs to know that mod_proxy also uses OpenSSL (and thus should skip
	cleanup if that module is in use).

2015-07-31  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c: Fix logging of selected ALPN.

2015-07-30  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c, include/netio.h, src/netio.c: Allow modules
	registering NetIO objects to customise the registered NetIO owner
	name, if they wish.

2015-07-28  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c: Fixed a few nits in the cert-checking routine.

2015-07-28  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c: We retrieved the data connection SSL object too
	early.

2015-07-28  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c: Fix some timing-related trace logging.

2015-07-28  tjsaunders <tj@lyveminds.com>

	* doc/contrib/mod_tls.html: Mention, in the TLSSessionCache
	description, that mod_tls aggressively prunes its session cache of
	expired sessions by flushing the cache on each session exit.

2015-07-28  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c: Handle the edge cases where TLS read/write
	returns negative values; we don't want that to artificially affect
	the total raw IO values.

2015-07-28  tjsaunders <tj@lyveminds.com>

	* NEWS: Update NEWS with fix for Bug#4097.

2015-07-28  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #45 from
	proftpd/sftp-small-rsa-hostkey-rekeying-bug4097 Bug#4097 -  SSH rekey fails when using RSA hostkey smaller than 2048
	bits.

2015-07-27  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #145 from proftpd/ascii-oob-read-bug4195 Bug#4195 - Handle empty string inputs into ASCII CRLF translation
	rou…

2015-07-26  tjsaunders <tj@lyveminds.com>

	* src/ascii.c: Bug#4195 - Handle empty string inputs into ASCII CRLF
	translation routine.

2015-07-25  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #144 from
	proftpd/fsio-dircat-oob-read-bug4194 Bug#4194: Add more checks for empty paths in pr_fs_dircat().

2015-07-25  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c: Fix broken build by including the necessary
	OpenSSL header.

2015-07-25  tjsaunders <tj@lyveminds.com>

	* src/fsio.c, tests/api/fsio.c: If either of the arguments to
	pr_fs_dircat() are empty strings, be consistent and append a "/"
	character, just as is done when BOTH arguments are empty strings.

2015-07-25  tjsaunders <tj@lyveminds.com>

	* src/fsio.c, tests/api/fsio.c: Bug#4194: Add more checks for empty
	paths in pr_fs_dircat().

2015-07-25  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c: Better handling, when logging OpenSSL
	diagnostics, of the protocol record callbacks.

2015-07-25  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #143 from proftpd/tests-oob-read-bug4193 Bug#4193 - Out of bounds read in tests/api/str.c.

2015-07-25  tjsaunders <tj@lyveminds.com>

	* tests/api/ascii.c: Fix previous stupidity.

2015-07-25  tjsaunders <tj@lyveminds.com>

	* tests/api/ascii.c, tests/api/cmd.c: Quell some compiler warnings
	in the unit tests, spotted while still trying to figure out why
	travis-ci tests are failing (but they pass locally).

2015-07-25  tjsaunders <tj@lyveminds.com>

	* tests/api/ascii.c: Triaging a failing unit test in travis-ci.

2015-07-25  tjsaunders <tj@lyveminds.com>

	* tests/api/str.c: Bug#4193 - Out of bounds read in tests/api/str.c.

2015-07-25  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c: Tweaking/polishing the OpenSSL msg/info
	callbacks.

2015-07-25  tjsaunders <tj@lyveminds.com>

	* doc/contrib/mod_ban.html: Remove duplicate/extraneous slash in
	example config.

2015-07-25  tjsaunders <tj@lyveminds.com>

	* doc/contrib/mod_ban.html: Minor tweak.

2015-07-24  tjsaunders <tj@lyveminds.com>

	* : commit 4776466b62889dee9a67171c6dbd317822191595 Author:
	tjsaunders <tj@lyveminds.com> Date:   Fri Jul 24 13:41:12 2015 -0700

2015-07-24  tjsaunders <tj@lyveminds.com>

	* modules/mod_log.c: Require a non-zero length LogFormat name.

2015-07-24  tjsaunders <tj@lyveminds.com>

	* modules/mod_log.c: Slightly better handling of using the default
	LogFormat, without necessarily blocking configs that want to
	use/override the "default" nickname themselves.

2015-07-24  tjsaunders <tj@lyveminds.com>

	* modules/mod_log.c: Fix the registration of the "default"
	LogFormat.

2015-07-24  tjsaunders <tj@lyveminds.com>

	* doc/howto/TLS.html: Adding TLS FAQ, from forums, about
	TLSVerifyDepth.

2015-07-23  tjsaunders <tj@lyveminds.com>

	* modules/mod_core.c: Better string handling, to make localization
	easier.

2015-07-23  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c: Fix the handling of OpenSSL's
	SSL_SESS_CACHE_OFF value (which is 0x0, and thus not usable for the
	bit-checking mod_tls was doing).  Enhance the trace logging around TLS handshaking.

2015-07-23  tjsaunders <tj@lyveminds.com>

	* src/inet.c: Be a little more paranoid in pr_inet_close(), and only
	try to destroy a non-NULL pool pointer.  (Although destroy_pool()
	does a NULL check, so this is more for clarity than anything else.)

2015-07-22  tjsaunders <tj@lyveminds.com>

	* include/netio.h, src/netio.c: Include the direction/mode of the
	stream in the NetIO trace messages.

2015-07-22  tjsaunders <tj@lyveminds.com>

	* modules/mod_core.c: Tweaks to the handling of HOST commands in
	relation to FTPS.  Stylistic nits.

2015-07-22  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c, include/cmd.h, src/cmd.c: Add missing
	PR_CMD_HOST_ID value, and use it in e.g. mod_tls, to allow the HOST
	command before AUTH is used.

2015-07-22  tjsaunders <tj@lyveminds.com>

	* src/netio.c: Add trace logging of which custom (or not) NetIO is
	being used for the network operations.

2015-07-21  tjsaunders <tj@lyveminds.com>

	* src/pool.c: Allow unregistering of any/all cleanups by handling a
	NULL callback value.

2015-07-21  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c: Quell some compiler warnings, and propagate
	errno appropriately in some cases.

2015-07-20  tjsaunders <tj@lyveminds.com>

	* src/response.c: Add some trace logging for when the Response API
	is blocked, for debugging.

2015-07-20  tjsaunders <tj@lyveminds.com>

	* include/pool.h, src/pool.c, tests/api/array.c: Create an
	array_cat2() function which provides a nice return value;
	array_cat() then just becomes a void wrapper around array_cat2().

2015-07-19  TJ Saunders <tj@castaglia.org>

	* src/netaddr.c: If the caller wants to know all of the addresses
	resolved via pr_netaddr_get_addr(), then actually walk all of the
	struct addrinfo values provided by getaddrinfo(3) and provision the
	caller-provided list.

2015-07-19  TJ Saunders <tj@castaglia.org>

	* src/table.c: Stylistic nits; no functional changes.

2015-07-19  TJ Saunders <tj@castaglia.org>

	* doc/contrib/mod_sftp.html: Minor tweaks/updates to the mod_sftp
	docs.

2015-07-18  TJ Saunders <tj@castaglia.org>

	* doc/modules/mod_core.html: Typos.

2015-07-18  TJ Saunders <tj@castaglia.org>

	* doc/contrib/mod_snmp.html: Update the mod_snmp docs as to where
	the most recent code for mod_snmp can be found.

2015-07-18  TJ Saunders <tj@castaglia.org>

	* include/netaddr.h, src/ftpdctl.c, src/netaddr.c,
	tests/api/netaddr.c: Add new Netaddr API functions for clearing
	specific cached IP addresses, DNS names, as opposed to entire
	caches.

2015-07-17  tjsaunders <tj@lyveminds.com>

	* doc/modules/mod_auth_unix.html: Add mod_auth_unix FAQ about
	`passwd -d' and password-less logins.

2015-07-17  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/mod_sftp.c: Style nit; no functional change.

2015-07-17  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sftp/kex.c: Add some trace logging into the function
	which determines the DH size to request, for debugging.

2015-07-17  tjsaunders <tj@lyveminds.com>

	* : commit aabf243ce6b52e6817509922d4889dd7e6cd63d4 Author:
	tjsaunders <tj@lyveminds.com> Date:   Fri Jul 17 10:36:08 2015 -0700

2015-07-17  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #142 from proftpd/mysql-utf8-bug4191 Bug#4191 - Use "utf8mb4" for MySQL, not just "utf8", if the version
	of

2015-07-16  tjsaunders <tj@lyveminds.com>

	* include/log.h, include/options.h, src/xferlog.c: Make the default
	mode for the TransferLog be a PR_TUNABLE option.

2015-07-15  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sql_mysql.c: Bug#4191 - Use "utf8mb4" for MySQL, not
	just "utf8", if the version of MySQL is new enough, for UTF8
	encodings.

2015-07-11  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/crypto.c, contrib/mod_sftp/mod_sftp.c,
	contrib/mod_sftp/mod_sftp.h.in, contrib/mod_tls.c: I was going to
	provide configuration directives, for mod_tls and mod_sftp, to
	configure the path to the OpenSSL .cnf file that should be used.
	Due to the initialization timing, though, this is a path to do via
	configuration directives.  Instead, I will simply document the use
	of the SetEnv directive, and setting the OPENSSL_CONF environment
	variable, in conjunction with adding calls to OPENSSL_config(3) in
	these respective modules.

2015-07-09  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/crypto.c, contrib/mod_tls.c: Use the OpenSSL
	config file; it's probably used by the configured ENGINE.

2015-07-07  TJ Saunders <tj@castaglia.org>

	* configure, configure.in: Adding a few more compiler warnings, when
	--enable-devel is used.

2015-07-07  TJ Saunders <tj@castaglia.org>

	* modules/mod_auth_pam.c: Finally clean up compiler warnings which
	had been bugging me for quite a while.

2015-07-07  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c: Quell some compiler warnings.

2015-07-07  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/kex.c: When computing the size of the DH needed,
	we also need to pay attention to the negotiated cipher block sizes,
	not just the cipher key lengths.

2015-07-07  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/kex.c: Remove now-unused macro value.

2015-07-07  TJ Saunders <tj@castaglia.org>

	* doc/contrib/mod_sftp_sql.html: Remove now-unused keywords.

2015-07-07  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp_sql.pm: Minor tweaks
	when testing out some use cases.

2015-07-07  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/keystore.c: Fix the trace log message when
	handling SFTPAuthorizedUserKeys to properly include the store type.

2015-07-07  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/auth.c, contrib/mod_sftp/channel.c,
	contrib/mod_sftp/service.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: When constructing the
	cmd_recs, do it properly, so that ExtendedLog entries, e.g. for the
	%r variable, log the request properly.  The cmd_recs allocated did
	not set the correct cmd_rec.argc value.

2015-07-07  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp_sql.c: Remove extraneous (and misleading) trace
	logging.

2015-07-02  TJ Saunders <tj@castaglia.org>

	* src/dirtree.c: Found a place where we should have been using
	"_bind_", not just "_bind".

2015-07-01  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/TestSuite/Utils.pm: More testsuite help when
	writing out subsections of e.g. <IfModule> config sections.

2015-07-01  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #141 from proftpd/core-class-add-note Add a function for attaching notes to a class, e.g. from a config
	dir…

2015-07-01  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/kex.c: Always make sure we're using this kex's
	pool, not the overall Kex API pool, to prevent memory leaks.

2015-06-30  tjsaunders <tj@lyveminds.com>

	* : commit 98541b4a198b3f49721bd8a7d6d1894e52981623 Author:
	tjsaunders <tj@lyveminds.com> Date:   Tue Jun 30 10:06:54 2015 -0700

2015-06-30  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/mod_sftp.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Be more
	defensive/picky about the client version string handling from
	connecting SSH2 clients.

2015-06-29  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c: Impose a limit of 512K on the size of a
	single SFTP packet.  For comparison, OpenSSH imposes a 256K limit.

2015-06-29  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c: Impose a limit (much higher than ever
	expected) on the number of EXTENDED attributes that we'll read from
	an SFTP client.

2015-06-29  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c: Be more consistent about the handling of
	errno values, especially across function calls.

2015-06-29  tjsaunders <tj@lyveminds.com>

	* RELEASE_NOTES: Update release notes to mention SFTP hardlink
	extension support.

2015-06-29  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #140 from proftpd/sftp-hardlink-extension Support the SFTP "hardlink@openssh.com" extension.

2015-06-29  tjsaunders <tj@lyveminds.com>

	* RELEASE_NOTES: Update release notes for LINK_COUNT SFTP STAT
	support.

2015-06-29  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #139 from proftpd/sftp-hardlink-stat-attr Support the SFTP STAT link-count attribute if clients are using a
	new…

2015-06-26  TJ Saunders <tj@castaglia.org>

	* configure, configure.in: More tweaks to the module build summary
	display, to properly display shared modules.

2015-06-26  TJ Saunders <tj@castaglia.org>

	* NEWS, RELEASE_NOTES: Update NEWS, release notes for Bug#4153.

2015-06-26  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #137 from proftpd/sftp-multi-auth-bug4153 Bug#4153 - Support requiring multiple SSH authentication methods

2015-06-26  tjsaunders <tj@lyveminds.com>

	* : commit 250ec7f47628c1eb0b518b1311b709860c78ba0e Author:
	tjsaunders <tj@lyveminds.com> Date:   Fri Jun 26 13:04:34 2015 -0700

2015-06-26  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #138 from
	proftpd/tls-protocol-exclusion-bug4189 Bug#4189 - Support protocol exclusion via TLSProtocol directive.

2015-06-25  tjsaunders <tj@lyveminds.com>

	* : commit d77feab0d434db2273bc16074f75106646a17d90 Author:
	tjsaunders <tj@lyveminds.com> Date:   Thu Jun 25 15:28:11 2015 -0700

2015-06-25  tjsaunders <tj@lyveminds.com>

	* : commit 4372ae9463913ca03ba24b6c15dd590699a5989d Author:
	tjsaunders <tj@lyveminds.com> Date:   Thu Jun 25 15:26:52 2015 -0700

2015-06-25  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sftp/auth.c, contrib/mod_sftp/auth.h,
	contrib/mod_sftp/mod_sftp.c: Guard against auth chains which are
	unsupportable, i.e. chains that have "password" or "hostbased"
	appearing multiple times.

2015-06-25  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sftp/auth-kbdint.c: Just as we require different
	publickey authentications, we now require different
	keyboard-interactive driver authentications in auth chains.

2015-06-24  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/auth.h: Found another place to use auth "chain"
	instead of "list".

2015-06-24  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/auth.c, contrib/mod_sftp/mod_sftp.c: Use "auth
	chain" terminology more consistently throughout the code.

2015-06-24  tjsaunders <tj@lyveminds.com>

	* .gitignore: Ignore a few more file extensions.

2015-06-24  tjsaunders <tj@lyveminds.com>

	* doc/contrib/mod_sftp.html: Update mod_sftp SFTPAuthMethods
	description for new auth chain syntax.

2015-06-24  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sftp/auth-hostbased.c,
	contrib/mod_sftp/auth-kbdint.c, contrib/mod_sftp/auth-password.c,
	contrib/mod_sftp/auth-publickey.c, contrib/mod_sftp/auth.c,
	contrib/mod_sftp/auth.h, contrib/mod_sftp/mod_sftp.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Implemented checking
	of the configured auth chains at startup, to catch chains that use a
	method (e.g. "hostbased") that cannot be supported (e.g.  no
	SFTPAuthorizedHostKeys configured).  Implemented restriction that publickey authentication requests must
	use different keys; duplicate keys will be rejected.  This supports
	authentication chains such as "publickey+publickey".

2015-06-24  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/auth.c, contrib/mod_sftp/auth.h,
	contrib/mod_sftp/mod_sftp.c: Use the term "auth chain" rather than
	"auth list", as "chain" is, in my mind, more accurate.

2015-06-24  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/auth.c: Fix the handling of the next
	authentication methods in the chain.

2015-06-23  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/auth.c, contrib/mod_sftp/mod_sftp.c: Catch
	unknown/unsupported authentication methods properly, and report them
	properly, too.

2015-06-23  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/auth.c: Catch other misconfigurations such as
	double '+' characters in an SFTPAuthMethods list.

2015-06-23  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/auth.c: Fix the check used for detecting trailing
	'+' characters in a SFTPAuthMethods list.

2015-06-23  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/auth.c, contrib/mod_sftp/auth.h,
	contrib/mod_sftp/kbdint.h, contrib/mod_sftp/mod_sftp.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Checking in the bulk
	of the work needed for Bug#4153.  There is still a fair amount of
	testing to be done, but the initial tests are looking good.

2015-06-08  TJ Saunders <tj@castaglia.org>

	* doc/modules/mod_auth.html, modules/mod_auth.c, src/regexp.c,
	tests/t/lib/ProFTPD/Tests/Config/AnonRejectPasswords.pm: Make it
	possible to use the AnonRejectPasswords directive to require
	email-like anonymous passwords.

2015-06-08  TJ Saunders <tj@castaglia.org>

	* NEWS: Update NEWS for fix for Bug#4139.

2015-06-08  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #134 from
	proftpd/auth-allow-empty-password-bug4139 Bug#4139 - Support rejecting empty passwords.

2015-06-08  TJ Saunders <tj@castaglia.org>

	* contrib/mod_ban.c, doc/contrib/mod_ban.html: Document the banning
	of hosts using empty passwords.

2015-06-08  TJ Saunders <tj@castaglia.org>

	* RELEASE_NOTES, doc/modules/mod_auth.html, modules/mod_auth.c,
	tests/t/lib/ProFTPD/Tests/Logins.pm: Add integration tests and
	documentation.

2015-06-08  TJ Saunders <tj@castaglia.org>

	* contrib/mod_ban.c, contrib/mod_sftp/auth-password.c,
	modules/mod_auth.c: Bug#4139 - Support rejecting empty passwords.

2015-06-08  TJ Saunders <tj@castaglia.org>

	* NEWS: Updating NEWS for Bug#4151.

2015-06-08  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #132 from
	proftpd/data-ascii-conversion-bug4151 Bug#4151 - FTP ASCII mode conversion algorithm is painfully slow.

2015-06-08  TJ Saunders <tj@castaglia.org>

	* Make.rules.in, include/ascii.h, include/data.h, src/ascii.c,
	src/data.c, tests/Makefile.in, tests/api/ascii.c, tests/api/data.c,
	tests/api/tests.c, tests/api/tests.h,
	tests/t/lib/ProFTPD/Tests/Commands/STOR.pm, utils/utils.h: Refactor
	the ASCII CRLF handling code into its own API, unentangling it from
	the implementation of the data transfers.  This makes it much easier
	to unit test.  Added those unit tests, including a regression test for uploading a
	file as ASCII.

2015-06-05  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #133 from maytechnet/master Fix small copy/paste leftower

2015-06-04  TJ Saunders <tj@castaglia.org>

	* include/data.h, src/data.c, tests/api/data.c: Make the FTP ASCII
	translation function symbols publicly visible, for accessing
	directly for unit testing.  Removed misleading comment; history is what git is for.  Moved
	potentially expensive pr_signals_handle() outside of the
	byte-copying loop; we will handle any potential SIGSEGV signals
	after the loop.

2015-06-04  TJ Saunders <tj@castaglia.org>

	* tests/api/data.c: Not yet ready for these tests to be run.

2015-06-04  TJ Saunders <tj@castaglia.org>

	* tests/Makefile.in, tests/api/data.c, tests/api/stubs.c,
	tests/api/tests.c, tests/api/tests.h: Start working on unit tests
	for the Data API.  This adds the build glue to do so; now to fill in
	the testcases.

2015-06-03  TJ Saunders <tj@castaglia.org>

	* src/data.c: Bug#4151 - FTP ASCII mode conversion algorithm is
	painfully slow.

2015-06-03  TJ Saunders <tj@castaglia.org>

	* NEWS: Updated NEWS for fix for Bug#4188.

2015-06-03  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #131 from proftpd/geoip-multi-expr-bug4188 Bug#4188 - Support filtering based on country code and regional code
	in

2015-06-03  TJ Saunders <tj@castaglia.org>

	* NEWS: Update NEWS for fix for Bug#4167.

2015-06-03  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #98 from proftpd/core-crlf-in-path-bug4167 Bug#4167 - CR/LF characters are not supported in filenames.

2015-06-03  TJ Saunders <tj@castaglia.org>

	* src/main.c: Typo in comment; no functional change.

2015-06-03  TJ Saunders <tj@castaglia.org>

	* : commit 621000469e1f0b11486d2188f50eee87a33bb280 Author: TJ
	Saunders <tj@castaglia.org> Date:   Wed Jun 3 22:30:51 2015 -0700

2015-06-02  TJ Saunders <tj@castaglia.org>

	* doc/contrib/mod_geoip.html: Update the mod_geoip documentation
	with FAQ describing the use case of Bug#4188.

2015-06-02  TJ Saunders <tj@castaglia.org>

	* contrib/mod_geoip.c: Bug#4188 - Support filtering based on country
	code and regional code in mod_geoip.

2015-05-31  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/interop.c: Per this forums post, at least one
	SSH2 client identifying itself as J2SSH does not support/handle
	rekey requests properly:   https://forums.proftpd.org/smf/index.php/topic,11757.0.html Thus add it to the builtin interop lists as a non-rekeying client.

2015-05-31  TJ Saunders <tj@castaglia.org>

	* NEWS: Updated NEWS for fix of Bug#4187.

2015-05-31  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #129 from proftpd/geoip-table-loading-bug4187 Bug#4187 - mod_geoip does not load all of the GeoIPTables properly.

2015-05-30  TJ Saunders <tj@castaglia.org>

	* contrib/mod_geoip.c: Bug#4187 - mod_geoip does not load all of the
	GeoIPTables properly.

2015-05-28  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #128 from proftpd/tls-adaptive-buffering Implement adaptive tuning of the TLS record/buffer size for data
	tran…

2015-05-27  TJ Saunders <tj@castaglia.org>

	* doc/modules/mod_dso.html: Adding mod_dso FAQ, from the online
	forums.

2015-05-27  tjsaunders <tj@lyveminds.com>

	* NEWS, contrib/dist/rpm/proftpd.spec, include/version.h: Update
	files for rc2 status.

2015-05-27  TJ Saunders <tj@castaglia.org>

	* NEWS, contrib/dist/rpm/proftpd.spec, include/version.h: Warming up
	for a release of 1.3.6rc1.

2015-05-27  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #80 from proftpd/core-schmod-cifs-bug4134 Bug#4134 - Unable to create folders using FTP on a CIFS mounted
	share: "...

2015-05-25  TJ Saunders <tj@castaglia.org>

	* RELEASE_NOTES, contrib/mod_sftp/kex.c,
	contrib/mod_sftp/mod_sftp.c, contrib/mod_sftp/mod_sftp.h.in,
	doc/contrib/mod_sftp.html: Update mod_sftp to avoid weak DH groups,
	per Bug#4184.

2015-05-22  tjsaunders <tj@lyveminds.com>

	* modules/mod_auth.c: Attempt to address Debian Bug#717235:   https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=717235

2015-05-22  tjsaunders <tj@lyveminds.com>

	* configure, configure.in: Fix the build summary, so that it
	displays modules, like mod_sftp or mod_snmp, which have their own
	module directories.  Also skip the module listing if there are no
	static (or no shared) modules to list in the summary.

2015-05-22  tjsaunders <tj@lyveminds.com>

	* RELEASE_NOTES: Mention the new ServerAlias directive in the
	release notes, too.

2015-05-22  tjsaunders <tj@lyveminds.com>

	* NEWS, RELEASE_NOTES, doc/modules/mod_core.html: Update NEWS,
	release notes for HOST support.  Add docs for the new ServerAlias
	directive.

2015-05-22  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #126 from proftpd/core-host-cmd-bug3289 Bug#3289 - Support the HOST command

2015-05-22  TJ Saunders <tj@castaglia.org>

	* doc/howto/TLS.html: Tweaks to the TLS FAQ for FZ.

2015-05-21  TJ Saunders <tj@castaglia.org>

	* doc/howto/TLS.html: Add FAQs about FTPS connection issues with
	FileZilla, lftp to the TLS howto.

2015-05-21  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #125 from proftpd/tls-weak-dh-bug4184 Bug#4184 - Remove support for "weak" Diffie-Hellman groups.

2015-05-12  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls.c: Nit.

2015-05-12  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Commands/HOST.pm: Adding regression test
	showing successful login to name-based vhost.

2015-05-04  TJ Saunders <tj@castaglia.org>

	* : commit 8e6f14aa2f6141b632b48e1b063dde688cbeec62 Merge: 3b93982
	64f28f1 Author: TJ Saunders <tj@castaglia.org> Date:   Mon May 4
	19:34:33 2015 -0700

2015-05-01  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #124 from proftpd/tls-ssl-buffer-sizing Tweak the SSL write buffer/record sizes during TLS handshakes, to
	try to

2015-04-30  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #123 from proftpd/tls-npn-alpn Support/use the ALPN/NPN TLS extensions in mod_tls

2015-04-30  tjsaunders <tj@lyveminds.com>

	* config.h.in, configure, configure.in, contrib/mod_tls.c: Add
	support for the NPN and ALPN extensions to mod_tls, to support any
	FTPS clients which might use these as heuristics for determining
	when to use TLS False Start (e.g. Chrome/Firefox).

2015-04-29  tjsaunders <tj@lyveminds.com>

	* tests/t/lib/ProFTPD/Tests/Commands/HOST.pm: Tweaks.

2015-04-29  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c: Stylistic nits, compiler warnings; no
	functional change.

2015-04-29  tjsaunders <tj@lyveminds.com>

	* src/bindings.c: Fix null pointer derefence encountered during
	regression testing the HOST command.

2015-04-29  tjsaunders <tj@lyveminds.com>

	* doc/howto/Tracing.html, src/modules.c, src/trace.c: Add a 'module'
	trace channel, for tracing the Module API.

2015-04-29  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c, modules/mod_core.c: Implement handling of the
	TLS SNI extension, so that we can then double-check that (if used)
	against the provided HOST command (and vice versa).

2015-04-29  tjsaunders <tj@lyveminds.com>

	* include/bindings.h, src/bindings.c: Fix bad merge.

2015-04-29  tjsaunders <tj@lyveminds.com>

	* : commit 2bde9ba89eb007778a940f1eae60f2fd22102195 Author:
	tjsaunders <tj@lyveminds.com> Date:   Wed Apr 29 14:46:09 2015 -0700

2015-04-29  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #122 from proftpd/tls-session-reuse-bug4178 Bug#4178: When accepting a TLS connection for data transfers,
	disable th...

2015-04-28  tjsaunders <tj@lyveminds.com>

	* src/data.c: Fix segfault due to null pointer dereference.

2015-04-28  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c: Use the SSL options to work around a Safari
	ECDSA bug.

2015-04-27  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls.c: Enable SSL session cache flushing on session
	exit, to keep that cache as groomed as possible.

2015-04-27  TJ Saunders <tj@castaglia.org>

	* .gitignore: Ignore a few more files/paths.

2015-04-27  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls.c: Style nits; no functional change.

2015-04-26  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c: Refactor the random PSK generation code into a
	single helper function, for good style/DRY princicple.

2015-04-26  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c: Fix the handling of the TLSECDHCurve directive.

2015-04-26  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #121 from proftpd/tls-psk-support Bug#4174 - Support for TLS-PSK (pre-shared keys)

2015-04-26  tjsaunders <tj@lyveminds.com>

	* NEWS, RELEASE_NOTES, doc/contrib/mod_tls.html: Adding
	documentation for the new TLSPreSharedKey directive.

2015-04-26  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c: Finish implementing TLS-PSK support.

2015-04-25  tjsaunders <tj@lyveminds.com>

	* : commit 569ebe9163e7d5cedcbf54215ced625a77aeab6b Merge: 9f1078f
	46c8a0c Author: TJ Saunders <tj@castaglia.org> Date:   Sat Apr 25
	19:30:49 2015 -0700

2015-04-25  tjsaunders <tj@lyveminds.com>

	* doc/contrib/mod_tls.html: Improve the TLSECDHCurve docs by
	including the openssl command to use, to see the full list of
	supported curves.

2015-04-25  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c: Make sure that mod_tls compiles properly when
	using OpenSSL-1.0.2 or later.

2015-04-25  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c, doc/contrib/mod_tls.html: Better error
	reporting if the configured curve name isn't known.  Add TLSOption
	for disabling auto-ECDH negotiation behavior, as a future-proof
	safety switch.

2015-04-25  tjsaunders <tj@lyveminds.com>

	* RELEASE_NOTES, contrib/mod_tls.c, doc/contrib/mod_tls.html: Add a
	new TLSECDHCurve directive, for specifying the curve to use for
	ECDHE ciphers.

2015-04-25  tjsaunders <tj@lyveminds.com>

	* NEWS, RELEASE_NOTES: Update NEWS, release notes for Bug#3125.

2015-04-25  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #119 from proftpd/facl-macosx-bug3125 Bug#3125 - Support for Mac OS X implementation of POSIX ACLs.

2015-04-25  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls.c: Only log a trace message about adjusting the DH
	parameter length if we indeed to adjust/change the length.

2015-04-24  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls.c: Properly handle multiple TLSDHParamFiles, if
	configured.  Adjust the DH parameter length to be the size of the RSA/DSA private
	key, for greater strength, rather than using the given length (which
	will only ever be 512 or 1024 bits, even for 2048-bit server
	certs/keys).  If OpenSSL-1.0.2 or later are used, automatically negotiate the best
	EC, rather than always falling back to the prime256v1 group.

2015-04-22  TJ Saunders <tj@castaglia.org>

	* src/privs.c: Change the logging priority based on errno
	consistently.

2015-04-20  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #118 from proftpd/core-stash-remove-symbol Add symbol type-specific remove functions, for use by modules (e.g.
	mod_...

2015-04-19  TJ Saunders <tj@castaglia.org>

	* doc/howto/FXP.html, doc/modules/mod_core.html: Update references
	in FXP howto to point to local mod_core docs, and add the missing
	descriptions to the mod_core docs.

2015-04-19  TJ Saunders <tj@castaglia.org>

	* doc/howto/Directory.html, doc/modules/mod_core.html: Add
	description of AllowOverride directive, and fix up the Directory
	howto to point to that description.

2015-04-19  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp/rewrite.pm: Fix
	mod_sftp+mod_rewrite tests for Mac OSX.

2015-04-16  TJ Saunders <tj@castaglia.org>

	* doc/howto/LogMessages.html: Fix nits in LogMessages doc.

2015-04-15  tjsaunders <tj@lyveminds.com>

	* README.md: Add links/badges for Travis, Coverity.

2015-04-15  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #116 from rk295/patch-1 Changed the version string to reflect 1.3.6rc1

2015-04-15  Gildásio Júnior <gildasio97@gmail.com>

	* README, README.md: Update and rename README to README.md 1. Use md extention because use markdown sintaxe; 2. Update in some sections with markdown "tags"

2015-04-14  Robin Kearney <robin@kearney.co.uk>

	* contrib/dist/rpm/proftpd.spec: Changed the version string to
	reflect 1.3.6rc1

2015-04-12  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c: Clear the statcache appropriately for
	READLINK requests.  Add a note for my future self to NOT make the
	mistake of using a resolved path (again) when making a call to
	readlink(2).

2015-04-12  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Fix a few more
	tests for running on a Mac OSX.

2015-04-12  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sftp/sql.pm,
	tests/t/lib/ProFTPD/Tests/Modules/mod_tls.pm,
	tests/t/lib/ProFTPD/Tests/Modules/mod_wrap2_sql.pm: More fixing up
	of tests.

2015-04-12  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Commands/FEAT.pm,
	tests/t/lib/ProFTPD/Tests/Commands/MLSD.pm,
	tests/t/lib/ProFTPD/Tests/Commands/OPTS.pm,
	tests/t/lib/ProFTPD/Tests/Commands/RNFR.pm,
	tests/t/lib/ProFTPD/Tests/Commands/SIZE.pm,
	tests/t/lib/ProFTPD/Tests/Config/DefaultChdir.pm,
	tests/t/lib/ProFTPD/Tests/Config/Directory/Limits.pm,
	tests/t/lib/ProFTPD/Tests/Config/FactsOptions.pm,
	tests/t/lib/ProFTPD/Tests/Config/Limit/RMD.pm,
	tests/t/lib/ProFTPD/Tests/Config/MaxClients.pm,
	tests/t/lib/ProFTPD/Tests/Config/ShowSymlinks.pm,
	tests/t/lib/ProFTPD/Tests/Config/Umask.pm,
	tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm: Fixing up some of
	the regression tests to either work on Mac OSX, or to match the
	current code.  Still more tests need updating.

2015-04-11  TJ Saunders <tj@castaglia.org>

	* modules/mod_facts.c: Now that the statcaches have been separated
	for stat(2) vs lstat(2), this second clearing of the statcaches is
	no longer needed.

2015-04-11  TJ Saunders <tj@castaglia.org>

	* src/fsio.c: I found that we need to maintain two different
	statcache tables: one for stat(2) data, and one for lstat(2) data.
	The data can be different, for the same path, depending on whether
	it's a symlink or not.

2015-04-11  TJ Saunders <tj@castaglia.org>

	* modules/mod_facts.c, src/dirtree.c: Running through the regression
	tests has picked up a few necessary fixes.  Expect more.

2015-04-10  TJ Saunders <tj@castaglia.org>

	* NEWS: Updated NEWS for Bug#4168.

2015-04-10  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #110 from
	proftpd/xfer-hiddenstores-races-bug4168 Bug#4168 - Race condition with HiddenStores and TimeoutIdle timeout.

2015-04-10  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #114 from
	proftpd/sftp-realpath-ctrl-byte-bug4170 Bug#4170 - Incorrect handling of control-byte field of
	SSH_FXP_REALPATH ...

2015-04-09  TJ Saunders <tj@castaglia.org>

	* doc/howto/Radius.html: Update Radius howto to mention new
	attributes supported by mod_radius.

2015-04-09  TJ Saunders <tj@castaglia.org>

	* contrib/ftpasswd, modules/mod_auth_file.c: Bug#4171 - Add checks
	to mod_auth_file for crypt(3) failures due to the hash algorithm
	used, and make ftpasswd check for times when --des/--md5 will not be
	sufficient.

2015-04-09  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sftp/fxp.c: Try to implement more of the SFTP protocol
	version 6 semantics for REALPATH's control byte.

2015-04-09  tjsaunders <tj@lyveminds.com>

	* : commit 8c1412153a13f51c63070c2ac67c7a922b1a9831 Author:
	tjsaunders <tj@lyveminds.com> Date:   Thu Apr 9 00:18:17 2015 -0700

2015-04-08  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c: Fix copy/pasto, spotted by Coverity.

2015-04-08  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sftp/kex.c: Remove unnecessary NULL check, per
	Coverity.

2015-04-08  tjsaunders <tj@lyveminds.com>

	* src/str.c, tests/api/str.c: Make sure that pr_str_is_fnmatch()
	properly handles NULL arguments.

2015-04-08  tjsaunders <tj@lyveminds.com>

	* lib/glibc-glob.c: Initialize the 'next' value explicitly, so that
	things happen properly in the error handling code.  Found by
	Coverity.

2015-04-08  tjsaunders <tj@lyveminds.com>

	* contrib/mod_radius.c: Handle the size where the size of an int may
	not be exactly 4 bytes; on some platforms, it might actually be
	larger.  So be specific about the number of bytes we copy for the
	vendor ID of a VSA.

2015-04-08  tjsaunders <tj@lyveminds.com>

	* modules/mod_site.c, tests/t/lib/ProFTPD/Tests/Modules/mod_site.pm: 
	Fix some typos in the handling of symbolic mode expressions for SITE
	CHMOD commands, and start adding some symbolic SITE CHMOD regression
	tests.

2015-04-08  tjsaunders <tj@lyveminds.com>

	* modules/mod_delay.c: When shutting down and preserving the
	DelayTable, make the handling a little more resilient, handling
	(very unlikely but possible) error cases better, per Coverity.

2015-04-08  tjsaunders <tj@lyveminds.com>

	* contrib/mod_snmp/mod_snmp.c: Remove unnecessary NULL check, per
	Coverity.

2015-04-08  tjsaunders <tj@lyveminds.com>

	* modules/mod_core.c: Handle NULL return values from pr_expr_create,
	and make Coverity happier.

2015-04-08  tjsaunders <tj@lyveminds.com>

	* src/inet.c: Make the fd checks in pr_inet_openrw() a little less
	brittle by checking for any valid-looking fd (i.e. > -1), rather
	than just directly comparing against -1.

2015-04-08  tjsaunders <tj@lyveminds.com>

	* contrib/coverity/modeling.c: Tell Coverity to ignore
	rand(3)/random(3); we know what we're doing, and do not use it for
	cases where cryptographically strong random numbers are needed.  So
	please, Coverity, stop marking its use as defects.

2015-04-08  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sftp/keys.c, contrib/mod_tls.c: Make sure that we
	NUL-terminate the buffer we gave to read(2), for passphrase
	collection, before doing anything else with the buffer.

2015-04-08  tjsaunders <tj@lyveminds.com>

	* src/fsio.c: Check for possible NULL value before calling glob(3),
	lest it segfault on us.

2015-04-08  tjsaunders <tj@lyveminds.com>

	* src/fsio.c: Remove unnecessary NULL check, per Coverity.

2015-04-08  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c: Bug#4170 - Incorrect handling of
	control-byte field of SSH_FXP_REALPATH as bitmask rather than
	enumeration.

2015-04-08  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sftp/auth.c: Handle possibly (albeit unlikely) NULL
	return value.

2015-04-08  tjsaunders <tj@lyveminds.com>

	* contrib/mod_radius.c: Slightly more paranoid parsing of RADIUS
	variable formatted strings, as configured in the config file.

2015-04-08  tjsaunders <tj@lyveminds.com>

	* contrib/mod_ifsession.c: The <If...> sections using regexes might
	be malformed; the configuration handler needs to handle this error
	case properly.

2015-04-08  tjsaunders <tj@lyveminds.com>

	* : commit ac1a6a4dc9d34703dd5a438336cb53c0fed33d10 Author:
	tjsaunders <tj@lyveminds.com> Date:   Wed Apr 8 00:25:07 2015 -0700

2015-04-08  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #112 from proftpd/coverity-defects Moew Coverity defects

2015-04-08  tjsaunders <tj@lyveminds.com>

	* contrib/coverity/modeling.c, lib/tpl.c, lib/tpl.h: Tweak the TPL
	API a little, so that we can mark it for visibility by Coverity.

2015-04-07  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c: Quell warning about uninitialized variable
	being used.

2015-04-07  tjsaunders <tj@lyveminds.com>

	* src/fsio.c: Better NULL checking.  Also clear the statcache in the
	case of renames.

2015-04-07  tjsaunders <tj@lyveminds.com>

	* contrib/mod_exec.c, contrib/mod_radius.c, lib/tpl.c,
	modules/mod_ls.c, modules/mod_site.c: Fixing up more issues spotted
	by Coverity.

2015-04-07  tjsaunders <tj@lyveminds.com>

	* src/fsio.c: Fix dead code spotted by Coverity.

2015-04-07  tjsaunders <tj@lyveminds.com>

	* contrib/mod_snmp/packet.c: Removing some logically dead code
	branches spotted by Coverity.

2015-04-07  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #111 from proftpd/coverity-defects Quell some of the warnings/issues spotted by Coverity.

2015-04-07  tjsaunders <tj@lyveminds.com>

	* : commit 6bb2e06513363a256802ebb250ff05a1d9fd3208 Author:
	tjsaunders <tj@lyveminds.com> Date:   Tue Apr 7 22:03:04 2015 -0700

2015-04-07  tjsaunders <tj@lyveminds.com>

	* modules/mod_core.c, modules/mod_xfer.c: Use PR_HANDLED, not
	HANDLED.

2015-04-07  tjsaunders <tj@lyveminds.com>

	* contrib/mod_copy.c: Use PR_DECLINED, not DECLINED.

2015-04-07  tjsaunders <tj@lyveminds.com>

	* RELEASE_NOTES: Tweaks/edits to release notes.

2015-04-07  tjsaunders <tj@lyveminds.com>

	* RELEASE_NOTES: More fleshing out of the release notes.  We're
	getting close to release-ready.

2015-04-07  tjsaunders <tj@lyveminds.com>

	* RELEASE_NOTES: Start fleshing out the release notes, getting ready
	for a release.

2015-04-07  TJ Saunders <tj@castaglia.org>

	* modules/mod_xfer.c: Bug#4168 - Race condition with HiddenStores
	and TimeoutIdle timeout.  Attempt to reduce/mitigate this race by blocking timers during
	critical sections of transfer setup code, and handle some side
	effects in the exit handler by using other criteria for determining
	when/how to handle e.g. HiddenStores files.

2015-04-07  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sftp/Makefile.in, contrib/mod_sftp/umac.c: Fix
	building of umac128.{o, lo}, and the resulting symbol collision for
	a DSO build of mod_sftp.

2015-04-07  tjsaunders <tj@lyveminds.com>

	* src/inet.c: Fix compilation when the --disable-ipv6 compile-time
	option is used.

2015-04-07  tjsaunders <tj@lyveminds.com>

	* NEWS, RELEASE_NOTES: Updating NEWS, release notes for Bug#4169.

2015-04-07  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #109 from
	proftpd/copy-unauthenticated-copying Bug#4169 - Unauthenticated copying of files via SITE CPFR/CPTO
	allowed by mod_copy

2015-04-06  tjsaunders <tj@lyveminds.com>

	* NEWS, contrib/mod_sftp/fxp.c: Update NEWS with mention of fix for
	Bug#4166.

2015-04-06  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #97 from
	proftpd/sftp-rekeying-memory-usage-bug4166 Bug#4166 - mod_sftp sessions consume large amounts of memory due to
	reke...

2015-04-05  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #108 from proftpd/sftp-umac-128 Support for "umac-128@openssh.com" SSH MAC algorithm

2015-04-05  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/Makefile.in, contrib/mod_sftp/crypto.c,
	contrib/mod_sftp/mac.c, contrib/mod_sftp/umac.c,
	contrib/mod_sftp/umac.h: Add support for the umac-128@openssh.com
	SSH MAC.

2015-04-05  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/kbdint.c: Fix memory leak when handling
	'keyboard-interactive' SSH authentication.

2015-04-05  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls_memcache.c: Tone down the logging message emitted
	when we try to register a handler and there's no memcache support
	enabled in the build.

2015-04-04  tjsaunders <tj@lyveminds.com>

	* NEWS, RELEASE_NOTES: Update NEWS, release notes with mention of
	Bug#4059.

2015-04-04  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #107 from
	proftpd/radius-addl-attributes-bug4059 Bug#4059 - Implement additional RADIUS attributes

2015-04-03  tjsaunders <tj@lyveminds.com>

	* contrib/mod_radius.c, doc/contrib/mod_radius.html: Bug#4059 -
	Implement additional RADIUS attributes.

2015-04-03  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp_pam.c: Stylistic nit cleanup in mod_sftp_pam, no
	functional changes.

2015-04-02  TJ Saunders <tj@castaglia.org>

	* RELEASE_NOTES: Mention the new FSCachePolicy directive in the
	release notes.

2015-04-02  TJ Saunders <tj@castaglia.org>

	* doc/contrib/mod_sftp.html: Fix the spacing in the mod_sftp docs
	referring to RFCs.

2015-04-02  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #106 from proftpd/site-misc-resp-code-setting Fix the setting of FTP response codes for the internal commands that

2015-04-02  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #105 from proftpd/site-misc-extlog-resp-code Add regression test for ExtendedLog handling of the response code
	for SITE commands

2015-04-02  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c: Found a few more places in mod_sftp that
	need to clear the statcache for accurate stat/lstat results.

2015-04-02  TJ Saunders <tj@castaglia.org>

	* : commit f88556af8c9395873f75fc43e5f779648b5de0c3 Author: TJ
	Saunders <tj@castaglia.org> Date:   Thu Apr 2 11:25:48 2015 -0700

2015-04-02  TJ Saunders <tj@castaglia.org>

	* tests/api/table.c: Add a unit test for executing pr_table_do() on
	a table, with a callback that removes items from the table during
	the iteration.

2015-04-02  TJ Saunders <tj@castaglia.org>

	* src/fsio.c: Clear the statcache when files are created/modified
	via creat(2) and open(2) calls as well.

2015-04-02  TJ Saunders <tj@castaglia.org>

	* src/fsio.c, tests/api/fsio.c: Clear the statcache when a file is
	closed or unlinked.  Flesh out the pr_fsio_stat()/pr_fsio_lstat() unit tests to catch
	regressions such as the previous statcache issue, where the
	statcache was not being populated with the struct stat information.

2015-04-02  TJ Saunders <tj@castaglia.org>

	* contrib/mod_site_misc.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_site_misc.pm: Adding
	integration test demonstrating the proper handling of the %s
	ExtendedLog variable for SITE commands, e.g. those provided by
	mod_site_mis.c

2015-04-02  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #104 from proftpd/core-fscacheoptions Add FSCachePolicy directive, for tuning statcache

2015-04-01  TJ Saunders <tj@castaglia.org>

	* : commit 36ed1cb9901e041e88b0a96e8fb4bd13defea24f Merge: b65700f
	9d45a71 Author: TJ Saunders <tj@castaglia.org> Date:   Wed Apr 1
	23:35:15 2015 -0700

2015-04-01  TJ Saunders <tj@castaglia.org>

	* src/fsio.c: Set errno to the proper value in the case of
	stat(2)/lstat(2) failure.

2015-04-01  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/misc.c: Adding missing format string.

2015-04-01  TJ Saunders <tj@castaglia.org>

	* modules/mod_ls.c: Remove debugging cruft.

2015-04-01  TJ Saunders <tj@castaglia.org>

	* modules/mod_ls.c, src/fsio.c: Add missing memcpy(2) call that was
	causing FTP directory listings to fail.

2015-04-01  TJ Saunders <tj@castaglia.org>

	* modules/mod_ls.c, src/dirtree.c, src/fsio.c, src/support.c: 
	Checking in some changes while I debug why the statcaching is
	breaking FTP directory listings.

2015-04-01  tjsaunders <tj@lyveminds.com>

	* modules/mod_core.c: Start working on an FSCacheOptions directive,
	for tuning the newly-added statcache.

2015-04-01  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sftp/fxp.c: Properly increment the st_size on SFTP
	WRITE, taking into account possible overwrites of existing chunks of
	the file.

2015-04-01  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #100 from proftpd/fsio-stat-caching Change the FSIO API's statcache from a single entry to one using
	tables.

2015-04-01  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #101 from proftpd/sftp-fstat-on-write-perf Avoid an fstat(2) call per WRITE request, to see if it helps with
	perfor...

2015-04-01  tjsaunders <tj@lyveminds.com>

	* src/fsio.c, tests/api/fsio.c: Dealing with test fallout, and
	quelling some compiler warnings spotted by travis-ci.

2015-04-01  tjsaunders <tj@lyveminds.com>

	* src/str.c: Remove some unused variables (spotted by travis-ci).

2015-04-01  tjsaunders <tj@lyveminds.com>

	* src/fsio.c: Make sure that pr_fsio_access() doesn't clear the
	statcache when it doesn't have to; that policy should be up to the
	caller, not to the implementation.

2015-04-01  tjsaunders <tj@lyveminds.com>

	* include/fsio.h, modules/mod_core.c, src/dirtree.c, src/fsio.c,
	tests/api/fsio.c: Disable statcaching until the client has
	authenticated, at which point we will start caching.

2015-03-31  tjsaunders <tj@lyveminds.com>

	* : commit fc5dda6054a982a858add1fa63addb48fbdbb9f4 Author:
	tjsaunders <tj@lyveminds.com> Date:   Tue Mar 31 23:33:53 2015 -0700

2015-03-31  tjsaunders <tj@lyveminds.com>

	* contrib/mod_copy.c, contrib/mod_quotatab.c,
	contrib/mod_rewrite.c, contrib/mod_sftp/fxp.c,
	contrib/mod_sftp/misc.c, contrib/mod_site_misc.c,
	contrib/mod_snmp/mod_snmp.c, contrib/mod_sql.c, include/fsio.h,
	include/options.h, modules/mod_auth.c, modules/mod_core.c,
	modules/mod_facl.c, modules/mod_facts.c, modules/mod_log.c,
	modules/mod_ls.c, modules/mod_xfer.c, src/dirtree.c, src/fsio.c,
	src/mkhome.c, src/support.c, src/table.c, tests/api/fsio.c: Change
	the FSIO API's statcache from a single entry to one using tables.
	This cache now holds up to a configurable size, with expiration, and
	allows clearing of single entries (or the entire cache if needed).

2015-03-31  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sftp/fxp.c: Fix bug where we were allocating a cmd_rec
	out of the wrong pool when handling REMOVE requests.

2015-03-31  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sftp/fxp.c: Slight logging tweaks; no functional
	change.

2015-03-31  TJ Saunders <tj@castaglia.org>

	* NEWS: Update NEWS with mention of Bug#4157.

2015-03-31  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #96 from proftpd/core-tracing-perf-bug4157 Bug#4157 - LIST/NLST of 1000s of files is slow on some platforms.

2015-03-30  TJ Saunders <tj@castaglia.org>

	* src/bindings.c: Remove now-unused variable.

2015-03-30  TJ Saunders <tj@castaglia.org>

	* include/bindings.h, src/bindings.c: Fix up the
	ServerAlias/namebind handling which was causing spurious NOTICE
	level log messages in 1.3.5.

2015-03-29  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c: Make sure to set the curr_pkt pointer to
	NULL in the case of an unknown request, too.

2015-03-29  TJ Saunders <tj@castaglia.org>

	* modules/mod_dso.c, src/auth.c, src/inet.c, src/netio.c: Add
	missing tags on some pools, fix typos.  Nothing major.

2015-03-29  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c: Found a place where we need to clear a
	pointer to a packet explicitly. Failing to do so could mean that a
	packet is reused, thus leading to leaking memory (as that packet
	pool is never actually freed/reused).

2015-03-28  TJ Saunders <tj@castaglia.org>

	* include/support.h, modules/mod_ls.c, src/support.c: Additional
	fixes for Bug#4157, trying to remove a redundant lstat(2) call
	during directory listings that include symlinks.

2015-03-28  TJ Saunders <tj@castaglia.org>

	* : commit fd68ce118083fea2e1add58ae6e43413aa0b408e Author: TJ
	Saunders <tj@castaglia.org> Date:   Sat Mar 28 15:48:31 2015 -0700

2015-03-28  TJ Saunders <tj@castaglia.org>

	* modules/mod_core.c, src/netio.c, src/response.c,
	tests/api/netio.c, tests/t/lib/ProFTPD/Tests/Commands/MKD.pm: 
	Additional changes needed for handling embedded LFs in paths, for
	Bug#4167.

2015-03-28  TJ Saunders <tj@castaglia.org>

	* include/netio.h, src/main.c, src/netio.c, src/str.c,
	tests/api/netio.c, tests/t/lib/ProFTPD/Tests/Commands/MKD.pm: 
	Bug#4167 - CR/LF characters are not supported in filenames.

2015-03-25  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sftp/fxp.c: Avoid an fstat(2) call per WRITE request,
	to see if it helps with performance writing files on network
	filesystems like NFS.

2015-03-25  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c: Slightly better trace messages for SSL
	WANT_READ/WANT_WRITE conditions.

2015-03-21  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/mod_sftp.c: Only dump the memory pools if
	mod_shaper is NOT present.

2015-03-21  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/kex.c: Additional changes for Bug#4166, to reduce
	the memory leaked during an SSH2 rekeying.

2015-03-21  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c, contrib/mod_sftp/kex.c,
	contrib/mod_sftp/mod_sftp.c, modules/mod_xfer.c: Bug#4166 - mod_sftp
	sessions consume large amounts of memory due to rekeying.  In order to debug this, I had to add code to mod_sftp which handles
	the SIGUSR2 signal by dumping the memory pools of the process.
	This, in turn, required some slight adjustments to a similar
	handling of SIGUSR2 that mod_xfer does, but which was only needed if
	mod_shaper is present.

2015-03-20  TJ Saunders <tj@castaglia.org>

	* modules/mod_ls.c, src/fsio.c, src/trace.c: Bug#4157 - LIST/NLST of
	1000s of files is slow on some platforms.

2015-03-20  tjsaunders <tj@lyveminds.com>

	* NEWS, RELEASE_NOTES: Update NEWS, release notes for Bug#4164.

2015-03-20  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #95 from proftpd/sql-uid-size-bug4164 Bug#4164 - mod_sql fails to read UID/GID values larger than 32 bits
	from SQL table

2015-03-16  tjsaunders <tj@lyveminds.com>

	* contrib/mod_exec.c, contrib/mod_sftp/fxp.c, contrib/mod_sql.c,
	modules/mod_cap.c, modules/mod_facts.c, src/main.c: Updating more
	places to use the new functions for stringifying UID/GID values.
	Display the max supported UID/GID value in the -V output.

2015-03-16  tjsaunders <tj@lyveminds.com>

	* : commit 005b8a5cccfa75109f738f2ecbb763225d1a76c3 Author: TJ
	Saunders <tj@castaglia.org> Date:   Mon Mar 16 14:05:11 2015 -0700

2015-03-15  tjsaunders <tj@lyveminds.com>

	* src/auth.c, src/privs.c: Update more places in the core code to
	log UID/GID values properly.

2015-03-15  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sql.c: Fix up a few more places in mod_sql where
	proper stringification of UID/GID needs to use the new routines.

2015-03-15  tjsaunders <tj@lyveminds.com>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm: The bug has
	number; it's number is 4164.

2015-03-15  tjsaunders <tj@lyveminds.com>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm: Run all of
	the mod_sql_sqlite tests, please.

2015-03-15  tjsaunders <tj@lyveminds.com>

	* src/auth.c, src/str.c, tests/api/str.c: Bug#4164: Start using the
	new functions for ID/string conversion in more places; there's still
	more here to do.

2015-03-15  tjsaunders <tj@lyveminds.com>

	* : commit 9b215b1530bf4839ddce6505d70d9e79a9c541c5 Author:
	tjsaunders <tj@lyveminds.com> Date:   Sun Mar 15 17:27:51 2015 -0700

2015-03-15  TJ Saunders <tj@castaglia.org>

	* configure: Updated configure.

2015-03-15  TJ Saunders <tj@castaglia.org>

	* config.h.in, configure.in: Check for the strtoll(3) function, too.

2015-03-15  TJ Saunders <tj@castaglia.org>

	* configure: Updated configure.

2015-03-15  TJ Saunders <tj@castaglia.org>

	* config.h.in, configure.in: Add autoconf checks for the size of
	uid_t/gid_t, as part of handling Bug#4164.

2015-03-15  tjsaunders <tj@lyveminds.com>

	* NEWS, RELEASE_NOTES: Update NEWS, release notes for Bug#4163.

2015-03-15  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #94 from
	proftpd/tls-no-export-ciphers-bug4163 Bug#4163 - Remove support for EXPORT grade ciphers.

2015-03-15  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sftp/fxp.c: Fix two places with incorrect comparisons
	against the utf8ProtocolVersion SFTPOption, per comments in
	Bug#4160.

2015-03-15  tjsaunders <tj@lyveminds.com>

	* NEWS: Update NEWS for Bug#4160.

2015-03-15  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #93 from
	proftpd/sftp-realpath-nocheck-v6-response-bug4160 Bug#4160 - Malformed response to SSH_FXP_REALPATH with SFTP version
	6.

2015-03-14  tjsaunders <tj@lyveminds.com>

	* NEWS: Update NEWS with fix for Bug#4156.

2015-03-14  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #91 from proftpd/core-ls-segfault-bug4156 Bug#4156 - Segfault handling LIST/NLST FTP command on Mac OS X.

2015-03-03  tjsaunders <tj@lyveminds.com>

	* NEWS, RELEASE_NOTES: Updates NEWS, release notes for Bug#4159.

2015-03-03  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #92 from proftpd/xfer-ignore-ascii-bug4159 Bug#4159: Support ability to disable ASCII translation transparently
	to ...

2015-03-01  TJ Saunders <tj@castaglia.org>

	* include/fsio.h, lib/sstrncpy.c, src/fsio.c, tests/api/fsio.c,
	tests/api/str.c: Bug#4156 - Segfault handling LIST/NLST FTP command
	on Mac OS X.

2015-03-01  TJ Saunders <tj@castaglia.org>

	* src/main.c: Include PR_TUNABLE_PATH_MAX in the `proftpd -V'
	output.

2014-12-25  TJ Saunders <tj@castaglia.org>

	* NEWS, RELEASE_NOTES: Update NEWS, release notes for JSON output of
	ftpwho (Bug#4031).

2015-02-27  TJ Saunders <tj@castaglia.org>

	* lib/pr_fnmatch_loop.c: Backport glibc fix for a memory overread
	for certain fnmatch patterns.

2015-02-19  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp_sql.c: Fix additional issue related to Bug#4155,
	where the buffer overrun could happen for bad key data.  This also
	adds a log message for the future, pinpointing the root of the
	problem.

2015-02-19  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp_sql.pm: Remove stray
	comment character.

2015-02-17  tjsaunders <tj@lyveminds.com>

	* tests/t/lib/ProFTPD/Tests/Commands/NLST.pm: Add a regression test
	for the NLST command and how the -a and -1 options will affect the
	format of the NLST response.

2015-02-17  tjsaunders <tj@lyveminds.com>

	* modules/mod_ls.c: Stylistic nits; no functional change.

2015-02-17  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_exec.pm: Adding mod_exec
	regression test demonstrating how to use mod_exec and mod_ifsession.

2015-02-17  tjsaunders <tj@lyveminds.com>

	* NEWS: Update NEWS with fix for Bug#4155.

2015-02-17  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #89 from
	proftpd/sftp-sql-overlong-commented-keys-bug4155 Bug#4155 - SSH keys with too-long Comment headers aren't recognized
	by mod_sftp_sql

2015-02-17  TJ Saunders <tj@castaglia.org>

	* tests/t/etc/modules/mod_sftp/test_rsa2048_key2,
	tests/t/etc/modules/mod_sftp/test_rsa2048_key2.pub,
	tests/t/etc/modules/mod_sftp/test_rsa_key_bug4155,
	tests/t/etc/modules/mod_sftp/test_rsa_key_bug4155.pub,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sftp_sql.pm: Adding
	accompanying regression tests for Bug#4155.

2015-02-17  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp_sql.c: Bug#4155 - SSH keys with too-long Comment
	headers aren't recognized by mod_sftp_sql.

2015-02-17  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #88 from proftpd/ls-option-parsing Fix random issue with LIST option parsing

2015-02-17  tjsaunders <tj@lyveminds.com>

	* tests/t/lib/ProFTPD/Tests/Commands/LIST.pm: Adding a regression
	test for the "LIST -a" parsing issue raised on GitHub.

2015-02-04  tjsaunders <tj@lyveminds.com>

	* NEWS: Update NEWS for fix for Bug#4152.

2015-02-04  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #87 from
	proftpd/core-enotconn-logging-bug4152 Bug#4152 - Reduce logging of non-fatal "unable to open incoming
	connection" errors

2015-02-04  tjsaunders <tj@lyveminds.com>

	* src/main.c: Bug#4152 - Reduce logging of non-fatal "unable to open
	incoming connection" errors.

2015-02-03  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sql_passwd.c: Correct the pointer check used in an
	error case; spotted by Coverity.

2015-02-03  tjsaunders <tj@lyveminds.com>

	* contrib/mod_tls.c: Stylistic nits; no functional change.

2015-02-03  tjsaunders <tj@lyveminds.com>

	* contrib/mod_radius.c: Stylistic cleanup; no functional changes.

2015-02-03  tjsaunders <tj@lyveminds.com>

	* contrib/mod_sftp/keys.c, contrib/mod_tls.c: Address some Coverity
	issues by ensuring that a buffer, given to OpenSSL, is
	NUL-terminated before calling e.g. strlen(3) on the buffer.

2015-02-03  tjsaunders <tj@lyveminds.com>

	* src/data.c: Clear the "have dangling CR" flag on data reset as
	well.

2015-02-03  tjsaunders <tj@lyveminds.com>

	* src/data.c: Reset any ASCII transformation state, possibly
	leftover from previous transfers, when preparing for a data transfer
	(Bug#4150).

2015-02-03  tjsaunders <tj@lyveminds.com>

	* src/data.c: Use the return value from xfrm_ascii_write() as part
	of a trace-level log message (Bug#4149).

2015-02-03  tjsaunders <tj@lyveminds.com>

	* src/data.c: Update stale comment (Bug#4148).

2015-02-03  tjsaunders <tj@lyveminds.com>

	* NEWS: Update NEWS for Bug#4145.

2015-02-03  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #86 from
	proftpd/authfile-symlink-segfault-bug4145 Bug#4145 - Segfault if AuthUserFile is a relative symlink.

2014-12-25  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #84 from proftpd/utils-ftpwho-json-bug4031  Bug#4031 - Support JSON output format for ftpwho

2014-12-25  TJ Saunders <tj@castaglia.org>

	* utils/ftpwho.1.in: Update the ftpwho man page to mention the new
	json option.

2014-12-25  TJ Saunders <tj@castaglia.org>

	* include/tpl.h: Include renamed file.

2014-12-25  TJ Saunders <tj@castaglia.org>

	* configure.in, include/memcache.h, lib/json.c, lib/json.h,
	lib/tpl.h, utils/ftpwho.c, utils/utils.h: Bug#4031 - Support JSON
	output format for ftpwho.

2014-12-24  TJ Saunders <tj@castaglia.org>

	* NEWS, RELEASE_NOTES: Updating NEWS, release notes for fix for
	Bug#4144.

2014-12-24  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #83 from
	proftpd/xfer-appe-with-hiddenstores-bug4144 Bug#4144 - Support APPE when HiddenStores are enabled.

2014-12-22  TJ Saunders <tj@castaglia.org>

	* src/fsio.c: Adding missing trace logging of some FSIO operations.
	Stylistic cleanup.

2014-12-22  TJ Saunders <tj@castaglia.org>

	* .travis.yml, tests/api/fsio.c: Set the TRAVIS_CI environment
	variable when it is being used to e.g. run the API tests.  Then use
	this in the fsio_access() tests, to avoid running the tests which
	run afoul of the travis-ci environment (and causing unexpected
	false-positive test failures).

2014-12-22  TJ Saunders <tj@castaglia.org>

	* tests/api/fsio.c: For the fsio_access() tests, use chmod(2)
	directly on the created directory, rather than futzing with the
	umask.

2014-12-22  TJ Saunders <tj@castaglia.org>

	* tests/api/fsio.c: Comment out more of the fsio_access() tests, for
	now.

2014-12-22  TJ Saunders <tj@castaglia.org>

	* src/scoreboard.c: Quell compiler warning, found by travis-ci.

2014-12-22  TJ Saunders <tj@castaglia.org>

	* tests/api/fsio.c: Comment out some of the just-added tests for
	fsio_access(), pending investigation into travis-ci's umask et al.

2014-12-22  TJ Saunders <tj@castaglia.org>

	* tests/api/inet.c: Removing more unused variables; no functional
	change.

2014-12-22  TJ Saunders <tj@castaglia.org>

	* tests/api/auth.c: Remove unused variable; no functional change.

2014-12-22  TJ Saunders <tj@castaglia.org>

	* tests/api/fsio.c: Fixup use of variables; no functional change.

2014-12-22  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/kex.c: Quell another compiler warning, found by
	travis-ci.

2014-12-22  TJ Saunders <tj@castaglia.org>

	* contrib/mod_site_misc.c: Fix printf(3) format warning found by
	travis-ci.

2014-12-22  TJ Saunders <tj@castaglia.org>

	* src/fsio.c, tests/api/fsio.c: Add unit test for the fsio_access()
	function, as part of tracking down the culprit for Bug#4141.

2014-12-22  TJ Saunders <tj@castaglia.org>

	* src/dirtree.c: Add trace logging of various conditions under which
	we'll hide a file, for debugging/triage.

2014-12-20  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls_memcache.c: Reduce the severity of the "unable to
	register memcache SSL session cache" message, from NOTICE to DEBUG;
	it causes more confusion than aid.

2014-12-17  tjsaunders <tj@lyveminds.com>

	* RELEASE_NOTES, contrib/mod_ban.c, doc/contrib/mod_ban.html: Add
	support to mod_ban, for banning on "bad protocol" detection.

2014-12-15  TJ Saunders <tj@castaglia.org>

	* NEWS: Update NEWS with fix for Bug#4143.

2014-12-15  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #81 from proftpd/core-reject-http-smtp Bug#4143 - HTTPS/FTPS protocol confusion leads to XSS

2014-12-15  tjsaunders <tj@lyveminds.com>

	* src/cmd.c, src/main.c: Update the comments with the appropriate
	bug number.

2014-12-14  TJ Saunders <tj@castaglia.org>

	* include/cmd.h, include/dirtree.h, include/session.h, src/cmd.c,
	src/main.c, tests/t/http.t, tests/t/lib/ProFTPD/Tests/HTTP.pm,
	tests/t/lib/ProFTPD/Tests/SMTP.pm, tests/t/smtp.t: If we detect HTTP
	or SMTP commands, drop the connection.  This prevents proftpd from
	being used as a staging server for nefarious attacks on other
	protocol servers.

2014-12-14  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Fix regression test
	for Bug#4097 to run using current mod_sftp code.

2014-12-14  TJ Saunders <tj@castaglia.org>

	* : commit 1ba73d3d85bb837ae08eb1fd15d81d087385fc60 Author: TJ
	Saunders <tj@castaglia.org> Date:   Sun Dec 14 18:57:16 2014 -0800

2014-12-14  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Fixed quite a few
	failing regression tests; many of them were failing (on Mac OSX) due
	to tmp filesystem fun.

2014-12-13  TJ Saunders <tj@castaglia.org>

	* doc/contrib/mod_sftp.html: Add another mod_sftp FAQ about warnings
	about reading certain config files.

2014-12-09  TJ Saunders <tj@castaglia.org>

	* src/fsio.c: Remove the EPERM exclusion.

2014-12-09  TJ Saunders <tj@castaglia.org>

	* src/fsio.c: Ignore EPERM, in the case where we see ENOENT.

2014-12-09  TJ Saunders <tj@castaglia.org>

	* src/fsio.c: If we encounter an ENOENT from fchmod(2) when securely
	changing mode of a temporary directory, as from a network filesystem
	such as CIFS, then we should probably ignore any EACCES errors said
	filesystem might return as well.

2014-12-09  TJ Saunders <tj@castaglia.org>

	* src/fsio.c: Make sure the fchmod(2) call fails, using ENOENT,
	before deciding to fall back to chmod(2).

2014-12-09  TJ Saunders <tj@castaglia.org>

	* modules/mod_site.c: Fix build warnings about missing printf
	arguments.

2014-12-09  TJ Saunders <tj@castaglia.org>

	* src/fsio.c: Bug#4134 - Unable to create folders using FTP on a
	CIFS mounted share: "No such file or directory".  The underlying cause of this bug is that, on a CIFS mount (perhaps
	because of the mount options used), fchmod(2) on the temporary
	directory returns ENOENT.  Weird.  So we address this by doing a) a
	fallback call to chmod(2) on the path, and b) ignoring ENOENT.

2014-12-08  TJ Saunders <tj@castaglia.org>

	* NEWS: Update NEWS for fix for Bug#4140.

2014-12-08  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #79 from
	proftpd/sftp-readlink-symlinks-bug4140 Bug#4140 - SFTP READLINK requests to symlinks to directories fail.

2014-12-08  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Bug#4140 - SFTP
	READLINK requests to symlinks to directories fail.

2014-12-07  TJ Saunders <tj@castaglia.org>

	* src/auth.c: Log the value for TZ, if it is already present; this
	will help with debugging issues such as Bug#4113.

2014-12-06  TJ Saunders <tj@castaglia.org>

	* NEWS, RELEASE_NOTES: Updated NEWS, release notes for Bug#4138
	changes.

2014-12-06  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #78 from
	proftpd/sql-passwd-salt-encodings-bug4138 Bug#4138 - Support for hex-encoded salts in mod_sql_passwd.

2014-12-06  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sql_passwd.c, doc/contrib/mod_sql_passwd.html,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sql_passwd.pm: Bug#4138 -
	Support for hex-encoded salts in mod_sql_passwd.

2014-12-01  tjsaunders <tj@lyveminds.com>

	* NEWS: Update NEWS with fix for Bug#4137.

2014-12-01  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #76 from
	proftpd/geoip-denyfilter-precedence-bug4137 Bug#4137 - GeoIPDenyFilter incorrectly takes precedence over
	GeoIPAllowF...

2014-11-30  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #77 from proftpd/ctrls-openbsd-portability Issue #75: Add configure-time check for struct sockpeercred (as used
	on

2014-11-29  TJ Saunders <tj@castaglia.org>

	* contrib/mod_geoip.c: Bug#4137 - GeoIPDenyFilter incorrectly takes
	precedence over GeoIPAllowFilter.

2014-11-16  TJ Saunders <tj@castaglia.org>

	* NEWS: Updated NEWS for fix for Bug#4133.

2014-11-16  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #73 from
	proftpd/ldap-users-missing-uid-filter-bug4133 Bug#4133 - LDAPUsers directive does not honor
	uid-number-filter-templat...

2014-11-16  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/keys.c: Make sure that
	sftp_keys_clear_ecdsa_hostkey() has proper semantics, and will
	return ENOENT if ECC is supported, but there are no ECDSA hostkeys
	configured.

2014-11-16  TJ Saunders <tj@castaglia.org>

	* RELEASE_NOTES, doc/contrib/mod_sftp.html: Update docs, release
	notes for new SFTPHostKey flags.

2014-11-16  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #72 from
	proftpd/sftp-disabling-global-hostkeys Modify the SFTPHostKey directive such that it can be used to
	unload/clea...

2014-11-14  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/log.c: Remove misleading comment; no functional change.

2014-11-13  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #71 from proftpd/sftp-wrap2-deny-msg Make sure that mod_sftp properly resolves any %u variables in a
	WrapDeny...

2014-11-11  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #70 from proftpd/sftp-allowfilter-redux Following up on a forums post, make sure that if AllowFilter is used
	on

2014-11-10  TJ Saunders <tj@castaglia.org>

	* modules/mod_core.c: Update notes of which modules have been
	reworked, which need reworking.

2014-11-10  TJ Saunders <tj@castaglia.org>

	* modules/mod_xfer.c: Fix merge errors causing broken build.

2014-11-10  TJ Saunders <tj@castaglia.org>

	* : commit 7c4787492b879207a6052058bf9dd11c8c2f48dd Merge: bdaefba
	eef26a0 Author: TJ Saunders <tj@castaglia.org> Date:   Mon Nov 10
	10:24:31 2014 -0800

2014-11-10  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp_sql.pm: Add regression
	test demonstrating use of the new key fingerprint environment
	variables.

2014-11-10  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/auth-publickey.c, doc/contrib/mod_sftp.html: 
	Populate some environment variables that can be used for
	logging/tracking the publickey used for user authentication, via key
	fingerprints.

2014-11-10  TJ Saunders <tj@castaglia.org>

	* NEWS, RELEASE_NOTES: Update NEWS, release notes for changes for
	Bug#4060.

2014-11-10  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #68 from proftpd/ls-opt-U-bug4060 Bug#4060 fix

2014-11-10  TJ Saunders <tj@castaglia.org>

	* doc/howto/ListOptions.html, modules/mod_ls.c,
	tests/t/lib/ProFTPD/Tests/Commands/LIST.pm: Bug#4060 - Support
	unsorted LIST entries (-U) to decrease memory/CPU usage for large
	directory listings.

2014-11-09  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #67 from proftpd/xfer-note-file-offset Add support for %{file-offset} ExtendedLog variable, for tracking
	resumed uploads/downloads

2014-11-09  TJ Saunders <tj@castaglia.org>

	* : commit 8d0d90490407d67d8da7bd1543a5f4625b5797af Author: TJ
	Saunders <tj@castaglia.org> Date:   Sun Nov 9 22:38:25 2014 -0800

2014-11-09  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #66 from
	proftpd/lang-require-valid-encoding-bug4125 Bug#4125 - mod_lang should provide way to reject illegally-encoded
	filenames.

2014-11-09  TJ Saunders <tj@castaglia.org>

	* modules/mod_lang.c: Copy-pasto.

2014-11-09  TJ Saunders <tj@castaglia.org>

	* include/encode.h, modules/mod_lang.c, src/encode.c, src/fsio.c: 
	Forgot to actually wire up the handling of the RequireValidEncoding
	LangOption to the propagation of decoding errors; without this, all
	illegal encodings would be rejected.

2014-11-09  TJ Saunders <tj@castaglia.org>

	* contrib/mod_copy.c, contrib/mod_site_misc.c,
	doc/modules/mod_lang.html, include/encode.h, include/fsio.h,
	include/session.h, modules/mod_core.c, modules/mod_facts.c,
	modules/mod_lang.c, modules/mod_ls.c, modules/mod_site.c,
	modules/mod_xfer.c, src/dirtree.c, src/encode.c, src/fsio.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_lang.pm: Bug#4125 - mod_lang
	should provide way to reject illegall-encoded filenames.

2014-11-09  TJ Saunders <tj@castaglia.org>

	* NEWS: Update NEWS with mention of changes for Bug#4058.

2014-11-09  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #65 from proftpd/trace-timing-channel-bug4058 Bug#4058 -  Create a 'timing' trace channel, for timing-related data

2014-11-09  TJ Saunders <tj@castaglia.org>

	* contrib/mod_log_forensic.c, contrib/mod_sftp/packet.c,
	contrib/mod_tls.c, include/proftpd.h, include/support.h,
	modules/mod_auth.c, src/main.c, src/support.c: Add supporting
	functions for easier timestamping for a 'timing' channel, and start
	implementing some of the more important timings to capture.

2014-11-09  TJ Saunders <tj@castaglia.org>

	* NEWS, contrib/mod_sftp/configure: Update NEWS, regenerate mod_sftp
	configure, for fix for Bug#4131.

2014-11-09  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #64 from proftpd/sftp-autoconf-sha2-detection Fix mod_sftp's autoconf script to properly detect OpenSSL support
	for SH...

2014-11-06  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #63 from proftpd/sqlpasswd-dual-salt-support Modify mod_sql_passwd so that both global and per-user salts can be
	supp...

2014-11-06  tjsaunders <tjsaunders@blackpearlsystems.com>

	* NEWS, RELEASE_NOTES: Update NEWS, release notes for Bug#4130.

2014-11-06  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #62 from
	proftpd/site-utime-multi-timestamps-bug4130 Bug#4130 - Support the 3-timestamp form of SITE UTIME.

2014-11-03  tjsaunders <tjsaunders@blackpearlsystems.com>

	* NEWS: Update NEWS for fix for Bug#4129.

2014-11-03  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #61 from
	proftpd/sql-negative-cached-ids-bug4129 Bug#4129 - mod_sql caches incorrect UID/GID when name cannot be
	retrieve...

2014-11-02  tjsaunders <tjsaunders@blackpearlsystems.com>

	* tests/t/lib/ProFTPD/Tests/Commands/RMD.pm: Add regression test
	demonstrating deletion of a directory (empty) whose name contains
	spaces.

2014-10-27  TJ Saunders <tj@castaglia.org>

	* NEWS: Update NEWS with fix for Bug#4124.

2014-10-27  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #60 from
	proftpd/xfer-deleteabortestores-off-bug4124 Bug#4124 - DeleteAbortedStores defaults to "on" for all transfers,
	not j...

2014-10-24  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/scoreboard.c: Make sure we handle possible (albeit unlikey)
	lseek(2) errors here, too.

2014-10-24  tjsaunders <tjsaunders@blackpearlsystems.com>

	* utils/scoreboard.c: If lseek(2) fails, make sure we handle it
	properly.

2014-10-24  tjsaunders <tjsaunders@blackpearlsystems.com>

	* lib/tpl.c: Slightly better (paranoid) handling of fatal messages
	in TPL.

2014-10-24  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/stash.c, tests/api/stash.c: Per Coverity, check that our name
	comparison is doing what we expect.  Also ensure that the names used
	in stash tables are at least one character long; no empty strings.

2014-10-23  tjsaunders <tjsaunders@blackpearlsystems.com>

	* : commit 0ebf3f8a96aeaaa83bc1250fadc337d626a09186 Author:
	tjsaunders <tjsaunders@blackpearlsystems.com> Date:   Thu Oct 23
	08:50:32 2014 -0700

2014-10-23  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #58 from proftpd/tls-protocol-version-bug4116 Bug#4116 - Report exact SSL/TLS protocol version used in client
	connecti...

2014-10-22  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/memcache.c: Check for a null pointer again, as was done above.

2014-10-22  tjsaunders <tjsaunders@blackpearlsystems.com>

	* lib/tpl.c: Clean up the varargs in this error case.

2014-10-22  tjsaunders <tjsaunders@blackpearlsystems.com>

	* lib/tpl.c: Tell compilers (and static code analyzers) that we
	explicitly do not care about the return values in this code branch.

2014-10-22  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/main.c: If we still have trouble opening the ScoreboardFile in
	inetd mode, after deleting it, then fail to start up.

2014-10-22  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_shaper.c: Check for an improbable error when deleting
	the ShaperTable on shutdown, per Coverity's suggestions.

2014-10-21  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_tls.c: More refactoring to the TLS version setting in
	mod_tls, to make sure that the intended behavior, a la Bug#4114, is
	enforced properly in all cases. This code is much simpler to
	maintain now.

2014-10-21  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls.c: Got the order of the default ciphersuites
	wrong, for Bug#4114.

2014-10-21  tjsaunders <tjsaunders@blackpearlsystems.com>

	* modules/mod_xfer.c: Remove some unneeded code, and check that the
	configured Max{Retrieve,Store}FileSize is greater than zero.

2014-10-21  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/scoreboard.c, utils/scoreboard.c: If lseek(2) fails, make sure
	to clean up after ourselves before leaving (i.e.  unlocking the
	scoreboard, and closing the fd).

2014-10-19  TJ Saunders <tj@castaglia.org>

	* NEWS: Update NEWS for Bug#4035.

2014-10-19  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #53 from
	proftpd/xfer-hiddenstores-not-renamed-bug4035 Bug#4035 - HiddenStores file not renamed every time

2014-10-19  TJ Saunders <tj@castaglia.org>

	* : commit e3a87649a7bafa593b68b36fcc0b9eb2d1045eee Author: TJ
	Saunders <tj@castaglia.org> Date:   Sun Oct 19 12:13:49 2014 -0700

2014-10-19  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #51 from
	proftpd/sftp-too-small-buffer-bug4112 Bug#4112 - Failure to connect using mod_sftp sometimes due to
	too-small buffers

2014-10-19  TJ Saunders <tj@castaglia.org>

	* : commit 70c583005687a2cbba6807f9f83a504895eedb47 Author: TJ
	Saunders <tj@castaglia.org> Date:   Sun Oct 19 12:08:38 2014 -0700

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/log.c: If we fail to open a syslog socket, log the error.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/ctrls.c: Remove redundant variable.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* modules/mod_core.c: Ignore errors from setting trace levels here,
	when restarting.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* lib/pr-syslog.c, src/log.c: More cases where we are not concerned
	with errors; be explicit about it.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/inet.c: Check (or ignore) errors from pr_inet_set_block().

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_tls.c: Fix a case where, when secure site-to-site
	transfers are used, mod_tls would ignore a possible problem when
	matching the server cert's CN.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* lib/tpl.c: The tpl code needed some va_end() calls before
	returning early from a variadic function.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sftp/misc.c: Log in other places here when
	stat(2)/fstat(2) fail.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sftp/misc.c: Log if stat(2) fails here.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/data.c: We're not really concerned with a fcntl(2) error here.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/ctrls.c: Some controls could elicit large responses.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/ctrls.c: Put a bound on the number of controls response
	arguments, too.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/ctrls.c: Put a bound on the max number of controls request
	arguments.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* modules/mod_ctrls.c: Another place where we can check before
	calling close() on an fd.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* modules/mod_ctrls.c: Make sure the fd is a valid fd value before
	passing it to close(2).

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/scoreboard.c: More handling of lseek(2) errors.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* utils/scoreboard.c: Handle possible lseek(2) error when scrubbing
	scoreboard via ftpscrub.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/netaddr.c: More paranoid error handling, prompted by Coverity.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_quotatab_file.c: Handle (rare) cases where lseek(2)
	might return an error.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* modules/mod_core.c: Coverity found another place where possibly
	badly formatted Trace settings could trigger a null pointer
	dereference.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sftp/keystore.c: Avoid possible null pointer
	dereferences (unlikely) when handling badly configured
	SFTPAuthorized{Host,User}Keys parameters.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* modules/mod_core.c: Avoid possible null pointer dereference, per
	Coverity.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_wrap2/mod_wrap2.c: Paranoidly check for NULL from
	strchr(3); this case should've been caught in the directive handler.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sftp/fxp.c: Avoid possible (but unlikely) null pointer
	dereference.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/ctrls.c: Watch for short reads when reading in a controls
	request.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* doc/howto/Tracing.html, src/log.c, src/trace.c: Handle the case
	where opening a syslog socket might fail.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sftp/fxp.c: Remove unreachable code, found by
	Coverity.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* modules/mod_xfer.c: Remove code which is logically
	dead/unreachable, per Coverity.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/memcache.c: A few more missing break statements found by
	Coverity.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* modules/mod_core.c: Handle the EISDIR case first; the following
	code would handle it automatically, but we want to handle EISDIR as
	a special case.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/event.c: Coverity's analysis correctly identified some
	dead/unreachable code.  Clean it up here.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* modules/mod_xfer.c: Remove redundant check, pointed out by
	Coverity.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/scoreboard.c: Remove some code which would never be reached,
	pointed out by Coverity.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* utils/ftpshut.c: Adding missing break statement, and make the code
	clearer.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/memcache.c: More missing break statements found by Coverity.

2014-10-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* modules/mod_memcache.c: Add missing break statements, per
	Coverity.

2014-10-17  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls.c: Refactor the protocol-enabling bits into a
	common function, which makes the protocol setting code easier to
	read/maintain.

2014-10-16  tjsaunders <tjsaunders@blackpearlsystems.com>

	* NEWS, RELEASE_NOTES, doc/contrib/mod_tls.html: Update mod_tls
	docs, NEWS, and release notes for Bug#4114.

2014-10-16  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #56 from proftpd/tls-sslv3-disabled-bug4114 Bug#4114 - mod_tls should not support SSLv3 by default.

2014-10-16  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_tls.c: Bug#4114 - mod_tls should not support SSLv3 by
	default.

2014-10-14  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/inet.c: Better error handling (and reporting).

2014-10-14  tjsaunders <tjsaunders@blackpearlsystems.com>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm: Add
	regression test demonstrating setting the UID/GID columns for
	SQLUserInfo to NULL.

2014-10-14  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sql.c: Always log the default UID/GID, not just when
	"SQLAuthenticate groups" is in effect.  Sheesh.

2014-10-14  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/bindings.c, src/inet.c, src/netaddr.c: In handling some
	Coverity-found issues, I think we were propagating some errors too
	eagerly.  Fix these, along with the trace logging added for tracking
	down the cause.

2014-10-14  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #55 from proftpd/coverity-defects Coverity defects

2014-10-14  tjsaunders <tjsaunders@blackpearlsystems.com>

	* modules/mod_delay.c: Check for fcntl(2) return values, and log
	them (via trace logging).

2014-10-14  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sftp/fxp.c: If there are errors setting a file handle
	as blocking, log them via trace logging.

2014-10-14  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_tls.c: Log (via trace messages) when putting a socket
	into nonblocking/blocking mode results in errors.  Make it clear
	that setting other socket options can be ignored if they fail.

2014-10-14  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/stash.c: Minor edge case found by Coverity.

2014-10-14  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/coverity/modeling.c: More Coverity modeling hints.

2014-10-12  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_tls.c: More places where we need to log if there's an
	issue stashing a note in a table, especially these SSL notes.

2014-10-12  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_shaper.c: Per Coverity, avoid possible divide-by-zero
	situation.

2014-10-12  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/coverity/modeling.c: Model pr_session_disconnect() as a
	killpath.

2014-10-12  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sql_passwd.c: If we have an error reading the salt,
	then don't proceed to trying to manipulate the buffer containing
	said salt.

2014-10-12  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/timers.c: Remove redundant null check.

2014-10-12  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sftp/fxp.c: Fix more places in mod_sftp where checking
	xerrno for EOF was unnecessary.

2014-10-12  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sftp/fxp.c: As it is not possible for xerrno to be EOF
	in this case, remove the unneeded tertiary operator/check for that
	condition.

2014-10-12  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_snmp/mod_snmp.c: Add missing break statement
	(copy-pasto).

2014-10-12  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/dirtree.c: Add missing break statement.  Oops.

2014-10-12  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_radius.c: Make it clearer what the expected
	usage/return value of the RADIUS_IS_VAR macro is.

2014-10-12  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/str.c: Remove some redundant checks: an int cannot be larger
	than INT_MAX, by definition.

2014-10-12  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/fsio.c: Restructure a function to remove dead code.

2014-10-12  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/cmd.c: Log if we have a problem caching our "displayable"
	string of a command in its notes table.

2014-10-12  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sftp/display.c, src/display.c: Make sure that
	pr_fsio_fstat() succeeds before setting the IO block size hint on
	the file handle.

2014-10-12  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sftp/misc.c: Another place where we weren't checking
	pr_fsio_fstat()'s return value.

2014-10-12  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sftp/fxp.c: Be sure to check the pr_table_add() return
	value, per Coverity.

2014-10-12  tjsaunders <tjsaunders@blackpearlsystems.com>

	* modules/mod_xfer.c: Per Coverity's prodding, check the return
	value of pr_fsio_stat().

2014-10-12  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/coverity/modeling.c: Model setenv(3) as a TAINTED_DATA
	sink.

2014-10-12  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sftp/fxp.c: Another copy-pasto found by Coverity.

2014-10-12  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sftp/fxp.c: Copy-pasto, found by Coverity.

2014-10-12  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sftp/keys.c: Copy-pasto, found by Coverity.

2014-10-12  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sftp/packet.c: If mod_sftp is interrupted when reading
	from a socket, then retry that read(2) call again, rather than just
	looping infinitely.

2014-10-12  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_ldap.c: Remove unnecessary tertiary operator.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* modules/mod_delay.c: Use proper blocks, especially when dealing
	with macro expansion, to make clear what is happening (and what is
	in scope).

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sftp/kex.c: Be consistent with the datatype used for
	the hostkey length throughout the KEX API.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* modules/mod_delay.c: If mod_delay has issues blocking/unblocking
	signals, log the reason why via trace logging.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_copy.c: Log, via trace logging, if we fail to add a
	session note.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_copy.c: Log, via trace logging, a should-never-fail
	error.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* lib/pr-syslog.c: If we have a problem sending a message via
	syslog, try (at least) to report it via STDERR.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/fsio.c: Prompted by Coverity, log (rather than ignoring)
	return values.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sftp/agent.c: Per Coverity, at least log the fcntl(2)
	error when trying to set CLOEXEC on an fd opened to talk to an SSH
	agent.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/netio.c: Explicitly ignore fcntl(2) return values here.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/inet.c: Per Coverity, make sure that we check for, and handle
	errors, when calling getsockopt(2).

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/inet.c: At least log, via trace logging, if fcntl(F_SETOWN)
	fails.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/bindings.c, src/inet.c: Propagate -- and check for -- more
	return values, prompted by Coverity.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sftp/rfc4716.c: Be more paranoid about checking return
	values, prompted by Coverity.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/data.c: Explicitly ignore the fcntl(2) return value for data
	sockets.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/inet.c: If setting a socket back to blocking mode fails,
	propagate that error to the caller, just as we do when setting the
	socket to nonblocking mode.  Found by Coverity.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/ctrls.c, src/log.c: Explicitly ignore the fcntl(2) return
	value when opening a log fd; there is no existing log fd that we can
	use at that point for reporting the error.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/dirtree.c: If we encounter an error in opening a socket, make
	sure that we return from that function early, as appropriate (found
	by Coverity).

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* utils/ftptop.c: Fix a possible (albeit unlikely) resource leak
	identified by Coverity.

2014-10-11  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #54 from proftpd/coverity-defects Coverity defects

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sftp/display.c, src/display.c: Fix error spotted by
	Coverity, where we might exceed the array of supported units for
	Display variables.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* lib/pr-syslog.c: Avoid possible buffer overrun on exceedingly log
	syslog-destined log messages, per Coverity.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sftp/keys.c, contrib/mod_sftp/keys.h: Ensure matching
	datatypes, on platforms where uint32_t and size_t are not the same
	size; this should address an issue spotted by Coverity.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_shaper.c: Initialize variable, per Coverity.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_snmp/mod_snmp.c: Initialize variable, per Coverity.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sftp/keys.c: Initialize variable, per Coverity.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/stash.c: Initialize variable value, per Coverity.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sftp_sql.c: Be pedanticly cautious, prompted by
	Coverity, in making sure that buffer indices are within the range we
	assume.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/main.c: Avoid possible descriptor leak, found by Coverity, by
	using the existing pr_fs_get_usable_fd() function, rather than
	multiple different approaches.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_snmp/mod_snmp.c: Coverity found a "leaked" file
	descriptor in mod_snmp; we were not returning the opened socket to
	the caller when opening the listening socket.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/netaddr.c: Fix a case, found by Coverity, where we would not
	properly free an addrinfo.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/inet.c: Fix error case where a socket opened by init_conn()
	was not properly closed on error.  This leak was identified by
	Coverity.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/ctrls.c: If there are errors when opening a Controls socket,
	make sure that the socket is closed, otherwise we have a descriptor
	leak.  This was identified by Coverity.

2014-10-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/env.c: Fix memory leak identified by Coverity: setenv(3)
	already makes a copy of its arguments, which means that we do not
	need to do it.

2014-10-10  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sftp/keys.c, contrib/mod_tls.c: Make sure that when
	prompting the user for a passphrase for a certificate, we ensure
	that the buffer holding the passphrase is NUL-terminated.

2014-10-10  tjsaunders <tjsaunders@blackpearlsystems.com>

	* utils/scoreboard.c: If we fail to obtain a lock on the scoreboard
	and return the error, make sure we close the fd on the way out, lest
	we leak an fd.

2014-10-10  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/netaddr.c: Fix case where we might reference a buffer that has
	fallen out of scope.

2014-10-10  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_radius.c: Fix minor socket descriptor leak found by
	Coverity.

2014-10-09  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/inet.c, tests/Makefile.in, tests/api/inet.c,
	tests/api/stubs.c, tests/api/tests.c, tests/api/tests.h: Start
	working on unit tests for the Inet API.

2014-10-09  tjsaunders <tjsaunders@blackpearlsystems.com>

	* include/filter.h, src/filter.c, tests/Makefile.in,
	tests/api/filter.c, tests/api/tests.c, tests/api/tests.h: Adding
	unit tests for the Filter API.

2014-10-08  tjsaunders <tjsaunders@blackpearlsystems.com>

	* doc/howto/BCP.html, doc/modules/mod_auth.html: Minor doc updates,
	especially a caution for guarding the /proc filesystem.

2014-10-07  TJ Saunders <tj@castaglia.org>

	* include/options.h: Make the default lingering close timeout be 10
	secs, rather than 30 secs; the latter is rather long to wait for
	lost/wandering data to make its way to a client.

2014-10-07  TJ Saunders <tj@castaglia.org>

	* NEWS: Update NEWS for Bug#4110.

2014-10-07  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #52 from proftpd/core-solaris-conslog-bug4110 Bug#4110 - proftpd on Solaris should use /dev/conslog instead of
	/dev/lo...

2014-10-05  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Config/HiddenStores.pm: Added more
	regression tests, and tweaked code to add more logging, and to
	handle additional error cases.  This should help remove edge cases
	where HiddenStores are not properly deleted on error.

2014-10-05  TJ Saunders <tj@castaglia.org>

	* include/pr-syslog.h, lib/pr-syslog.c: Bug#4110 - proftpd on
	Solaris should use /dev/conslog instead of /dev/log.

2014-10-05  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/cipher.c, contrib/mod_sftp/kex.c,
	contrib/mod_sftp/mac.c: Increase buffer sizes where we write out
	mpints during the key exchange process, for Bug#4112.

2014-10-05  TJ Saunders <tj@castaglia.org>

	* : commit d2e0461cc51145c71dc1d8a4b48b669a39f5fe1a Author: TJ
	Saunders <tj@castaglia.org> Date:   Sun Oct 5 10:04:22 2014 -0700

2014-10-05  TJ Saunders <tj@castaglia.org>

	* doc/contrib/mod_ldap.html: Update mod_ldap docs to mention "ldap"
	trace logging channel, courtesy of Bug#4107.

2014-10-05  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #50 from proftpd/ldap-more-tracing-bug4107 Bug#4107 - LDAPLog can fill disk on a busy server.  Start moving
	some of...

2014-09-28  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_tls.c: Initial work on PSK support; needs testing.

2014-09-28  TJ Saunders <tj@castaglia.org>

	* contrib/mod_ldap.c: Bug#4107 - LDAPLog can fill disk on a busy
	server.  Start moving some of the mod_ldap logging into TraceLog.

2014-09-28  TJ Saunders <tj@castaglia.org>

	* NEWS: Updated NEWS for fix of Bug#4109.

2014-09-28  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #49 from proftpd/inet-ipv6-tclass-bug4109 Bug#4109 - setsockopt() call for IPV6_TCLASS should use
	IPPROTO_IPV6.

2014-09-23  TJ Saunders <tj@castaglia.org>

	* NEWS: Update NEWS with fix for Bug#4108.

2014-09-23  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #48 from
	proftpd/tls-data-conn-handshake-delay-bug4108 Bug#4108 - SSL handshakes for data connections sometimes stall for
	3-30 ...

2014-09-21  TJ Saunders <tj@castaglia.org>

	* : commit cf83753a6564b84f6962f60f2f0b49b4c7a89a97 Author: TJ
	Saunders <tj@castaglia.org> Date:   Sun Sep 21 21:51:56 2014 -0700

2014-09-21  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Use --enable-devel when building via travis-ci.

2014-09-21  TJ Saunders <tj@castaglia.org>

	* contrib/mod_deflate.c, modules/mod_memcache.c: Fix build
	warnings/breakage.

2014-09-21  TJ Saunders <tj@castaglia.org>

	* : commit d2f5d99fef7a30b3772b48ee4b3a400bf7ef9a65 Author: TJ
	Saunders <tj@castaglia.org> Date:   Sun Sep 21 16:53:03 2014 -0700

2014-09-18  TJ Saunders <tj@castaglia.org>

	* doc/modules/mod_facts.html: Slightly better anchor name.

2014-09-18  TJ Saunders <tj@castaglia.org>

	* doc/modules/mod_facts.html: Add FAQ about disabling mod_facts
	module entirely.

2014-09-14  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/cipher.c, contrib/mod_sftp/mac.c: Increase cipher
	and MAC buffer sizes, as a (somewhat educated) guess as to what
	might be causing the issues reported here:   https://forums.proftpd.org/smf/index.php/topic,11611.0.html

2014-09-10  TJ Saunders <tj@castaglia.org>

	* doc/contrib/mod_tls.html: Doc typo.

2014-09-07  TJ Saunders <tj@castaglia.org>

	* NEWS, contrib/mod_sftp/display.c: Make sure the fix for Bug#4094
	is applied to mod_sftp's handling of Display variables as well.

2014-09-07  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/keys.c: When loading the hostkey data, stop using
	the scratch buffer, and start using the provided pool.  In limited
	tests, this appears to help with rekeying.

2014-09-07  TJ Saunders <tj@castaglia.org>

	* doc/modules/mod_rlimit.html: Add a FAQ section to mod_rlimit, for
	the RLimitChroot directive.

2014-09-07  TJ Saunders <tj@castaglia.org>

	* modules/mod_core.c, modules/mod_xfer.c: Start moving toward using
	'core.module-reset' event handlers, rather than a POST_CMD HOST
	handler, for preparing a module for a changed main_server pointer
	due to a HOST command.

2014-09-04  tjsaunders <tjsaunders@blackpearlsystems.com>

	* NEWS, RELEASE_NOTES: Update NEWS, RELEASE_NOTES for fix for
	Bug#4098.

2014-09-04  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #44 from proftpd/sftp-hostkey-perms-bug4098 Bug#4098 -  mod_sftp unable to use SFTPHostKey due to being group
	readable in CentOS 7.

2014-09-03  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/keys.c, tests/t/lib/ProFTPD/TestSuite/Utils.pm,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Add
	integration/regression test for Bug#4098, and improve the log
	message when insecure permissions on hostkey files are found.

2014-08-30  TJ Saunders <tj@castaglia.org>

	* : commit 3e1a5851a7e2c7bcb711328225ffa9898780f2ec Merge: cd85317
	a8cc506 Author: TJ Saunders <tj@castaglia.org> Date:   Fri Aug 29
	08:51:04 2014 -0700

2014-08-29  TJ Saunders <tj@castaglia.org>

	* NEWS: Updating NEWS.

2014-08-29  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/mod_sftp.c, contrib/mod_sftp/mod_sftp.h.in: Make
	sure that if zlib support is lacking, mod_sftp does not to try
	negotiate compression during the key exchange.

2014-08-29  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/Makefile.in: Make sure to add -lz, when needed,
	to the building of a DSO mod_sftp.

2014-08-29  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/Makefile.in, contrib/mod_sftp/compress.c,
	contrib/mod_sftp/configure, contrib/mod_sftp/configure.in: Improve
	the detection of zlib support, and handling of the results, for
	mod_sftp.

2014-08-28  TJ Saunders <tj@castaglia.org>

	* Make.rules.in, configure, configure.in,
	contrib/mod_sftp/Makefile.in, contrib/mod_sftp/compress.c,
	contrib/mod_sftp/configure, contrib/mod_sftp/configure.in,
	contrib/mod_sftp/mod_sftp.c, contrib/mod_sftp/mod_sftp.h.in,
	contrib/mod_tls_memcache.c, contrib/mod_tls_shmcache.c: Bug#4102 -
	Failure to build mod_tls when using static libcrypto due to libdl
	linker errors.  In the course of fixing this issue, I also fixed problems with
	configure's detection of EC support in OpenSSL, and make it possible
	for mod_sftp to build without zlib support.

2014-08-27  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/configure, contrib/mod_sftp/configure.in: Fix
	another place where the libdl linker flag may need to come earlier
	in the list.

2014-08-27  TJ Saunders <tj@castaglia.org>

	* configure, configure.in: Bug#4102 - Failure to build mod_tls when
	using static libcrypto due to libdl linker errors.

2014-08-27  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/keys.c, contrib/mod_sftp/mod_sftp.c,
	contrib/mod_sftp/mod_sftp.h.in: Bug#4098 - mod_sftp unable to use
	SFTPHostKey due to being group readable in CentOS 7.

2014-08-19  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/kex.c,
	tests/t/etc/modules/mod_sftp/ssh_host_rsa1024_key,
	tests/t/etc/modules/mod_sftp/ssh_host_rsa1024_key.pub,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Bug#4097 - SSH rekey
	fails when using RSA hostkey smaller than 2048 bits.

2014-08-16  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #41 from proftpd/core-smkdir-only-when-needed Only use the mkdtemp(3) route in pr_fsio_smkdir() if root privs are
	need...

2014-08-14  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls.c, include/bindings.h, modules/mod_core.c,
	src/bindings.c, tests/t/lib/ProFTPD/TestSuite/FTP.pm,
	tests/t/lib/ProFTPD/Tests/Commands/HOST.pm: More work on handling
	the implications of HOST commands in various modules; much more work
	to be done here.

2014-08-14  TJ Saunders <tj@castaglia.org>

	* include/ftp.h, modules/mod_core.c,
	tests/t/lib/ProFTPD/TestSuite/FTP.pm: Create branch for finishing
	work on supporting the HOST command (Bug#3289).

2014-08-14  TJ Saunders <tj@castaglia.org>

	* src/fsio.c: Only use the mkdtemp(3) route in pr_fsio_smkdir() if
	root privs are needed for setting the desired ownership, i.e.
	UserOwner/GroupOwner are in effect.

2014-08-13  TJ Saunders <tj@castaglia.org>

	* doc/modules/mod_log.html: Update mod_log docs with a FAQ section,
	including a FAQ on how to get the ExtendedLog to include the reason
	why a session was ended.

2014-08-13  TJ Saunders <tj@castaglia.org>

	* modules/mod_ctrls.c, src/ctrls.c: Stylistic nits; no functional
	change.

2014-08-13  TJ Saunders <tj@castaglia.org>

	* configure: Regenerated configure script.

2014-08-13  TJ Saunders <tj@castaglia.org>

	* configure.in: Adding build summary for static and shared modules;
	more info will be added in this section.

2014-08-13  TJ Saunders <tj@castaglia.org>

	* : commit e423841e2d07f72d766baff5fddf094db343ff38 Author: TJ
	Saunders <tj@castaglia.org> Date:   Wed Aug 13 06:42:53 2014 -0700

2014-08-13  TJ Saunders <tj@castaglia.org>

	* configure.in: Fixed handling of too-many/misplaced colons in
	--with-shared argument.

2014-08-12  TJ Saunders <tj@castaglia.org>

	* configure, configure.in, src/fsio.c: Revert previous configure
	script change; it broke the build for shared modules.  Need to
	reexamine why that feedback was given on GitHub.  Also fix a typo
	causing a compiler warning.

2014-08-12  TJ Saunders <tj@castaglia.org>

	* configure: Regenerated configure script.

2014-08-12  TJ Saunders <tj@castaglia.org>

	* configure.in: Review feedback from GitHub.

2014-08-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* NEWS: Update NEWS for fix for Bug#4094.

2014-08-11  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #38 from
	proftpd/core-display-avail-space-bug4094 Bug#4094 - Available space on file system using %f displays wrong
	value.

2014-08-11  tjsaunders <tjsaunders@blackpearlsystems.com>

	* NEWS: Update NEWS for changes for Bug#4030.

2014-08-11  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #37 from proftpd/auth-negative-cache-bug4030 Bug#4030 - Cache negative/failed Auth API name/ID lookups.

2014-08-11  TJ Saunders <tj@castaglia.org>

	* include/auth.h, src/auth.c, tests/api/auth.c: Bug#4030 - Cache
	negative/failed Auth API name/ID lookups.

2014-08-10  TJ Saunders <tj@castaglia.org>

	* NEWS: Update NEWS with fix for Bug#4020.

2014-08-10  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #36 from proftpd/delay-delayonevent-bug4020 Bug#4020 - Add minimum delay options to mod_delay functionality

2014-08-10  TJ Saunders <tj@castaglia.org>

	* doc/modules/mod_delay.html, modules/mod_delay.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_delay.pm: Bug#4020 - Add
	minimum delay options to mod_delay functionality.

2014-08-09  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #35 from proftpd/fsio-getpipebuf-bug4050 Bug#4050 - Use of PIPE_BUF causes build failure on platforms without
	it.

2014-08-09  TJ Saunders <tj@castaglia.org>

	* doc/contrib/mod_copy.html, doc/contrib/mod_deflate.html,
	doc/contrib/mod_dnsbl.html, doc/contrib/mod_geoip.html,
	doc/contrib/mod_ifsession.html, doc/contrib/mod_rewrite.html,
	doc/contrib/mod_sftp.html, doc/contrib/mod_snmp.html,
	doc/contrib/mod_sql.html, doc/contrib/mod_sql_passwd.html,
	doc/contrib/mod_tls.html, doc/contrib/mod_tls_memcache.html,
	doc/contrib/mod_tls_shmcache.html, doc/modules/mod_auth_file.html,
	doc/modules/mod_auth_pam.html, doc/modules/mod_auth_unix.html,
	doc/modules/mod_ctrls.html, doc/modules/mod_delay.html,
	doc/modules/mod_dso.html, doc/modules/mod_facl.html,
	doc/modules/mod_ident.html, doc/modules/mod_xfer.html,
	modules/mod_auth_pam.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_tls_memcache.pm,
	tests/t/lib/ProFTPD/Tests/Modules/mod_tls_shmcache.pm: More
	documentation followup/cleanup for Bug#4054.

2014-08-09  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sql_passwd.c, contrib/mod_tls_memcache.c,
	contrib/mod_tls_shmcache.c, doc/contrib/mod_copy.html,
	doc/contrib/mod_deflate.html, doc/contrib/mod_dnsbl.html,
	doc/contrib/mod_geoip.html, doc/contrib/mod_ifsession.html,
	doc/contrib/mod_rewrite.html, doc/contrib/mod_sftp.html,
	doc/contrib/mod_snmp.html, doc/contrib/mod_sql.html,
	doc/contrib/mod_sql_passwd.html, doc/contrib/mod_tls.html,
	doc/contrib/mod_tls_memcache.html,
	doc/contrib/mod_tls_shmcache.html: Bug#4054 - Ensure that module
	documentation mentions Trace channel names where applicable.

2014-08-09  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #34 from proftpd/core-serverident-var-version Support %{version} variable for ServerIdent

2014-08-09  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #33 from proftpd/sftp-missing-payload-bug4093 Bug#4093 - Improve mod_sftp handling of missing packet payloads.

2014-08-09  TJ Saunders <tj@castaglia.org>

	* src/session.c, tests/t/lib/ProFTPD/Tests/Config/ServerIdent.pm: 
	Support a %{version} variable in the ServerIdent value.

2014-08-09  TJ Saunders <tj@castaglia.org>

	* modules/mod_ctrls.c: Clarify the mod_ctrls message when chown(2)
	fails to include the local socket path.

2014-08-09  TJ Saunders <tj@castaglia.org>

	* modules/mod_log.c: Fix handling of ExtendedLogs which log to
	syslog.

2014-08-08  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm: Adding another
	regression test for Bug#4067, proving that an ExtendedLog using just
	the READ or WRITE classes properly logs SFTP uploads and downloads,
	without needing to explicitly include the SFTP class.

2014-08-07  tjsaunders <tjsaunders@blackpearlsystems.com>

	* RELEASE_NOTES: Minor note, for future fleshing out, about
	ExtendedLog functionality changes.

2014-08-07  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/inet.c: Avoid log spam on FreeBSD 10, which is reported to
	indicate that the IPV6_TCLASS socket option is not usable on IPv6
	sockets via EINVAL, rather than the more appropriate ENOPROTOOPT.
	Sigh.

2014-07-30  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/auth-hostbased.c, contrib/mod_sftp/blacklist.c,
	contrib/mod_sftp/keys.c, contrib/mod_sftp/keystore.c,
	contrib/mod_sftp/msg.c: Bug#4093 - Improve mod_sftp handling of
	missing packet payloads.

2014-07-28  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/bindings.c: Ignore "unable to accept an incoming connection:
	Software caused connection abort" messages, as they are almost
	always caused by TCP probes/health checks from e.g. naive load
	balancers.

2014-07-28  tjsaunders <tjsaunders@blackpearlsystems.com>

	* NEWS: Updated NEWS for fix of Bug#4091.

2014-07-28  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #32 from
	proftpd/core-privs-error-logging-bug4091 Bug#4091 - Log "Operation not permitted" privs errors at NOTICE
	rather t...

2014-07-27  TJ Saunders <tj@castaglia.org>

	* src/privs.c: Bug#4091 - Log "Operation not permitted" privs errors
	at NOTICE rather than ERROR.

2014-07-25  tjsaunders <tjsaunders@blackpearlsystems.com>

	* NEWS, contrib/mod_wrap2_file.c: Update NEWS for fix of Bug#4090.

2014-07-25  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #31 from proftpd/wrap2-file-ipv6-addr-bug4090 Bug#4090 - mod_wrap2_file does not support IPv6 addresses properly.

2014-07-25  tjsaunders <tjsaunders@blackpearlsystems.com>

	* NEWS: Updated NEWS with fix for Bug#4089.

2014-07-25  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #30 from
	proftpd/sftp-auth-multiple-attempts-bug4089 Bug#4089 - mod_sftp does not allow multiple attempts using a given

2014-07-19  TJ Saunders <tj@castaglia.org>

	* NEWS: Update NEWS for fix for Bug#4087.

2014-07-19  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #29 from
	proftpd/sftp-maxloginattempts-none-bug4087 Bug#4087 - mod_sftp does not handle "MaxLoginAttempts none"
	properly.

2014-07-17  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/mod_sftp.h.in: Keep the mod_sftp version string
	format consistently using three digits, and use "1.0.0" instead of
	"1.0".

2014-07-17  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c, contrib/mod_sftp/mod_sftp.h.in: Fix
	SFTPLog message if LINK request fails.  Bump mod_sftp version, due
	to fixed LINK handling (and other fixes).

2014-07-16  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/auth.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Bug#4087 - mod_sftp
	does not handle "MaxLoginAttempts none" properly.

2014-07-16  TJ Saunders <tj@castaglia.org>

	* tests/t/etc/modules/mod_sftp/authorized_rsa_keys2,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Adding regression
	test of publickey SSH authentication, where the key is stored as the
	2nd key in the file.

2014-07-09  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp_pam.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sftp_pam.pm: Add louder
	logging for when mod_sftp_pam denies a login, along with a
	regression test that tickles this behavior.

2014-07-08  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm: Add
	regression test for SQLUserInfo which returns NULL for the uid/gid
	columns; this ensures that a) mod_sql doesn't segfault on such
	return values, and b) that the SQLDefaultUID/SQLDefaultGID values
	are used.

2014-07-06  TJ Saunders <tj@castaglia.org>

	* NEWS: Updated NEWS with fix of Bug#4081.

2014-07-06  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #28 from
	proftpd/sftp-symlink-rel-path-bug4081 Bug#4081 - Not possible to create relative symlinks with SFTP.

2014-07-05  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sql.c, modules/mod_log.c: Add support for the
	%{file-offset} variable to mod_sql (and the missing %{file-modified}
	variable).  Fixed formatting/printing of %{file-offset} for
	ExtendedLog.

2014-07-05  TJ Saunders <tj@castaglia.org>

	* NEWS: Updating NEWS for Bug#4084.

2014-07-05  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #27 from
	proftpd/ls-nlst-glob-recursion-bug4084 Bug#4084 - "NLST *" returns files from subdirectories.

2014-07-05  TJ Saunders <tj@castaglia.org>

	* modules/mod_ls.c, tests/t/lib/ProFTPD/Tests/Commands/NLST.pm: 
	Bug#4084 - "NLST *" returns files from subdirectories.

2014-07-05  TJ Saunders <tj@castaglia.org>

	* tests/t/config/maxtransfersperhost.t,
	tests/t/config/maxtransfersperuser.t,
	tests/t/lib/ProFTPD/Tests/Config/MaxTransfersPerHost.pm,
	tests/t/lib/ProFTPD/Tests/Config/MaxTransfersPerUser.pm,
	tests/tests.pl: Adding regression tests for the MaxTransfersPerHost
	and MaxTransfersPerUser directives.

2014-07-03  TJ Saunders <tj@castaglia.org>

	* doc/modules/mod_auth.html, doc/modules/mod_xfer.html: Fill in
	missing descriptions for the MaxClients* and MaxTransfers*
	directives.

2014-07-02  tjsaunders <tjsaunders@blackpearlsystems.com>

	* NEWS: Updating NEWS for Bug#4083.

2014-07-02  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #26 from
	proftpd/sql-defaulthomedir-empty-home-bug4083 Bug#4083 - Using SQLDefaultHomedir with null home results in "No
	such user"

2014-07-02  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sql.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm: Bug#4083 -
	Using SQLDefaultHomedir with null home results in "No such user".

2014-06-26  TJ Saunders <tj@castaglia.org>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_ifsession.pm: Adding
	regression test for particular mod_ifsession config, based on
	reports from the forums.

2014-06-26  TJ Saunders <tj@castaglia.org>

	* modules/mod_log.c: Fix bug in the handling of ExtendedLog class
	name parsing, introduced as part of the change for Bug#4067.

2014-06-24  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c, contrib/mod_sftp/scp.c,
	modules/mod_xfer.c: Stash the file-offset note for SCP transfers as
	well.  Fix up misleading comments.

2014-06-24  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c, include/mod_log.h, modules/mod_log.c,
	modules/mod_xfer.c: Add support for a new %{file-offset} LogFormat
	variable, to store the file offset at which a file transfer (upload
	or download) starts.

2014-06-24  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #25 from proftpd/core-cmd-errno-note Stash an errno value for all commands, for use by e.g. auditing
	modules

2014-06-23  TJ Saunders <tj@castaglia.org>

	* : commit 7d818268492254c9ee32f5ef4ab24edc04fe2a7e Author:
	tjsaunders <tjsaunders@blackpearlsystems.com> Date:   Mon Jun 23
	09:34:29 2014 -0700

2014-06-23  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #24 from proftpd/sftp-symlink-order-bug4080 Bug#4080 - mod_sftp does not implement SFTP LINK request properly.

2014-06-22  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c, src/fsio.c, tests/api/fsio.c: Bug#4080 -
	mod_sftp does not implement SFTP LINK request properly.

2014-06-20  tjsaunders <tjsaunders@blackpearlsystems.com>

	* doc/modules/mod_rlimit.html: Adding clarifying comments about
	RLimitChroot.

2014-06-20  tjsaunders <tjsaunders@blackpearlsystems.com>

	* NEWS: Update NEWS for fix for Bug#4079.

2014-06-20  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #23 from proftpd/sftp-space-available-bug4079 Bug#4079 - Invalid response encoding for SFTP space-available
	request.

2014-06-20  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sftp/fxp.c: Bug#4079 - Invalid response encoding for
	SFTP space-available request.

2014-06-19  TJ Saunders <tj@castaglia.org>

	* modules/mod_xfer.c: Add trace message of when REST offset exceeds
	file size, containg the requested offset and the file size in
	question.

2014-06-19  TJ Saunders <tj@castaglia.org>

	* modules/mod_xfer.c, src/netio.c,
	tests/t/lib/ProFTPD/Tests/Config/HiddenStores.pm: Adding regression
	tests for the behavior reported in Bug#4035, and tweaking the code
	to handle these cases.

2014-06-19  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #21 from
	proftpd/exec-execenable-per-directory-bug4076 Bug#4076 - Ability to disable mod_exec on a per-directory basis.

2014-06-19  TJ Saunders <tj@castaglia.org>

	* : commit 37569a94b3156be8f732741774702bb3fe5136be Author:
	tjsaunders <tjsaunders@blackpearlsystems.com> Date:   Thu Jun 19
	18:36:35 2014 -0700

2014-06-19  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #20 from proftpd/shaper-log-sighup-bug4077 Bug#4077 - ShaperLog not closed/reopened on SIGHUP, causing log
	rotation

2014-06-19  TJ Saunders <tj@castaglia.org>

	* : commit f214df3fd415cb9ce2cb6fd74bd85caa5b0ecc46 Author: TJ
	Saunders <tj@castaglia.org> Date:   Thu Jun 19 07:54:37 2014 -0700

2014-06-18  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #22 from
	proftpd/auth-addl-failure-reasons-bug4070 Bug#4070 - Support wider range of authentication failures.

2014-06-18  TJ Saunders <tj@castaglia.org>

	* : commit 5027925f5133e3d911eb7af27672fe45bda2818d Author: TJ
	Saunders <tj@castaglia.org> Date:   Wed Jun 18 21:50:26 2014 -0700

2014-06-18  TJ Saunders <tj@castaglia.org>

	* contrib/mod_ldap.c, src/auth.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_ldap.pm: Something shifted
	that is causing mod_ldap login troubles; making some tweaks to
	hopefully narrow down the issue.

2014-06-18  TJ Saunders <tj@castaglia.org>

	* doc/modules/mod_facts.html: Mention, in the mod_facts docs, how to
	build that module as a shared module.

2014-06-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/stash.c: Address more travis-ci compiler warnings.

2014-06-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/pidfile.c: Remember to set errno if opening the PidFile fails.
	This fixes a compiler warning detected by travis-ci.

2014-06-18  tjsaunders <tjsaunders@blackpearlsystems.com>

	* NEWS: Update NEWS with mention of Bug#4073.

2014-06-18  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #19 from
	proftpd/tls-implicitssl-download-bug4073 Bug#4073 - Polycom VOIP phones unable to use FTPS data transfers.

2014-06-17  TJ Saunders <tj@castaglia.org>

	* include/auth.h, modules/mod_auth.c, modules/mod_auth_pam.c: 
	Bug#4070 - Support wider range of authentication failures.

2014-06-17  TJ Saunders <tj@castaglia.org>

	* contrib/mod_exec.c, doc/contrib/mod_exec.html,
	tests/t/lib/ProFTPD/Tests/Modules/mod_exec.pm: Bug#4076 - Ability to
	disable mod_exec on a per-directory basis.

2014-06-17  TJ Saunders <tj@castaglia.org>

	* include/cmd.h, src/cmd.c, tests/api/cmd.c: Start working on
	stashing the errno value for every command in the cmd->notes table.
	This will allow modules (such as audit modules for Bug#3807) access
	to that errno value, for tracking/logging.

2014-06-17  TJ Saunders <tj@castaglia.org>

	* contrib/mod_shaper.c: Bug#4077 - ShaperLog not closed/reopened on
	SIGHUP, causing log rotation problems.

2014-06-17  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls.c: Remove unnecessary comment.

2014-06-17  TJ Saunders <tj@castaglia.org>

	* contrib/mod_tls.c, modules/mod_xfer.c: Bug#4073 - Polycom VOIP
	phones unable to use FTPS data transfers.

2014-06-17  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #18 from
	proftpd/ls-stat-response-codes-bug3990 Fix regression for Bug#3990

2014-06-17  TJ Saunders <tj@castaglia.org>

	* modules/mod_ls.c, tests/t/lib/ProFTPD/Tests/Commands/STAT.pm: Fix
	the handling of the response code for STAT commands, fixing a
	regression caused by the previous commits for Bug#3990.

2014-05-30  tjsaunders <tjsaunders@blackpearlsystems.com>

	* NEWS: Update NEWS for Bug#4063.

2014-05-30  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #16 from
	proftpd/fsio-smkdir-cifs-eacces-bug4063 Bug#4063 -  Unable to create directory on NFS/CIFS partition:
	Permission...

2014-05-30  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #17 from
	proftpd/ls-nlst-opt-a-wrong-directory-bug4069 Bug#4069 - NLST -a shows / directory instead of the current
	directory.

2014-05-30  tjsaunders <tjsaunders@blackpearlsystems.com>

	* modules/mod_ls.c: Bug#4069 - NLST -a shows / directory instead of
	the current directory.

2014-05-29  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/fsio.c: Bug#4063 -  Unable to create directory on NFS/CIFS
	partition: Permission denied.

2014-05-29  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #15 from proftpd/auth-anon-maxclients-bug4068 Bug#4068 - MaxClients directive doesn't work for <Anonymous>
	sessions.

2014-05-29  tjsaunders <tjsaunders@blackpearlsystems.com>

	* : commit cd89bc454ba0e3655b01a79ca32cc342595bdd46 Author:
	tjsaunders <tjsaunders@blackpearlsystems.com> Date:   Thu May 29
	09:57:31 2014 -0700

2014-05-29  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #14 from proftpd/sftp-extlog-class-bug4067 ExtendedLog classes for SSH, SFTP (Bug#4067)

2014-05-29  tjsaunders <tjsaunders@blackpearlsystems.com>

	* modules/mod_log.c,
	tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm: Better
	implementation of logging class exclusion, and tested with
	regression tests, including the new SSH and SFTP logging classes.

2014-05-28  tjsaunders <tjsaunders@blackpearlsystems.com>

	* NEWS, RELEASE_NOTES, contrib/mod_sftp/auth.c,
	contrib/mod_sftp/channel.c, contrib/mod_sftp/fxp.c,
	contrib/mod_sftp/kex.c, contrib/mod_sftp/service.c,
	include/modules.h, modules/mod_log.c: Bug#4067 - Create ExtendedLog
	class for SFTP requests.

2014-05-28  tjsaunders <tjsaunders@blackpearlsystems.com>

	* doc/modules/mod_core.html: Update ServerIdent description to
	mention the supported variables, and add description for the
	ServerName directive.

2014-05-28  tjsaunders <tjsaunders@blackpearlsystems.com>

	* NEWS, doc/contrib/mod_sftp.html: Update NEWS, mod_sftp docs for
	Bug#4065.

2014-05-28  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #13 from
	proftpd/sftp-banner-environ-variable-bug4065 Bug#4065 - mod_sftp should provide the SSH client banner as
	environment variable, for logging

2014-05-27  tjsaunders <tjsaunders@blackpearlsystems.com>

	* contrib/mod_sftp/mod_sftp.c: Bug#4065 - mod_sftp should provide
	the SSH client banner as environment variable, for logging.

2014-05-27  tjsaunders <tjsaunders@blackpearlsystems.com>

	* doc/contrib/mod_sftp.html: Improved formatting for mod_sftp
	environment variables.

2014-05-27  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #12 from
	proftpd/scoreboard-entry-locking-bug3823 Attempt to mitigate possible cause for Bug#3823 by replacing use of
	F_SE...

2014-05-27  TJ Saunders <tj@castaglia.org>

	* src/scoreboard.c: Attempt to mitigate possible cause for Bug#3823
	by replacing use of F_SETLKW when updating scoreboard entries to
	F_SETLK, and handling interruptions.  This should reduce any
	(potentially long) blocking behaviors.

2014-05-26  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #11 from proftpd/signals-refactoring Refactor the signal-handling code out of src/main.c, and into its
	own so...

2014-05-25  TJ Saunders <tj@castaglia.org>

	* include/conf.h: Previous merge forgot to include the new configdb
	header.

2014-05-25  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #10 from proftpd/dirtree-refactoring Refactor the src/dirtree.c file into smaller chunks, one for the
	pr_conf...

2014-05-24  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #9 from
	proftpd/hiddenstores-pid-variable-bug4062 Bug#4062 - Support PID variable in HiddenStores filename.

2014-05-24  TJ Saunders <tj@castaglia.org>

	* include/log.h, src/log.c, src/main.c: Fix slight regression in
	logging behavior due to changes for Bug#3983.  If the -d
	command-line option is used, then make sure the default syslog level
	is DEBUG, so that the requested debug logging appears.

2014-05-24  TJ Saunders <tj@castaglia.org>

	* modules/mod_xfer.c,
	tests/t/lib/ProFTPD/Tests/Config/HiddenStores.pm: Bug#4062 - Support
	PID variable in HiddenStores filename.

2014-05-24  TJ Saunders <tj@castaglia.org>

	* modules/mod_auth_file.c: Sprinkle more signal handling in
	potentially long while() loops when handling AuthUserFiles and
	AuthGroupFiles.

2014-05-24  TJ Saunders <tj@castaglia.org>

	* modules/mod_auth_file.c: Fix ordering of handlers in
	mod_auth_file; no functional change.

2014-05-24  TJ Saunders <tj@castaglia.org>

	* modules/mod_auth_file.c, modules/mod_auth_unix.c: Use better trace
	channel names in the provided auth modules.

2014-05-24  TJ Saunders <tj@castaglia.org>

	* modules/mod_auth_file.c: Comment typo fixed.  No functional
	change.

2014-05-24  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #8 from
	proftpd/snmp-multiple-agent-addrs-bug4061 Bug#4061 - SNMPAgent should support multiple addresses, including
	IPv6

2014-05-23  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #7 from proftpd/aix-build-errors Fix AIX build issues, as reported in the forums; see:

2014-05-21  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #6 from proftpd/symtab-hash-comparison When storing symbols in the symbol table hash ("stash"), stop
	storing al...

2014-05-21  TJ Saunders <tj@castaglia.org>

	* contrib/mod_ctrls_admin.c, contrib/mod_quotatab_ldap.c,
	contrib/mod_quotatab_radius.c, contrib/mod_quotatab_sql.c,
	contrib/mod_ratio.c, contrib/mod_sftp_sql.c,
	contrib/mod_sql_passwd.c, contrib/mod_wrap2_sql.c,
	include/dirtree.h, include/stash.h, src/auth.c, src/cmd.c,
	src/main.c, src/modules.c, src/parser.c, src/stash.c,
	tests/api/stash.c: When storing symbols in the symbol table hash
	("stash"), stop storing all symbol types (CMD, CONF, AUTH, and HOOK)
	all in the same table.  Instead, have different tables for each
	different type.  This makes it faster when looking up (by name) a
	symbol of a given type; less symbol names to grovel through and
	compare.  And speaking of symbol comparisons, this change also stores the hash
	value (of the symbol name) as part of the symbol data.  Thus when
	doing symbol lookups, the hash value is compared FIRST, and only if
	that value matches will the more in-depth comparison (by name
	length, name content) be done.  The overall effect should be a net gain in speed (less latency when
	dispatching e.g. commands, auth lookups, parsing), and a drop in CPU
	(due to fewer string comparisons hopefully).

2014-05-20  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #5 from proftpd/parser-pidfile-unit-tests Add unit tests for the Pidfile API, and start working on tests for
	the

2014-05-19  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #4 from proftpd/trace-unit-tests Adding unit tests for the Trace API; fixed some minor bugs found
	while

2014-05-18  TJ Saunders <tj@castaglia.org>

	* .gitignore: A few more files for git to ignore.

2014-05-18  TJ Saunders <tj@castaglia.org>

	* src/main.c: Stylistic nit; no functional change.

2014-05-18  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #3 from proftpd/clang-warnings Clean up some warnings spotted by travis-ci's clang build.

2014-05-18  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #2 from proftpd/radius-timeout-parsing Update mod_radius to use pr_str_get_duration() for parsing timeout
	strin...

2014-05-18  TJ Saunders <tj@castaglia.org>

	* contrib/mod_radius.c: Update mod_radius to use
	pr_str_get_duration() for parsing timeout strings for the
	RadiusAuthServer and RadiusAcctServer directives.  Fixed stylistic
	nits while there.

2014-05-18  TJ Saunders <tj@castaglia.org>

	* Makefile.in: Clean up the .git/ directory, and .gitignore and
	.travis.yml files, when preparing a release.

2014-05-18  TJ Saunders <tj@castaglia.org>

	* .cvsignore, contrib/.cvsignore, contrib/mod_dnsbl/.cvsignore,
	contrib/mod_load/.cvsignore, contrib/mod_sftp/.cvsignore,
	contrib/mod_snmp/.cvsignore, contrib/mod_wrap2/.cvsignore,
	include/.cvsignore, lib/.cvsignore, lib/libcap/.cvsignore,
	locale/.cvsignore, modules/.cvsignore, src/.cvsignore,
	tests/.cvsignore, tests/api/.cvsignore, tests/array.c,
	tests/class.c, tests/env.c, tests/event.c, tests/expr.c,
	tests/feat.c, tests/modules.c, tests/netacl.c, tests/netaddr.c,
	tests/pool.c, tests/regexp.c, tests/scoreboard.c, tests/sets.c,
	tests/str.c, tests/stubs.c, tests/table.c, tests/tests.c,
	tests/tests.h, tests/timers.c, tests/var.c, tests/version.c,
	utils/.cvsignore: Clean up more files from the cvs2git conversion.

2014-05-18  TJ Saunders <tj@castaglia.org>

	* NEWS: Update NEWS.

2014-05-18  TJ Saunders <tj@castaglia.org>

	* : Merge pull request #1 from proftpd/stat-response-code-bug3990 Bug#3990 - Use 213 response code for STAT on a file.  We also use
	212 fo...

2014-05-18  TJ Saunders <tj@castaglia.org>

	* contrib/mod_quotatab.c: Style nits; no functional change.

2014-05-18  TJ Saunders <tj@castaglia.org>

	* tests/api/cmd.c: Remove unused variable.

2014-05-18  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Disable the static code analyzers, for now; they can
	be re-enabled when needed.  Do another configure/build, this time
	with all modules being shared, rather than static.

2014-05-18  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Have cppcheck write to stdout its errors.  Use normal
	email notifications (i.e. committer).

2014-05-18  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Skip checking header files, and unit test files, when
	performing static code analysis.

2014-05-18  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Still wrestling with cppcheck.  Sigh.

2014-05-18  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Fix the cppcheck arguments.  Enable PCRE support.

2014-05-18  TJ Saunders <tj@castaglia.org>

	* .travis.yml: More tweaks to the static code analysers.

2014-05-18  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Use the direct email address to the -committers list.

2014-05-18  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Keep cppcheck from scanning *every* file; use find to
	tell it which file to scan.  Break the `make' and `make check-api'
	steps onto separate lines, for legibility.

2014-05-18  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Start commenting the travis-ci config file.  Add some
	static code analysis in.

2014-05-17  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Direct email notifications of build success/failures
	to the proftp-committers list.

2014-05-17  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Enable memcache support.

2014-05-17  TJ Saunders <tj@castaglia.org>

	* contrib/mod_sql_postgres.c: Fix another build warning spotted by
	travis-ci.

2014-05-17  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Make the dependency installations a little easier to
	read.  Build the MySQL and Postgres modules.  Install gettext, so
	that we can use --enable-nls.

2014-05-17  TJ Saunders <tj@castaglia.org>

	* contrib/mod_snmp/asn1.c, contrib/mod_snmp/notify.c,
	contrib/mod_snmp/smi.c, contrib/mod_sql_sqlite.c, src/log.c: Clean
	up build warnings spotted by travis-ci.

2014-05-17  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Now install the check library, to enable the API/unit
	tests -- and run them.

2014-05-17  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Need the PAM libraries/headers for some modules.

2014-05-17  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Build mod_geoip as well; we'll need its geoip library
	dependency as well.

2014-05-17  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Install more dependencies, and build more modules,
	via travis-ci.

2014-05-17  TJ Saunders <tj@castaglia.org>

	* .travis.yml: Add a .travis.yml file, to start using travis-ci for
	continuous build/integration.  I'm sure we'll get fancier over time.

2014-05-17  TJ Saunders <tj@castaglia.org>

	* src/data.c: Forgot to update copyright dates with last
	modification.

2014-05-17  TJ Saunders <tj@castaglia.org>

	* NEWS, src/log.c: Bug#3983 - Change default SyslogLevel to be
	NOTICE rather than DEBUG.

2014-05-17  TJ Saunders <tj@castaglia.org>

	* NEWS, src/data.c, src/inet.c,
	tests/t/lib/ProFTPD/Tests/Commands/PORT.pm: Bug#3944 -  Session
	closed if active data transfer fails due to "Address already in use"
	error.

2014-05-17  TJ Saunders <tj@castaglia.org>

	* src/netaddr.c: Avoid null pointer dereference for interfaces with
	no addresses.

2014-05-17  TJ Saunders <tj@castaglia.org>

	* po/Makefile.in: Remove unused po/ directory; it came back with the
	cvs2git conversion.

2014-05-17  TJ Saunders <tj@castaglia.org>

	* NEWS: Bug#4055 - "error setting listen fd IPV6_TCLASS: Protocol
	not available" log message.

2014-05-17  TJ Saunders <tj@castaglia.org>

	* : commit 3fd34befa71cdc41bc1375b243a18e8837ee76d0 Author:
	tjsaunders <tjsaunders@blackpearlsystems.com> Date:   Fri May 16
	09:53:25 2014 -0700

2014-05-16  tjsaunders <tjsaunders@blackpearlsystems.com>

	* .gitignore: Improving the .gitignore file.

2014-05-16  tjsaunders <tjsaunders@blackpearlsystems.com>

	* .gitignore: Adding .gitignore file.

2014-05-16  tjsaunders <tjsaunders@blackpearlsystems.com>

	* src/inet.c: Bug#4055: Ignore any ENOPROTOOPT errors when setting
	the IPv6 TCLASS (TOS) flags on the socket; they make for noisier
	logging without providing any actual value to the user/admin.

2014-05-16  tjsaunders <tjsaunders@blackpearlsystems.com>

	* include/version.h: Bump version to reflect new release cycle.

2014-05-15  castaglia <castaglia>

	* NEWS: Preparing for release.

2014-05-15  castaglia <castaglia>

	* ChangeLog: Updated ChangeLog.

2014-05-15  castaglia <castaglia>

	* contrib/dist/rpm/proftpd.spec, include/version.h: Preparing files
	for release.

2014-05-15  castaglia <castaglia>

	* locale/files.txt: Updated list of files for localization.

2014-05-09  castaglia <castaglia>

	* RELEASE_NOTES: Fleshing out release notes for upcoming release.

2014-05-05  castaglia <castaglia>

	* contrib/mod_sql_passwd.c: Use sql_log() instead of pr_log_debug(),
	so that the logging is consistently done in the module.  There may
	still be a few outliers.

2014-05-04  castaglia <castaglia>

	* doc/contrib/mod_sql_passwd.html: Updated SQLPasswordPBKDF2 docs in
	light of Bug#4052.

2014-05-04  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sql_passwd.pm: Added
	regression test for Bug#4052.

2014-05-04  castaglia <castaglia>

	* NEWS, contrib/mod_sql_passwd.c: Bug#4052 - Enhance
	SQLPasswordPBKDF2 to support per-user query for settings.

2014-05-04  castaglia <castaglia>

	* doc/contrib/mod_site_misc.html: Emphasize that both acces and mod
	times are set by SITE UTIME.

2014-05-04  castaglia <castaglia>

	* NEWS, modules/mod_facl.c: Bug#4044 - mod_facl prevents a normal
	SIGHUP reload.

2014-05-03  castaglia <castaglia>

	* NEWS, modules/mod_core.c: Bug#4042 - MIC command between RNFR and
	RNTO should not be rejected.

2014-05-02  castaglia <castaglia>

	* NEWS, contrib/mod_exec.c: Bug#4049 - mod_exec should include
	supplemental groups when running commands as logged-in user.

2014-04-30  castaglia <castaglia>

	* contrib/mod_ban.c: As a follow-on to the fix for Bug#4048, add
	some "headroom" to the SHM segment, to allow for multiple
	racing/competing processes incrementing indices.

2014-04-30  castaglia <castaglia>

	* NEWS, contrib/mod_ban.c: Bug#4048 - Race condition in mod_ban can
	lead to segfault of all new connections.

2014-04-28  castaglia <castaglia>

	* modules/mod_xfer.c: Slightly better fix for Bug#4046; less chance
	of overflowing the off_t datatype on filesystems with lots of free
	space.

2014-04-28  castaglia <castaglia>

	* NEWS, modules/mod_xfer.c: Bug#4046 - ALLO command failed because
	of bad size check.

2014-03-26  castaglia <castaglia>

	* doc/howto/TLS.html: Typo.

2014-03-19  castaglia <castaglia>

	* contrib/mod_tls.c: Bug#4039 - Fix compile error in mod_tls, when
	built using newer OpenSSL versions.  This is a regression caused by
	Bug#4029.

2014-03-13  castaglia <castaglia>

	* doc/howto/Chroot.html: Fix broken link, per Bug#4038.

2014-03-08  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Config/DeleteAbortedStores.pm: Adding
	some regression tests for the DeleteAbortedStores directive, for
	when timeouts kick in and kill the session.

2014-03-08  castaglia <castaglia>

	* modules/mod_xfer.c: If a session dies in the middle of a data
	transfer, make sure that the path in the fake cmd_rec is correct.
	It was empty, which led to some misleading logging.

2014-03-08  castaglia <castaglia>

	* NEWS, contrib/mod_tls.c: Bug#4024 - TLS 1.1/1.2 configurable, but
	not properly implemented.

2014-03-05  castaglia <castaglia>

	* contrib/mod_tls.c: When seeding OpenSSL's PRNG manually, use
	gettimeofday(2) instead of time(3).

2014-03-04  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Adding regression
	tests for Bug#4034.

2014-03-04  castaglia <castaglia>

	* NEWS, contrib/mod_sftp/auth.c: Bug#4034 - SSH publickey
	authentication fails with "MaxLoginAttempts 1".

2014-03-03  castaglia <castaglia>

	* doc/contrib/mod_sftp.html: Add mod_sftp FAQ about pointing an SSH
	client (*not* SFTP or SCP) at mod_sftp, and why that connection
	would fail.

2014-03-02  castaglia <castaglia>

	* doc/contrib/mod_sftp.html: Document the AllowInsecureLogin
	SFTPOption.

2014-03-02  castaglia <castaglia>

	* contrib/mod_sftp/auth-kbdint.c, contrib/mod_sftp/auth-password.c,
	contrib/mod_sftp/mod_sftp.c, contrib/mod_sftp/mod_sftp.h.in: Add a
	new SFTPOption, called 'AllowInsecureLogin'.  This is needed for
	sites which wish to use/allow SSH2 logins that use the 'none' cipher
	or digest (hopefully just for performance testing).

2014-03-02  castaglia <castaglia>

	* NEWS, contrib/mod_sftp/mod_sftp.c: Bug#4032 - Restarting proftpd
	with mod_sftp fails due to permissions on SFTPHostKey file.

2014-03-02  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Fix the mod_sftp
	regression tests which SHOULD have caught Bug#4033.

2014-03-02  castaglia <castaglia>

	* NEWS, contrib/mod_sftp/cipher.c: Bug#4033 - mod_sftp fails to
	create SSH2 session using 'none' cipher.

2014-03-01  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_wrap2_file.pm: Added
	regression test for Bug#3938.

2014-03-01  castaglia <castaglia>

	* NEWS, contrib/mod_wrap2/mod_wrap2.c: Bug#3938 - mod_wrap2 uses
	reverse DNS regardless "UseReverseDNS off".

2014-02-28  castaglia <castaglia>

	* tests/t/config/passiveports.t,
	tests/t/lib/ProFTPD/Tests/Config/PassivePorts.pm, tests/tests.pl: 
	Added regression tests for the PassivePorts directive in various
	configuration contexts, i.e. "server config", <Global>, and
	<VirtualHost>.

2014-02-28  castaglia <castaglia>

	* NEWS, contrib/mod_tls.c: Bug#4029 - TLSOptions EnableDiags logs
	"unknown version (771)" for TLS 1.1/1.2 connections.

2014-02-23  castaglia <castaglia>

	* contrib/mod_ban.c: Minor name/string change; no functional change.

2014-02-23  castaglia <castaglia>

	* contrib/mod_ban.c, tests/t/lib/ProFTPD/Tests/Modules/mod_ban.pm: 
	Allow for custom, user-specified event names in the BanOnEvent
	directive.  This will make it easier to support rules for events
	other than the ones that are specially handled, and ease the need to
	add special handling in the future.

2014-02-23  castaglia <castaglia>

	* doc/contrib/mod_ban.html: Added support for RootLogin bans.

2014-02-23  castaglia <castaglia>

	* contrib/mod_ban.c, tests/t/lib/ProFTPD/Tests/Modules/mod_ban.pm: 
	Make it possible to ban clients which attempt to login as root.

2014-02-21  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Adding reproduction
	recipe/regression test for Bug#4026.

2014-02-19  castaglia <castaglia>

	* doc/contrib/mod_sftp.html: Add "Cipher Implementations" section to
	"Known Client Issues", noting that SBB clients don't handle the
	blowfish-ctr cipher.

2014-02-18  castaglia <castaglia>

	* doc/contrib/mod_sftp.html: Fix typo/misnamed cipher in list.

2014-02-15  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm: Adding
	regression test for Bug#4025.

2014-02-15  castaglia <castaglia>

	* NEWS, contrib/mod_ifsession.c: Bug#4025 - <IfClass> sections do
	not work for multiple SQLLog directives.

2014-02-15  castaglia <castaglia>

	* contrib/mod_sql.c: If SQLEngine is not configured, then DO emit
	the "no SQLAuthTypes configured" log message if necessary.  Previous
	commit would not have handled the case where SQLEngine was not
	explicitly set.

2014-02-15  castaglia <castaglia>

	* contrib/mod_sql.c: If "SQLEngine log" is configured, then do NOT
	log a message saying "error: no SQLAuthTypes configured".  Stylistic
	nits addressed while there.

2014-02-11  castaglia <castaglia>

	* NEWS, src/fsio.c: Bug#4022 - "Directory not empty" error when
	creating directory is misleading.

2014-02-11  castaglia <castaglia>

	* src/stash.c: Fix minor compiler warning when --enable-devel is
	used.

2014-02-09  castaglia <castaglia>

	* modules/mod_delay.c: The regression tests caught a small
	regression in mod_delay, where the fix for Bug#3622 was reverted
	partly by the fixes for Bug#3970.

2014-02-09  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Commands/MKD.pm: Another MKD test,
	making sure that using a preceding CWD doesn't gum up the works.
	Also makes for a nice testbed for pr_fsio_smkdir() issues.

2014-02-09  castaglia <castaglia>

	* src/fsio.c: Add more logging of error conditions in the
	pr_fsio_smkdir() function, for better diagnosing some reported MKD
	errors.

2014-02-09  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_rewrite.pm: Yet another data
	point/reproduction recipe for Bug#4017.

2014-02-08  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Config/SocketOptions.pm: Add basic test
	for SocketOption keepalive.

2014-02-05  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_rewrite.pm: Additional
	regression/reproduction recipe for Bug#4017, this time using PCRE
	regexes.

2014-02-03  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_rewrite.pm: Regression
	test/reproduction recipe for Bug#4017.

2014-02-01  castaglia <castaglia>

	* contrib/mod_tls.c: Update mod_tls to start using the pr_netio_t
	notes table for stashing/retrieving its SSL objects, rather than the
	strm_data void pointer.  The table is more flexible, and allows for
	other code to use the keys as needed.

2014-01-31  castaglia <castaglia>

	* modules/mod_rlimit.c,
	tests/t/lib/ProFTPD/Tests/Config/RLimitChroot.pm: Allow for per-user
	(via <IfUser>) setting of the RLimitChroot directive.

2014-01-31  castaglia <castaglia>

	* doc/modules/mod_rlimit.html: Add description for new RLimitChroot
	directive to mod_rlimit docs.

2014-01-31  castaglia <castaglia>

	* src/fsio.c: Match URLs for "Roaring Beast" reports.

2014-01-31  castaglia <castaglia>

	* tests/t/config/rlimitchroot.t,
	tests/t/lib/ProFTPD/Tests/Config/RLimitChroot.pm, tests/tests.pl: 
	Adding regression tests for the new RLimitChroot directive.

2014-01-31  castaglia <castaglia>

	* NEWS, RELEASE_NOTES, include/fsio.h, modules/mod_rlimit.c,
	src/fsio.c: Bug#4018 - Implement checks for sensitive directories
	when chrooted.

2014-01-30  castaglia <castaglia>

	* doc/modules/mod_core.html: Add description of SocketBindTight
	directive to mod_core docs, and include FAQ about using it.

2014-01-29  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp/rewrite.pm: Adding
	regression/reproduction recipe for Bug#4017.

2014-01-29  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm: Fix broken (only
	on MacOSX) test.

2014-01-29  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm: Minor tweaks
	while investigating Bug#3638.

2014-01-29  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_tls.pm: Updated mod_tls
	tests to work around bug in Net-FTPSSL version 0.21's quot()
	implementation.

2014-01-28  castaglia <castaglia>

	* include/version.h: Updating version for CVS.

2014-01-28  castaglia <castaglia>

	* ChangeLog: Updated ChangeLog.

2014-01-28  castaglia <castaglia>

	* NEWS, contrib/dist/rpm/proftpd.spec, include/version.h: Prepping
	files for RC.

2014-01-28  castaglia <castaglia>

	* contrib/mod_sftp/crypto.c, contrib/mod_sftp/keys.c,
	contrib/mod_sftp/umac.c: Allow mod_sftp to be compiled using an old
	version of OpenSSL, e.g.  OpenSSL-0.9.6.  Fixes Bug#4016.

2014-01-28  castaglia <castaglia>

	* contrib/mod_tls.c: Enable mod_tls to be built using old OpenSSL
	version; tested using OpenSSL-0.9.6h.

2014-01-27  castaglia <castaglia>

	* doc/contrib/mod_quotatab.html: Try to make the Installation notes
	for mod_quotatab a little clearer.

2014-01-27  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Commands/ALLO.pm: Quell compiler warning
	about redefined variables.

2014-01-27  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Logins.pm: Quell compiler warning about
	overloaded variables.

2014-01-27  castaglia <castaglia>

	* tests/t/lib/ProFTPD/TestSuite/Utils.pm: Copy-pasto was blocking
	the setting of different values for the (as-yet) little used
	test_setup() function.

2014-01-27  castaglia <castaglia>

	* tests/api/str.c: With this tweak (of debatable and investigatable
	value), all of the API tests now pass on my old Linux machine.

2014-01-27  castaglia <castaglia>

	* tests/api/netaddr.c: Make the INCL_DEVICE API test a little more
	resilient by providing some fallback device names.

2014-01-27  castaglia <castaglia>

	* src/fsio.c, tests/api/cmd.c: The API testsuite found some places
	where we were not properly checking for null strings, which might
	lead to segfaults.

2014-01-27  castaglia <castaglia>

	* tests/Makefile.in, tests/api/stubs.c: Make sure the API testsuite
	compiles properly when --enable-nls is used.

2014-01-27  castaglia <castaglia>

	* contrib/mod_snmp/db.c: Quell compiler warning about unused
	variable.

2014-01-27  castaglia <castaglia>

	* RELEASE_NOTES, doc/howto/Radius.html, doc/howto/index.html: Adding
	(finally!) RADIUS howto.

2014-01-26  castaglia <castaglia>

	* contrib/mod_ban.c: Typo in comment; no functional change.

2014-01-25  castaglia <castaglia>

	* modules/mod_core.c: Make sure to handle the case where units
	aren't specified properly.

2014-01-25  castaglia <castaglia>

	* NEWS, include/options.h, modules/mod_core.c, src/main.c,
	tests/t/lib/ProFTPD/Tests/Config/CommandBufferSize.pm: Bug#4014 -
	CommandBufferSize should override PR_DEFAULT_CMD_BUFSZ.

2014-01-24  castaglia <castaglia>

	* contrib/mod_tls.c: Bug#4015 - Possible bad/ambiguous expression
	found by static code analyzer cppcheck.

2014-01-22  castaglia <castaglia>

	* doc/howto/TLS.html: Updates to the TLS howto, adding some FAQs and
	noting that secure FXP transfers are now supported.

2014-01-22  castaglia <castaglia>

	* doc/howto/SQL.html: Add more links from the SQL howto to the
	mod_sql docs, and add more substance to the "min ID" question,
	pointing out the default UID/GID values.

2014-01-22  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_auth_file.pm: Update
	AuthGroupFile world-readable test to match changes to the
	permissions checking code.

2014-01-22  castaglia <castaglia>

	* modules/mod_auth_file.c: Alter the permission checks (per
	Bug#3892) to allow world-readable AuthGroupFiles; there's no
	sensitive information in there.

2014-01-22  castaglia <castaglia>

	* doc/modules/mod_auth_file.html: Improve/expand on the FAQ about
	permissions.

2014-01-21  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Commands/RETR.pm: Adding regression test
	for Bug#4010 (which, I think, is actually a client bug).

2014-01-21  castaglia <castaglia>

	* RELEASE_NOTES: Update release notes, getting them ready for a
	release.

2014-01-21  castaglia <castaglia>

	* doc/contrib/mod_exec.html: Update the ExecOnEvent description to
	match the code.

2014-01-21  castaglia <castaglia>

	* doc/contrib/mod_sql.html: Note when the IgnoreConfigFile SQLOption
	first appeared.

2014-01-21  castaglia <castaglia>

	* doc/contrib/mod_ldap.html: Add description for LDAPLog directive
	to mod_ldap docs.

2014-01-20  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Added regression
	test for Bug#4013.

2014-01-20  castaglia <castaglia>

	* NEWS, contrib/mod_sftp/scp.c: Bug#4013 - SCP upload of shorter
	file does not completely overwrite existing file of same name.

2014-01-20  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Commands/NLST.pm: Adding regression
	tests for several NLST bugs, including Bug#4011.

2014-01-20  castaglia <castaglia>

	* NEWS, include/fsio.h, modules/mod_ls.c, src/fsio.c,
	tests/api/fsio.c: Bug#4011 - NLST ../ shows current directory
	contents rather than parent directory.

2014-01-17  castaglia <castaglia>

	* configure: Updated configure.

2014-01-17  castaglia <castaglia>

	* configure.in: Fix default location of datadir to be
	'/usr/local/share', not '/usr/locale/share'.

2014-01-17  castaglia <castaglia>

	* contrib/mod_sftp/fxp.c,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Make sure that SFTP
	CLOSE requests are logged as either READ or WRITE requests as
	appropriate (per the ExtendedLog logging classes), but not both.

2014-01-13  castaglia <castaglia>

	* doc/contrib/mod_sftp.html: Update SFTPClientMatch description for
	'sftpUTF8ProtocolVersion', noting the NLS requirement.  Also add FAQ
	about this, with regard to accepted protocol versions.

2014-01-13  castaglia <castaglia>

	* contrib/mod_sftp/mod_sftp.c: If the 'sftpUTF8ProtocolVersion'
	SFTPClientMatch key is used, AND the proftpd has not been compiled
	with --enable-nls, then display a more informative error about this
	situation, instead of acting as if 'sftpUTF8ProtocolVersion' is
	unknown.

2014-01-08  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_tls.pm: Tweaks to the
	mod_tls testsuite to make it pass (more) on my Mac; I think it's
	related to the version of Net::FTPSSL being used.

2014-01-06  castaglia <castaglia>

	* NEWS, contrib/mod_radius.c: Bug#4006 - RADIUS "service-type"
	attribute encoded with wrong length on 64-bit system.

2014-01-06  castaglia <castaglia>

	* tests/Makefile.in, tests/api/netio.c, tests/api/stubs.c,
	tests/api/tests.c, tests/api/tests.h: Adding API tests for the NetIO
	API, focusing heavily on the pr_netio_telnet_gets() function.

2014-01-06  castaglia <castaglia>

	* include/netio.h, src/netio.c: Make the function for allocating and
	attaching a pr_buffer_t to a NetIO stream public.

2014-01-03  castaglia <castaglia>

	* contrib/mod_deflate.c: Refactor the same note name string into a
	single #define.

2014-01-03  castaglia <castaglia>

	* contrib/mod_deflate.c: Update the mod_deflate module to use the
	new pr_netio_stream_t notes table for stashing the z_stream
	pointers, rather than the nstrm_data member.

2014-01-02  castaglia <castaglia>

	* doc/modules/mod_log.html: Fix inaccurate description of %p
	LogFormat variable.

2014-01-02  castaglia <castaglia>

	* include/netio.h, src/netio.c: A NetIO stream object now has a
	table for stashing any/all kinds of module-specific data.  This
	table will eventually replace the void *strm_data member, once all
	modules have been updated to use the new table for their stashing.

2014-01-02  castaglia <castaglia>

	* src/netio.c: Use slightly better, more descriptive names for the
	default NetIO objects.  Make the code use consistent style, i.e.
	switch statements, enclosing parentheses around function pointers,
	etc throughout.  No functional change.

2014-01-01  castaglia <castaglia>

	* contrib/mod_tls.c: Fix grammar-o in a comment.

2014-01-01  castaglia <castaglia>

	* src/fsio.c: When reading from a file using pr_fsio_gets(), use the
	given iosz hint as is, rather than using the smaller size of given
	buffer vs iosz hint.  The iosz hint, if present, will always be more
	efficient.  The given buffer can then be filled from the read-in
	buffer.

2013-12-30  castaglia <castaglia>

	* src/parser.c: Clean up a few stylistic nits in the parser code; no
	functional change.

2013-12-30  castaglia <castaglia>

	* src/fsio.c: Clean up a few stylistic nits in fsio.c; no functional
	change.

2013-12-29  castaglia <castaglia>

	* modules/mod_auth.c: Once the "has this client authenticated?"
	check -- which occurs per-command -- has succeeded, record that
	success value such that we do not do the same lookup for subsequent
	commands.  Once a client has authenticated, that state will not
	change for the duration of the connection.  At least until REIN is
	implemented.

2013-12-29  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Logins.pm: Add regression test for
	failed logins due to out-of-sequence commands.

2013-12-29  castaglia <castaglia>

	* tests/t/lib/ProFTPD/TestSuite/FTP.pm: Despite Net::FTP's
	documentation with regard to FTP firewalls (i.e. proxying), the
	implementation leaves much to be desired.  So I worked around the
	Net::FTP internals to make it do what I wanted.

2013-12-27  castaglia <castaglia>

	* NEWS, contrib/mod_sftp/scp.c: Bug#4004 - IgnoreSCPUploadPerms
	SFTPOption not honored properly for SCP directory upload.

2013-12-27  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Adding regression
	test for Bug#4004.

2013-12-23  castaglia <castaglia>

	* include/netaddr.h, src/netaddr.c, tests/api/netaddr.c: Rename the
	ADDRS_ONLY pr_netaddr_get_addr2() flag to EXCL_DNS, to be more
	consistent with the naming of similar flags for the option, and to
	be more descriptive.

2013-12-23  castaglia <castaglia>

	* include/netaddr.h, src/netaddr.c, tests/api/netaddr.c: Support new
	flag for pr_netaddr_get_addr2() which can be used to skip DNS name
	resolutions, and only check whether the given string is a resolvable
	IP address.  Add missing regression test for pr_netaddr_get_addr2(),
	with tests for the INCL_DEVICE and ADDRS_ONLY flags.

2013-12-20  castaglia <castaglia>

	* NEWS, contrib/mod_sftp/dhparams.pem: Bug#4002 - Add 7680-bit DH
	parameter to mod_sftp bundled dhparams.pem file.

2013-12-20  castaglia <castaglia>

	* modules/mod_auth_file.c: Try mitigating some of the terror/madness
	caused by Bug#3892 preemptively by using root privs when opening the
	AuthUserFile/AuthGroupFile for reading.

2013-12-20  castaglia <castaglia>

	* modules/mod_auth_file.c: Slight tweaks to the error messages
	logged.

2013-12-20  castaglia <castaglia>

	* modules/mod_auth_file.c: Add more information to error messages
	logged by mod_auth_file due to the stricter checks added for
	Bug#3892.

2013-12-19  castaglia <castaglia>

	* contrib/mod_wrap2_file.c: Add some helpful logging when
	mod_wrap2_file performs resolution on the given table path.

2013-12-19  castaglia <castaglia>

	* doc/contrib/mod_wrap2.html: Fix typos.

2013-12-19  castaglia <castaglia>

	* NEWS, contrib/mod_sftp/cipher.c, contrib/mod_sftp/mac.c: Bug#4001
	- mod_sftp fails key exchange for 8192-bit DH group.

2013-12-16  castaglia <castaglia>

	* contrib/mod_sftp/fxp.c: Fix regressions in the handling of <Limit>
	sections applicable to READDIR SFTP requests, caused by the fix for
	Bug#3753 and pointed out by Mike Futerko.

2013-12-15  castaglia <castaglia>

	* src/netaddr.c: When caching the remote session address
	information, make sure to properly zero out the cache structures
	first.

2013-12-15  castaglia <castaglia>

	* tests/t/lib/ProFTPD/TestSuite/Utils.pm: Handle the new
	test_cleanup function properly, i.e. by going one level deeper into
	the call stack when writing out to the tests.log file, for accurate
	reporting of the failing testcase in question.

2013-12-15  castaglia <castaglia>

	* tests/t/lib/ProFTPD/TestSuite/Utils.pm: Provide a way to tell
	test_cleanup() to keep the log files around.

2013-12-14  castaglia <castaglia>

	* contrib/mod_sftp/mod_sftp.c: Fix typo in comment; no functional
	change.

2013-12-12  castaglia <castaglia>

	* doc/contrib/mod_geoip.html: Typo.

2013-12-12  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_shaper.pm: Checking in
	reproduction recipe for Bug#3928, for when I can address that issue
	in the future.

2013-12-12  castaglia <castaglia>

	* NEWS, RELEASE_NOTES, contrib/mod_exec.c: Bug#3876 - ExecOnEvent
	should be configurable per <VirtualHost>/<Global>.

2013-12-12  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Commands/ALLO.pm: Regression tests for
	Bug#3996.

2013-12-12  castaglia <castaglia>

	* NEWS, modules/mod_xfer.c: Bug#3996 - Handling ALLO command can
	result in wrong response when chrooted.

2013-12-12  castaglia <castaglia>

	* NEWS, contrib/mod_sftp/keys.c: Bug#3992 - RSA signature issue when
	connecting using PuTTY/WinSCP.

2013-12-10  castaglia <castaglia>

	* contrib/ftpasswd: Fix minor issue with Bug#3994 fix, to prevent
	multiple --locks on the same user from prepending multiple "lock"
	characters; just one is enough.

2013-12-09  castaglia <castaglia>

	* doc/contrib/mod_tls.html: Update mod_tls docs with descriptions
	for the new EC cert/key directives.

2013-12-09  castaglia <castaglia>

	* NEWS, RELEASE_NOTES, contrib/mod_tls.c: Bug#3772 - Support
	Elliptic Curve Cryptography (ECC) certs for FTPS connections.

2013-12-09  castaglia <castaglia>

	* contrib/mod_quotatab.c, contrib/mod_snmp/db.c, include/fsio.h,
	modules/mod_delay.c, src/fsio.c, src/scoreboard.c, src/wtmp.c: 
	Refactor some of the common code for getting a usable fd into a new
	pr_fs_get_usable_fd2() function, and update some of the sites to use
	the new function.

2013-12-09  castaglia <castaglia>

	* NEWS, contrib/mod_quotatab.c, contrib/mod_snmp/db.c,
	modules/mod_delay.c, src/scoreboard.c, src/wtmp.c: Bug#3970 -
	ProFTPD should not use fd 2 (stderr) for files.

2013-12-09  castaglia <castaglia>

	* modules/mod_core.c: Fix compiler warning about type mismatch.

2013-12-09  castaglia <castaglia>

	* tests/t/etc/modules/mod_tls/NOTES,
	tests/t/etc/modules/mod_tls/ec-ca.pem,
	tests/t/etc/modules/mod_tls/ec-server-cert.pem: Adding EC certs for
	tests.

2013-12-08  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Config/Limit/Anonymous.pm: Add
	regression tests for <Anonymous> configs with upload-only
	directories.

2013-12-08  castaglia <castaglia>

	* contrib/ftpasswd, doc/contrib/ftpasswd.html: Minor reordering of
	new --lock, --unlock options, and updating the docs to reflect the
	new options.

2013-12-08  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Contrib/ftpasswd.pm: Adding regression
	tests for Bug#3994.

2013-12-08  castaglia <castaglia>

	* NEWS, RELEASE_NOTES, contrib/ftpasswd: Bug#3994 - ftpasswd utility
	should support --lock/--unlock options.

2013-12-08  castaglia <castaglia>

	* NEWS, contrib/ftpasswd: Bug#3995 - ftpasswd utility should prevent
	concurrent modification of files.

2013-12-05  castaglia <castaglia>

	* doc/contrib/mod_sftp.html: Update mod_sftp docs for the new
	IgnoreSCPUploadTimes SFTPOption.

2013-12-05  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_sftp.pm: Added regression
	test for Bug#3998 (the new IgnoreSCPUploadTimes SFTPOption).

2013-12-05  castaglia <castaglia>

	* NEWS, RELEASE_NOTES, contrib/mod_sftp/mod_sftp.c,
	contrib/mod_sftp/mod_sftp.h.in, contrib/mod_sftp/scp.c: Bug#3998 -
	Support IgnoreSCPUploadTimes SFTPOption.

2013-12-05  castaglia <castaglia>

	* doc/contrib/mod_sftp.html: List the supported SFTPOptions in
	lexicographical order.

2013-12-05  castaglia <castaglia>

	* modules/mod_ctrls.c: Make sure that the mod_ctrls module cannot be
	built without using the --enable-ctrls configure option.

2013-12-04  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Commands/ALLO.pm: Adding regression test
	for the ALLO command in a chrooted environment.

2013-12-04  castaglia <castaglia>

	* lib/pr_fnmatch_loop.c: Bug#3997 - pr_fnmatch_loop.c compilation
	error: "CHAR str[0] : error #2094: the size of an array must be
	greater than zero"

2013-11-24  castaglia <castaglia>

	* NEWS, contrib/mod_exec.c, contrib/mod_ldap.c, contrib/mod_tls.c,
	include/str.h, modules/mod_auth.c, modules/mod_core.c,
	modules/mod_xfer.c, src/str.c, tests/api/str.c: Bug#3965 - Timeout
	directives have inconsistent maximum values.

2013-11-18  castaglia <castaglia>

	* tests/t/lib/ProFTPD/TestSuite/Utils.pm,
	tests/t/lib/ProFTPD/Tests/Commands/RETR.pm: Create new test_setup()
	and test_cleanup() functions, to reduce the amount of boilerplate in
	testcases and to reduce the accrued technical debt in the testsuite
	codebase by applying the DRY principle.

2013-11-11  castaglia <castaglia>

	* doc/modules/mod_log.html: Added description of new %{basename}
	variable to the LogFormat docs.

2013-11-11  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm,
	tests/t/lib/ProFTPD/Tests/Modules/mod_sql_sqlite.pm: Added
	(simplistic) regression tests for the new LogFormat %{basename}
	variable introduced for Bug#3987.

2013-11-11  castaglia <castaglia>

	* NEWS, RELEASE_NOTES, contrib/mod_sql.c, include/mod_log.h,
	modules/mod_log.c: Bug#3987 - LogFormat variable for just the
	filename.

2013-11-10  castaglia <castaglia>

	* RELEASE_NOTES, doc/howto/LogMessages.html: Check in the
	work-to-date on a log message compendium; there are still a few
	sections to fill in.

2013-11-10  castaglia <castaglia>

	* src/auth.c: Make the "Preparing to chroot to" log message slightly
	less noisy.

2013-11-10  castaglia <castaglia>

	* modules/mod_xfer.c: Shift the HiddenStore DEBUG level messages to
	properly use the pr_log_debug() function, and to use a lower DEBUG
	level, so they are not as noisy (and are more consistent with other
	debug-level logging).

2013-11-10  castaglia <castaglia>

	* modules/mod_auth_file.c: Improve the log message slightly when
	mod_auth_file can't open its configured files.

2013-11-09  castaglia <castaglia>

	* src/bindings.c: Found another place with inconsistent log message
	formatting; now fixed.

2013-11-09  castaglia <castaglia>

	* src/data.c: Fixed formatting of log message to be more consistent
	with the format used elsewhere, i.e. that the strerror(3) string
	follows a colon and space.

2013-11-09  castaglia <castaglia>

	* doc/modules/mod_core.html: Include description for the UserOwner
	directive in the mod_core docs.

2013-11-09  castaglia <castaglia>

	* contrib/mod_ifsession.c: Log messages about misconfigurations
	should be logged at WARNING, not ERR.

2013-11-05  castaglia <castaglia>

	* NEWS, contrib/mod_tls_memcache.c, contrib/mod_tls_shmcache.c: 
	Bug#3991 - SSL session caching modules use incorrect OpenSSL cache
	mode flags, breaking session caching.

2013-11-05  castaglia <castaglia>

	* doc/contrib/mod_tls_shmcache.html: Updated mod_tls_shmcache docs.

2013-10-27  castaglia <castaglia>

	* doc/howto/TLS.html: TLS FAQ about difference between shm and
	memcache for SSL session caching.

2013-10-15  castaglia <castaglia>

	* src/fsio.c: If the underlying filesystem doesn't support chmod(2)
	(per Bug#3986), then at least log a DEBUG level message about it.

2013-10-15  castaglia <castaglia>

	* NEWS, src/fsio.c: Bug#3986 - Support filesystems which do not
	support chmod(2)/chown(2), e.g.  FAT/ExFAT.

2013-10-14  castaglia <castaglia>

	* NEWS, RELEASE_NOTES: Bug#3982 - Normalize log messages and levels.

2013-10-13  castaglia <castaglia>

	* modules/mod_dso.c, src/log.c: Fix comments to match code.

2013-10-13  castaglia <castaglia>

	* modules/mod_core.c: Tweak a log message to be more in line with
	similar log messages elsewhere.

2013-10-13  castaglia <castaglia>

	* contrib/mod_rewrite.c: If a configured RewriteLog is in a
	world-writable directory, log it -- but use the same phrasing as
	used for other modules in similar situations.

2013-10-13  castaglia <castaglia>

	* src/fsio.c: Found only one instance of a DEBUG level message which
	needed a different log level (Bug#3982).

2013-10-13  castaglia <castaglia>

	* src/auth.c: The log message about chrooting is more of a DEBUG
	level message, rather than INFO (per Bug#3982).

2013-10-13  castaglia <castaglia>

	* modules/mod_ctrls.c, modules/mod_delay.c, modules/mod_dso.c,
	modules/mod_xfer.c: Changing the log levels of messages for some
	modules to be more consistent, per Bug#3982.

2013-10-13  castaglia <castaglia>

	* contrib/mod_ban.c, contrib/mod_ctrls_admin.c,
	contrib/mod_dynmasq.c, contrib/mod_geoip.c,
	contrib/mod_load/mod_load.c, contrib/mod_sftp/fxp.c,
	contrib/mod_sftp/scp.c, contrib/mod_shaper.c, contrib/mod_tls.c,
	contrib/mod_tls_memcache.c, contrib/mod_tls_shmcache.c,
	contrib/mod_wrap.c: Tweak the log levels of various log messages in
	contrib modules, bringing the messages in line with a more
	consistent logging policy (Bug#3982).

2013-10-13  castaglia <castaglia>

	* contrib/ftpmail: If there are comments after the user/password
	values in the ftpmail SMTP AUTH file, trim them off.

2013-10-13  castaglia <castaglia>

	* src/bindings.c, src/dirtree.c, src/lastlog.c, src/log.c,
	src/main.c: Combing through NOTICE level log messages in src/ turned
	up a few needed tweaks, for Bug#3982.

2013-10-13  castaglia <castaglia>

	* modules/mod_auth.c, modules/mod_auth_pam.c,
	modules/mod_auth_unix.c, modules/mod_cap.c, modules/mod_ctrls.c,
	modules/mod_dso.c, modules/mod_lang.c, modules/mod_log.c,
	modules/mod_memcache.c, modules/mod_xfer.c: Minor tweaks to log
	messages and log levels, bringing them in line with the
	expected/consistent log levels, per Bug#3982.

2013-10-13  castaglia <castaglia>

	* contrib/mod_dnsbl/mod_dnsbl.c, contrib/mod_geoip.c,
	contrib/mod_ldap.c, contrib/mod_log_forensic.c,
	contrib/mod_radius.c, contrib/mod_ratio.c, contrib/mod_rewrite.c,
	contrib/mod_sftp/auth.c, contrib/mod_sftp/keys.c,
	contrib/mod_sftp/mod_sftp.c, contrib/mod_snmp/mod_snmp.c,
	contrib/mod_sql.c, contrib/mod_tls.c: Tweaks to log levels of
	various messages in the contrib modules, making them be more
	consistent, per Bug#3982.

2013-10-11  castaglia <castaglia>

	* src/auth.c: Slightly better log message, hopefully.

2013-10-11  castaglia <castaglia>

	* src/auth.c, tests/t/lib/ProFTPD/TestSuite/Utils.pm,
	tests/t/lib/ProFTPD/Tests/Modules/mod_auth_file.pm: Added regression
	tests for Bug#3985, and slightly better logging that MIGHT help
	track down issues like this in the future.

2013-10-09  castaglia <castaglia>

	* doc/howto/Logging.html: Fix broken anchor tag.

2013-10-09  castaglia <castaglia>

	* src/timers.c: Use the WARNING level if we can't install our signal
	handlers needed for timers, rather than NOTICE.

2013-10-09  castaglia <castaglia>

	* contrib/mod_dynmasq.c: Slightly better language in the log message
	when we can't resolve a DNS name.

2013-10-09  castaglia <castaglia>

	* contrib/mod_deflate.c: Use more appropriate log levels for issues
	opening a DeflateLog file, and also make sure to preserve errno for
	proper error reporting.

2013-10-09  castaglia <castaglia>

	* contrib/mod_ban.c: Most of the NOTICE-level log messages in
	mod_ban are actually WARNING-level worthy; make them use WARNING,
	then.

2013-10-09  castaglia <castaglia>

	* modules/mod_xfer.c: Found a few more places where errno might be
	getting clobbered, and thus leading to inaccurate reporting.

2013-10-09  castaglia <castaglia>

	* modules/mod_delay.c: Preserve errno properly when reporting errors
	here.

2013-10-09  castaglia <castaglia>

	* src/main.c: Fix another case where the reported errno value might
	not be the correct one.

2013-10-09  castaglia <castaglia>

	* modules/mod_auth.c: Cut down on possibly-spurious log warnings.

2013-10-09  castaglia <castaglia>

	* src/lastlog.c: Another place where we might be losing the real
	errno value.

2013-10-09  castaglia <castaglia>

	* src/mkhome.c: Make sure that when an error occurs, we log and
	preserve the errno properly.

2013-10-09  castaglia <castaglia>

	* src/wtmp.c: Fix a few more places where we need to be careful to
	preserve the errno value.

2013-10-09  castaglia <castaglia>

	* modules/mod_auth_unix.c: More cases where we need to take care to
	preserve the errno value properly.

2013-10-09  castaglia <castaglia>

	* modules/mod_core.c: Preserve errno for proper error reporting.

2013-10-09  castaglia <castaglia>

	* modules/mod_facl.c: Make sure we preserve errno appropriately.

2013-10-09  castaglia <castaglia>

	* doc/modules/mod_core.html: One more link which should use the
	#Syslog anchor in the Logging doc.

2013-10-09  castaglia <castaglia>

	* contrib/mod_sql_postgres.c: Forgot to update copyright date on
	previous checkin.

2013-10-08  castaglia <castaglia>

	* src/child.c: If we update an empty child list, explicitly set the
	listlen back to zero.  It should already be this value anyway, we
	just want to make sure.

2013-10-07  castaglia <castaglia>

	* contrib/mod_rewrite.c, contrib/mod_sftp/auth.c,
	contrib/mod_sftp/mod_sftp.c, contrib/mod_snmp/mod_snmp.c,
	contrib/mod_sql_mysql.c, contrib/mod_sql_postgres.c,
	contrib/mod_sql_sqlite.c, contrib/mod_tls.c, modules/mod_auth.c,
	modules/mod_auth_file.c, modules/mod_auth_unix.c,
	modules/mod_cap.c, modules/mod_delay.c, modules/mod_facl.c,
	modules/mod_log.c, modules/mod_memcache.c, modules/mod_site.c,
	modules/mod_xfer.c, src/auth.c, src/bindings.c, src/data.c,
	src/dirtree.c, src/display.c, src/fsio.c, src/inet.c, src/main.c,
	src/modules.c, src/parser.c, src/pool.c: Shuffle some of the log
	levels used for log messages, making ERR message that should be
	something else BE something else, leaving ERR messages which should
	be ERR alone (Bug#3982).

2013-10-07  castaglia <castaglia>

	* NEWS, RELEASE_NOTES, contrib/mod_ldap.c: Bug#3888 - Add LDAPLog
	directive to mod_ldap.

2013-10-07  castaglia <castaglia>

	* contrib/mod_ldap.c: Start making stylistic changes to the mod_ldap
	code, bringing it more in line with the coding style used elsewhere
	in proftpd.  No functional change.

2013-10-07  castaglia <castaglia>

	* contrib/mod_sftp/auth.c, modules/mod_auth.c: Log "SECURITY
	VIOLATION" messages at the NOTICE level (Bug#3982).

2013-10-07  castaglia <castaglia>

	* contrib/mod_exec.c, contrib/mod_sftp/cipher.c,
	contrib/mod_sftp/crypto.c, contrib/mod_sftp/keys.c,
	contrib/mod_sftp/mac.c, contrib/mod_sftp/msg.c,
	contrib/mod_sftp_pam.c, contrib/mod_shaper.c,
	contrib/mod_snmp/mod_snmp.c, contrib/mod_tls.c, include/log.h,
	modules/mod_auth_file.c, modules/mod_ls.c, src/data.c, src/env.c,
	src/fsio.c, src/log.c, src/main.c, src/pool.c: On second thought,
	remove the whole lookup-of-log-level-by-resource mechanism.  It's
	overengineered, and we don't need it right now.

2013-10-06  castaglia <castaglia>

	* contrib/mod_exec.c, contrib/mod_sftp/keys.c,
	contrib/mod_snmp/mod_snmp.c, contrib/mod_tls.c, include/log.h,
	src/log.c, src/main.c: When fork(2) fails and we need to log a
	message, use the new lookup function to determine the log level for
	that "process" resource.

2013-10-06  castaglia <castaglia>

	* contrib/mod_sftp/cipher.c, contrib/mod_sftp/crypto.c,
	contrib/mod_sftp/keys.c, contrib/mod_sftp/mac.c,
	contrib/mod_sftp/msg.c, contrib/mod_sftp_pam.c,
	contrib/mod_shaper.c, contrib/mod_tls.c, include/log.h,
	modules/mod_auth_file.c, modules/mod_ls.c, src/data.c, src/env.c,
	src/fsio.c, src/log.c, src/pool.c: When a resource is exhausted, we
	now have a lookup function to determine the proper log level to use
	for the ensuing log message.  This lets us coordinate/tweak these
	levels in the future as needed, as well as being able to
	differentiate/tweak different log levels for the same resource but
	different errors (e.g. EMFILE vs ENFILE for fd exhaustion).

2013-10-06  castaglia <castaglia>

	* contrib/mod_snmp/mod_snmp.c: mod_snmp, too, needs to log fork(2)
	failures at the ALERT level (Bug#3982).

2013-10-06  castaglia <castaglia>

	* contrib/mod_exec.c, contrib/mod_tls.c, src/main.c: Log other
	out-of-resource errors (such as fork(2) and pipe(2) failures) at the
	ALERT log level, per Bug#3982.

2013-10-06  castaglia <castaglia>

	* modules/mod_ls.c, src/data.c, src/env.c, src/pool.c: Let's be
	consistent about the message logged when we are out of memory, and
	use "Out of memory!", rather than a mix of the former as well as
	variations on "memory exhausted" (Bug#3982).

2013-10-06  castaglia <castaglia>

	* contrib/mod_sftp/crypto.c, contrib/mod_sftp/keys.c,
	contrib/mod_tls.c, modules/mod_ls.c, src/data.c, src/env.c: Found
	more places in the code where an out-of-memory condition needed to
	be logged at the ALERT level, per Bug#3982.

2013-10-06  castaglia <castaglia>

	* NEWS, contrib/mod_sftp/cipher.c, contrib/mod_sftp/mac.c,
	contrib/mod_sftp/msg.c, contrib/mod_sftp_pam.c,
	contrib/mod_shaper.c, modules/mod_auth_file.c, src/fsio.c,
	src/pool.c: Bug#3982 - Normalize log messages and levels.  We start by logging all out-of-memory conditions at the ALERT level.

2013-10-06  castaglia <castaglia>

	* contrib/mod_snmp/.cvsignore: Updated .cvsignore files for
	mod_dnsbl and mod_snmp.

2013-10-06  castaglia <castaglia>

	* doc/howto/LogLevels.html: More typos, layout fixes.

2013-10-06  castaglia <castaglia>

	* doc/howto/LogLevels.html: Typo.

2013-10-06  castaglia <castaglia>

	* doc/howto/index.html: Add the LogLevels doc to the index.

2013-10-06  castaglia <castaglia>

	* doc/howto/LogLevels.html, doc/howto/Logging.html,
	doc/modules/mod_core.html: Beef up the logging documentation by
	covering the log levels, and the granularity of the DEBUG level
	messages.  This is necessary groundwork for the next stop: creating
	a log message catalog, per level.

2013-10-06  castaglia <castaglia>

	* doc/howto/Compiling.html: Minor embellishment on what the
	install_user/install_group variables are for (and what they are NOT
	for).

2013-10-06  castaglia <castaglia>

	* doc/howto/ConfigurationTricks.html: Add recipe for using
	environment variable to achieve ServerRoot-like functionality.

2013-10-06  castaglia <castaglia>

	* doc/howto/Filters.html: Add recipe about filtering SITE CHMOD
	parameters using DenyFilter to doc.  Fixed links to be relative.

2013-10-06  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Config/DenyFilter.pm: Added regression
	test show how to use DenyFilter to prevent a SITE CHMOD command that
	uses mode 777.

2013-10-06  castaglia <castaglia>

	* src/dirtree.c: Fixed bug in the handling of
	AllowFilter/DenyFilter, where a non-match would result in a false
	positive, such that a command might be allowed (when it should not
	be), or denied when it should be allowed.

2013-10-06  castaglia <castaglia>

	* src/var.c: Clean up minor stylistic nits in the Variables API; no
	real functional change.

2013-10-05  castaglia <castaglia>

	* src/fsio.c: Additional improvements for Bug#3963, reducing the
	scope of root privs used when setting created directory permissions.

2013-10-05  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_exec.pm: Updated mod_exec
	ExecOption useStdin regression test in light of Bug#3981.

2013-10-05  castaglia <castaglia>

	* NEWS, contrib/mod_exec.c: Bug#3981 - Null pointer dereference in
	mod_exec with ExecOption useStdin.

2013-10-05  castaglia <castaglia>

	* contrib/mod_sftp/fxp.c: When constructing the string version of
	unsupported OPEN flags sent by the SFTP client, make sure we are
	checking the correct flags variable.

2013-10-05  castaglia <castaglia>

	* tests/t/lib/ProFTPD/TestSuite/Utils.pm: Support writing out of
	configs that are given as arrayrefs, not just as hashrefs.

2013-10-05  castaglia <castaglia>

	* tests/t/config/setenv.t,
	tests/t/lib/ProFTPD/Tests/Config/SetEnv.pm, tests/tests.pl: Adding
	regression test for the SetEnv directive.  In this case, the test
	also demonstrates how environment variables can be used to
	approximate the functionality of Apache's ServerRoot directive.

2013-10-05  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_ratio.pm: Add a (currently
	failing) mod_ratio regression, found in an Ubuntu bug report.

2013-10-03  castaglia <castaglia>

	* doc/contrib/mod_ratio.html: Start working on mod_ratio docs, if
	only to cut down on bug reports about it.

2013-10-03  castaglia <castaglia>

	* doc/contrib/mod_sftp_pam.html: Fix typos and improve the
	installation instructions for mod_sftp_pam.

2013-10-02  castaglia <castaglia>

	* modules/mod_dso.c: Update mod_dso to use the pr_strnrstr()
	function, which duplicated code already in mod_dso.

2013-10-02  castaglia <castaglia>

	* RELEASE_NOTES: Plan to release RC4, and mention the fixing of the
	LDFLAGS for module builds.

2013-10-02  castaglia <castaglia>

	* contrib/mod_dnsbl/configure, contrib/mod_load/configure,
	contrib/mod_sftp/configure, contrib/mod_snmp/configure,
	contrib/mod_wrap2/configure: Updated contrib module configure
	scripts.

2013-10-02  castaglia <castaglia>

	* contrib/mod_dnsbl/Makefile.in, contrib/mod_dnsbl/configure.in,
	contrib/mod_load/Makefile.in, contrib/mod_load/configure.in,
	contrib/mod_sftp/Makefile.in, contrib/mod_sftp/configure.in,
	contrib/mod_snmp/Makefile.in, contrib/mod_snmp/configure.in,
	contrib/mod_wrap2/Makefile.in, contrib/mod_wrap2/configure.in: 
	Properly propagate/use LDFLAGS in the contrib module Makefiles.

2013-10-02  castaglia <castaglia>

	* contrib/mod_sftp/kex.c: Even when SSH2 clients do not send a
	"guess" KEX packet, but do correctly guess the preferred kex, we
	need to be prepared to handle ECDH key exchanges.

2013-10-01  castaglia <castaglia>

	* modules/mod_auth_unix.c: Fix typo in patch for Bug#3952 that was
	resulting in segfault.

2013-10-01  castaglia <castaglia>

	* contrib/mod_exec.c: Remove extraneous semicolon; I've been trying
	not to use them after the PRIVS macros.

2013-09-30  castaglia <castaglia>

	* contrib/mod_exec.c, contrib/mod_sql.c, modules/mod_log.c,
	modules/mod_xfer.c, src/dirtree.c, tests/api/cmd.c,
	tests/api/stubs.c: Deprecate get_full_cmd() in favor of
	pr_cmd_get_displayable_str(); both are existing functions, and the
	latter is more performant.

2013-09-30  castaglia <castaglia>

	* contrib/mod_sftp/mod_sftp.c: Make sure that ECC key exchange
	algorithms can be explicitly configured via the SFTPKeyExchanges
	directive, when supported.

2013-09-29  castaglia <castaglia>

	* doc/modules/mod_auth_unix.html: Updated PersistentPasswd docs per
	Bug#3952.

2013-09-29  castaglia <castaglia>

	* NEWS, RELEASE_NOTES, include/options.h, modules/mod_auth_file.c,
	modules/mod_auth_unix.c, src/main.c: Bug#3952 - Make
	PersistentPasswd default to 'off'.

2013-09-27  castaglia <castaglia>

	* src/netaddr.c: Include the address family (IPv4 vs IPv6) to which
	we tried (and failed) to resolve the given name, in the
	failed-resolution log message.

2013-09-27  castaglia <castaglia>

	* src/bindings.c: Only return an error from
	pr_ipbind_get_listening_conn(), if we fail to duplicate an address,
	for a reason other than EINVAL.  Turns out that EINVAL is actually
	an expected/common reason for the dup to fail.

2013-09-27  castaglia <castaglia>

	* src/bindings.c, src/dirtree.c, src/inet.c, src/netaddr.c: Fix an
	interesting bug only encountered if the following config is used:   DefaultAddress <ipv6-addr>   UseIPv6 off That is, the server is configured with an IPv6 address, and then
	later, in the config, support for IPv6 is disabled.  Without this
	patch, a strange segfault will ensue on startup.  Note that if the order of the directives is reversed, so that
	UseIPv6 occurs before the DefaultAddress directive, then startup
	fails as one might expect, since the IPv6 address won't be resolved
	unless IPv6 support is enabled.

2013-09-25  castaglia <castaglia>

	* contrib/mod_sftp/display.c, src/display.c: Silly compilers
	disagree on whether '' is valid syntax for denoting a single
	character.  Sigh.

2013-09-25  castaglia <castaglia>

	* contrib/mod_sftp/display.c, src/display.c: When formatting the %f
	Display variable, the units index was not being calculated
	correctly.

2013-09-25  castaglia <castaglia>

	* src/fsio.c: Minor clarifying comment.

2013-09-25  castaglia <castaglia>

	* NEWS, contrib/mod_sql_odbc.c: Bug#3979 - mod_sql_odbc compiler
	warnings on 64-bit systems using unixODBC.

2013-09-24  castaglia <castaglia>

	* include/str.h, src/str.c, tests/api/str.c, tests/api/timers.c: Add
	new pr_strnrstr() function, for checking whether a given string ends
	with a given suffix.  Comes with accompanying API tests.  Fixed a few racy timer tests while there.

2013-09-20  castaglia <castaglia>

	* contrib/mod_sftp/keys.c, contrib/mod_tls.c: Updated the cached
	PID, so that log messages reflected the forked process' PID
	properly.

2013-09-20  castaglia <castaglia>

	* contrib/mod_exec.c: Make sure we revoke root privs, even if we
	already hae the session.login_uid, when the '~' ExecOnEvent syntax
	is used.

2013-09-20  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Modules/mod_exec.pm: Adding regression
	test for Bug#3964.

2013-09-20  castaglia <castaglia>

	* NEWS, RELEASE_NOTES, contrib/mod_exec.c: Bug#3964 - Support
	running ExecOnEvent actions with logged-in user's permissions.

2013-09-20  castaglia <castaglia>

	* NEWS, contrib/mod_geoip.c: Bug#3976 - ProFTPD terminating (signal
	11) crash for GeoLiteCity-20130903 database lookup.

2013-09-20  castaglia <castaglia>

	* NEWS, contrib/mod_geoip.c: Bug#3975 - Error printed to stderr when
	loading GeoIP Lite country database using IndexCache flag.

2013-09-19  castaglia <castaglia>

	* include/netio.h, src/netio.c: Include not only the module pointer,
	but a stringified version of the module name.  The module pointer of
	the owner may not be available for comparison (think shared/DSO
	modules), so having the string is a nice complement.

2013-09-19  castaglia <castaglia>

	* contrib/mod_deflate.c, contrib/mod_tls.c, include/conf.h,
	include/netio.h, src/netio.c: Add new pr_alloc_netio2() function,
	for associate the module * with the netio created.  This allows
	modules to see, for a given pr_netio_t, which module registered/owns
	that netio.  And, related, add a new pr_get_netio() function, so that modules can
	see the currently registered NetIO object for a given stream type.
	With the above module * now part of that NetIO, said modules can see
	what is registered, and take appropriate action.

2013-09-18  castaglia <castaglia>

	* NEWS, src/fsio.c: Bug#3963 - Improve permission setting when
	creating directories.

2013-09-18  castaglia <castaglia>

	* doc/contrib/index.html: Update contrib module index with link to
	mod_dnsbl.

2013-09-18  castaglia <castaglia>

	* contrib/mod_dnsbl/configure: Updated configure for mod_dnsbl.

2013-09-18  castaglia <castaglia>

	* contrib/mod_dnsbl/Makefile.in, contrib/mod_dnsbl/configure.in,
	contrib/mod_dnsbl/mod_dnsbl.h.in: Tweaking the mod_dnsbl build
	system to use the module-libs.txt file, for e.g. building properly
	as a static module when libresolv is needed.

2013-09-18  castaglia <castaglia>

	* contrib/mod_dnsbl/.cvsignore: Adding necessary .cvsignore file.

2013-09-18  castaglia <castaglia>

	* contrib/mod_dnsbl/Makefile.in: Update clean target for mod_dnsbl
	Makefile.

2013-09-18  castaglia <castaglia>

	* RELEASE_NOTES, doc/contrib/mod_dnsbl.html: Mention addition of
	mod_dnsbl to the contrib/ area.

2013-09-18  castaglia <castaglia>

	* contrib/mod_dnsbl/Makefile.in, contrib/mod_dnsbl/config.guess,
	contrib/mod_dnsbl/config.sub, contrib/mod_dnsbl/configure,
	contrib/mod_dnsbl/configure.in, contrib/mod_dnsbl/install-sh,
	contrib/mod_dnsbl/mod_dnsbl.c, contrib/mod_dnsbl/mod_dnsbl.h.in: 
	Adding the mod_dnsbl module to the proftpd project.

2013-09-18  castaglia <castaglia>

	* contrib/mod_snmp/config.guess, contrib/mod_snmp/config.sub,
	contrib/mod_snmp/install-sh: Updating config.guess, config.sub,
	install-sh scripts for mod_snmp.

2013-09-18  castaglia <castaglia>

	* tests/t/lib/ProFTPD/Tests/Logging/ExtendedLog.pm: Add ExtendedLog
	test for the %r LogFormat variable, for commands other than PASS.
	Fixed broken mod_sftp test.

2013-09-18  castaglia <castaglia>

	* contrib/mod_sftp/fxp.c: Using a slightly different memory pool
	here avoids some strange side-effects later.

2013-09-17  castaglia <castaglia>

